// Compiled by ClojureScript 1.9.293 {:target :nodejs}
goog.provide('eginez.calvin.core');
goog.require('cljs.core');
goog.require('eginez.huckleberry.core');
goog.require('cljs.pprint');
goog.require('cljs.core.async');
goog.require('cljs.tools.cli');
goog.require('cljs.nodejs');
goog.require('clojure.string');
goog.require('cljs.reader');
eginez.calvin.core.fs = cljs.nodejs.require.call(null,"fs");
eginez.calvin.core.npath = cljs.nodejs.require.call(null,"path");
eginez.calvin.core.nchild = cljs.nodejs.require.call(null,"child_process");
eginez.calvin.core.nproc = cljs.nodejs.require.call(null,"process");
eginez.calvin.core.find_file = (function eginez$calvin$core$find_file(fpath){
var files = eginez.calvin.core.fs.readdirSync(fpath);
var fname = cljs.core.first.call(null,cljs.core.filter.call(null,((function (files){
return (function (p1__18721_SHARP_){
return clojure.string.includes_QMARK_.call(null,p1__18721_SHARP_,"project.clj");
});})(files))
,files));
return eginez.calvin.core.npath.join(fpath,fname);
});
eginez.calvin.core.samedep_QMARK_ = (function eginez$calvin$core$samedep_QMARK_(dep1,dep2){
return (cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"artifact","artifact",610074681).cljs$core$IFn$_invoke$arity$1(dep1),new cljs.core.Keyword(null,"artifact","artifact",610074681).cljs$core$IFn$_invoke$arity$1(dep2))) && (cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"version","version",425292698).cljs$core$IFn$_invoke$arity$1(dep1),new cljs.core.Keyword(null,"version","version",425292698).cljs$core$IFn$_invoke$arity$1(dep2))) && (cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"group","group",582596132).cljs$core$IFn$_invoke$arity$1(dep1),new cljs.core.Keyword(null,"group","group",582596132).cljs$core$IFn$_invoke$arity$1(dep2)));
});
eginez.calvin.core.load_content = (function eginez$calvin$core$load_content(file){
return eginez.calvin.core.fs.readFileSync(file).toString();
});
eginez.calvin.core.find_lein_dependencies = (function eginez$calvin$core$find_lein_dependencies(lein_project_file){
var content = eginez.calvin.core.load_content.call(null,lein_project_file);
var rcontent = cljs.reader.read_string.call(null,content);
var vec__18726 = rcontent;
var seq__18727 = cljs.core.seq.call(null,vec__18726);
var first__18728 = cljs.core.first.call(null,seq__18727);
var seq__18727__$1 = cljs.core.next.call(null,seq__18727);
var _ = first__18728;
var first__18728__$1 = cljs.core.first.call(null,seq__18727__$1);
var seq__18727__$2 = cljs.core.next.call(null,seq__18727__$1);
var name = first__18728__$1;
var first__18728__$2 = cljs.core.first.call(null,seq__18727__$2);
var seq__18727__$3 = cljs.core.next.call(null,seq__18727__$2);
var version = first__18728__$2;
var opts = seq__18727__$3;
var lopts = cljs.core.partition.call(null,(2),opts);
var mapopts = cljs.core.map.call(null,((function (content,rcontent,vec__18726,seq__18727,first__18728,seq__18727__$1,_,first__18728__$1,seq__18727__$2,name,first__18728__$2,seq__18727__$3,version,opts,lopts){
return (function (p1__18722_SHARP_){
return cljs.core.assoc.call(null,cljs.core.PersistentArrayMap.EMPTY,cljs.core.first.call(null,p1__18722_SHARP_),cljs.core.second.call(null,p1__18722_SHARP_));
});})(content,rcontent,vec__18726,seq__18727,first__18728,seq__18727__$1,_,first__18728__$1,seq__18727__$2,name,first__18728__$2,seq__18727__$3,version,opts,lopts))
,lopts);
var ret = cljs.core.reduce.call(null,cljs.core.merge,mapopts);
return ret;
});
eginez.calvin.core.resolve_dependencies = (function eginez$calvin$core$resolve_dependencies(coordinates,retrieve){
var dp = eginez.huckleberry.core.resolve_dependencies.call(null,new cljs.core.Keyword(null,"coordinates","coordinates",-1225332668),coordinates,new cljs.core.Keyword(null,"local-repo","local-repo",764410280),new cljs.core.Keyword(null,"local","local",-1497766724).cljs$core$IFn$_invoke$arity$1(eginez.huckleberry.core.default_repos),new cljs.core.Keyword(null,"retrieve","retrieve",-657129560),retrieve);
return dp;
});
eginez.calvin.core.resolve_classpath = (function eginez$calvin$core$resolve_classpath(path_to_project){
var c__13923__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13923__auto__){
return (function (){
var f__13924__auto__ = (function (){var switch__13908__auto__ = ((function (c__13923__auto__){
return (function (state_18756){
var state_val_18757 = (state_18756[(1)]);
if((state_val_18757 === (1))){
var inst_18747 = eginez.calvin.core.find_file.call(null,path_to_project);
var inst_18748 = eginez.calvin.core.find_lein_dependencies.call(null,inst_18747);
var inst_18749 = new cljs.core.Keyword(null,"dependencies","dependencies",1108064605).cljs$core$IFn$_invoke$arity$1(inst_18748);
var inst_18750 = eginez.calvin.core.resolve_dependencies.call(null,inst_18749,true);
var state_18756__$1 = state_18756;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_18756__$1,(2),inst_18750);
} else {
if((state_val_18757 === (2))){
var inst_18752 = (state_18756[(2)]);
var inst_18753 = cljs.core.map.call(null,eginez.huckleberry.core.dep__GT_path,inst_18752);
var inst_18754 = clojure.string.join.call(null,":",inst_18753);
var state_18756__$1 = state_18756;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_18756__$1,inst_18754);
} else {
return null;
}
}
});})(c__13923__auto__))
;
return ((function (switch__13908__auto__,c__13923__auto__){
return (function() {
var eginez$calvin$core$resolve_classpath_$_state_machine__13909__auto__ = null;
var eginez$calvin$core$resolve_classpath_$_state_machine__13909__auto____0 = (function (){
var statearr_18761 = [null,null,null,null,null,null,null];
(statearr_18761[(0)] = eginez$calvin$core$resolve_classpath_$_state_machine__13909__auto__);

(statearr_18761[(1)] = (1));

return statearr_18761;
});
var eginez$calvin$core$resolve_classpath_$_state_machine__13909__auto____1 = (function (state_18756){
while(true){
var ret_value__13910__auto__ = (function (){try{while(true){
var result__13911__auto__ = switch__13908__auto__.call(null,state_18756);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13911__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13911__auto__;
}
break;
}
}catch (e18762){if((e18762 instanceof Object)){
var ex__13912__auto__ = e18762;
var statearr_18763_18765 = state_18756;
(statearr_18763_18765[(5)] = ex__13912__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_18756);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e18762;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13910__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__18766 = state_18756;
state_18756 = G__18766;
continue;
} else {
return ret_value__13910__auto__;
}
break;
}
});
eginez$calvin$core$resolve_classpath_$_state_machine__13909__auto__ = function(state_18756){
switch(arguments.length){
case 0:
return eginez$calvin$core$resolve_classpath_$_state_machine__13909__auto____0.call(this);
case 1:
return eginez$calvin$core$resolve_classpath_$_state_machine__13909__auto____1.call(this,state_18756);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
eginez$calvin$core$resolve_classpath_$_state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$0 = eginez$calvin$core$resolve_classpath_$_state_machine__13909__auto____0;
eginez$calvin$core$resolve_classpath_$_state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$1 = eginez$calvin$core$resolve_classpath_$_state_machine__13909__auto____1;
return eginez$calvin$core$resolve_classpath_$_state_machine__13909__auto__;
})()
;})(switch__13908__auto__,c__13923__auto__))
})();
var state__13925__auto__ = (function (){var statearr_18764 = f__13924__auto__.call(null);
(statearr_18764[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13923__auto__);

return statearr_18764;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13925__auto__);
});})(c__13923__auto__))
);

return c__13923__auto__;
});
eginez.calvin.core.print_dep_tree = (function eginez$calvin$core$print_dep_tree(root,graph,depth){
var art = cljs.core.first.call(null,cljs.core.filter.call(null,(function (p1__18767_SHARP_){
return eginez.calvin.core.samedep_QMARK_.call(null,root,p1__18767_SHARP_);
}),cljs.core.keys.call(null,graph)));
var deps = cljs.core.get.call(null,graph,art);
cljs.core.println.call(null,clojure.string.join.call(null,cljs.core.concat.call(null,cljs.core.repeat.call(null,depth,"*"),">")),eginez.huckleberry.core.dep__GT_coordinate.call(null,art));

if(cljs.core.truth_(cljs.core.not_empty.call(null,deps))){
var seq__18772 = cljs.core.seq.call(null,deps);
var chunk__18773 = null;
var count__18774 = (0);
var i__18775 = (0);
while(true){
if((i__18775 < count__18774)){
var n = cljs.core._nth.call(null,chunk__18773,i__18775);
eginez.calvin.core.print_dep_tree.call(null,n,graph,(depth + (1)));

var G__18776 = seq__18772;
var G__18777 = chunk__18773;
var G__18778 = count__18774;
var G__18779 = (i__18775 + (1));
seq__18772 = G__18776;
chunk__18773 = G__18777;
count__18774 = G__18778;
i__18775 = G__18779;
continue;
} else {
var temp__4657__auto__ = cljs.core.seq.call(null,seq__18772);
if(temp__4657__auto__){
var seq__18772__$1 = temp__4657__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__18772__$1)){
var c__7357__auto__ = cljs.core.chunk_first.call(null,seq__18772__$1);
var G__18780 = cljs.core.chunk_rest.call(null,seq__18772__$1);
var G__18781 = c__7357__auto__;
var G__18782 = cljs.core.count.call(null,c__7357__auto__);
var G__18783 = (0);
seq__18772 = G__18780;
chunk__18773 = G__18781;
count__18774 = G__18782;
i__18775 = G__18783;
continue;
} else {
var n = cljs.core.first.call(null,seq__18772__$1);
eginez.calvin.core.print_dep_tree.call(null,n,graph,(depth + (1)));

var G__18784 = cljs.core.next.call(null,seq__18772__$1);
var G__18785 = null;
var G__18786 = (0);
var G__18787 = (0);
seq__18772 = G__18784;
chunk__18773 = G__18785;
count__18774 = G__18786;
i__18775 = G__18787;
continue;
}
} else {
return null;
}
}
break;
}
} else {
return null;
}
});
eginez.calvin.core.show_all_deps = (function eginez$calvin$core$show_all_deps(graph){
while(true){
if(cljs.core.truth_(cljs.core.not_empty.call(null,graph))){
var root = cljs.core.dissoc.call(null,cljs.core.first.call(null,graph),new cljs.core.Keyword(null,"exclusions","exclusions",1098729003));
var dg = cljs.core.second.call(null,graph);
var vec__18792 = cljs.core.filter.call(null,((function (graph,root,dg){
return (function (p1__18788_SHARP_){
return eginez.calvin.core.samedep_QMARK_.call(null,root,p1__18788_SHARP_);
});})(graph,root,dg))
,cljs.core.keys.call(null,dg));
var seq__18793 = cljs.core.seq.call(null,vec__18792);
var first__18794 = cljs.core.first.call(null,seq__18793);
var seq__18793__$1 = cljs.core.next.call(null,seq__18793);
var head_dep = first__18794;
var _ = seq__18793__$1;
cljs.core.println.call(null);

eginez.calvin.core.print_dep_tree.call(null,head_dep,dg,(0));

var G__18795 = cljs.core.drop.call(null,(2),graph);
graph = G__18795;
continue;
} else {
return null;
}
break;
}
});
eginez.calvin.core.show_deps = (function eginez$calvin$core$show_deps(){
var c__13923__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13923__auto__){
return (function (){
var f__13924__auto__ = (function (){var switch__13908__auto__ = ((function (c__13923__auto__){
return (function (state_18864){
var state_val_18865 = (state_18864[(1)]);
if((state_val_18865 === (1))){
var inst_18845 = (state_18864[(7)]);
var inst_18846 = (state_18864[(8)]);
var inst_18843 = (state_18864[(9)]);
var inst_18836 = cljs.core.println.call(null,"Calculating dependencies");
var inst_18843__$1 = eginez.calvin.core.nproc.cwd();
var inst_18844 = eginez.calvin.core.find_file.call(null,inst_18843__$1);
var inst_18845__$1 = eginez.calvin.core.find_lein_dependencies.call(null,inst_18844);
var inst_18846__$1 = new cljs.core.Keyword(null,"dependencies","dependencies",1108064605).cljs$core$IFn$_invoke$arity$1(inst_18845__$1);
var inst_18847 = eginez.calvin.core.resolve_dependencies.call(null,inst_18846__$1,false);
var state_18864__$1 = (function (){var statearr_18866 = state_18864;
(statearr_18866[(7)] = inst_18845__$1);

(statearr_18866[(8)] = inst_18846__$1);

(statearr_18866[(10)] = inst_18836);

(statearr_18866[(9)] = inst_18843__$1);

return statearr_18866;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_18864__$1,(2),inst_18847);
} else {
if((state_val_18865 === (2))){
var inst_18845 = (state_18864[(7)]);
var inst_18846 = (state_18864[(8)]);
var inst_18843 = (state_18864[(9)]);
var inst_18849 = (state_18864[(2)]);
var inst_18850 = cljs.core.nth.call(null,inst_18849,(0),null);
var inst_18851 = cljs.core.nth.call(null,inst_18849,(1),null);
var inst_18852 = cljs.core.nth.call(null,inst_18849,(2),null);
var inst_18853 = cljs.core.first.call(null,inst_18851);
var inst_18854 = cljs.core.dissoc.call(null,inst_18853,new cljs.core.Keyword(null,"exclusions","exclusions",1098729003));
var inst_18855 = cljs.core.second.call(null,inst_18851);
var inst_18856 = (function (){var cwd = inst_18843;
var options = inst_18845;
var coordinates = inst_18846;
var vec__18837 = inst_18849;
var status = inst_18850;
var dep_graph = inst_18851;
var dep_list = inst_18852;
var root = inst_18854;
var dg = inst_18855;
return ((function (cwd,options,coordinates,vec__18837,status,dep_graph,dep_list,root,dg,inst_18845,inst_18846,inst_18843,inst_18849,inst_18850,inst_18851,inst_18852,inst_18853,inst_18854,inst_18855,state_val_18865,c__13923__auto__){
return (function (p1__18796_SHARP_){
return eginez.calvin.core.samedep_QMARK_.call(null,root,p1__18796_SHARP_);
});
;})(cwd,options,coordinates,vec__18837,status,dep_graph,dep_list,root,dg,inst_18845,inst_18846,inst_18843,inst_18849,inst_18850,inst_18851,inst_18852,inst_18853,inst_18854,inst_18855,state_val_18865,c__13923__auto__))
})();
var inst_18857 = cljs.core.keys.call(null,inst_18855);
var inst_18858 = cljs.core.filter.call(null,inst_18856,inst_18857);
var inst_18859 = cljs.core.seq.call(null,inst_18858);
var inst_18860 = cljs.core.first.call(null,inst_18859);
var inst_18861 = cljs.core.next.call(null,inst_18859);
var inst_18862 = eginez.calvin.core.show_all_deps.call(null,inst_18851);
var state_18864__$1 = (function (){var statearr_18867 = state_18864;
(statearr_18867[(11)] = inst_18860);

(statearr_18867[(12)] = inst_18861);

return statearr_18867;
})();
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_18864__$1,inst_18862);
} else {
return null;
}
}
});})(c__13923__auto__))
;
return ((function (switch__13908__auto__,c__13923__auto__){
return (function() {
var eginez$calvin$core$show_deps_$_state_machine__13909__auto__ = null;
var eginez$calvin$core$show_deps_$_state_machine__13909__auto____0 = (function (){
var statearr_18871 = [null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_18871[(0)] = eginez$calvin$core$show_deps_$_state_machine__13909__auto__);

(statearr_18871[(1)] = (1));

return statearr_18871;
});
var eginez$calvin$core$show_deps_$_state_machine__13909__auto____1 = (function (state_18864){
while(true){
var ret_value__13910__auto__ = (function (){try{while(true){
var result__13911__auto__ = switch__13908__auto__.call(null,state_18864);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13911__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13911__auto__;
}
break;
}
}catch (e18872){if((e18872 instanceof Object)){
var ex__13912__auto__ = e18872;
var statearr_18873_18875 = state_18864;
(statearr_18873_18875[(5)] = ex__13912__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_18864);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e18872;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13910__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__18876 = state_18864;
state_18864 = G__18876;
continue;
} else {
return ret_value__13910__auto__;
}
break;
}
});
eginez$calvin$core$show_deps_$_state_machine__13909__auto__ = function(state_18864){
switch(arguments.length){
case 0:
return eginez$calvin$core$show_deps_$_state_machine__13909__auto____0.call(this);
case 1:
return eginez$calvin$core$show_deps_$_state_machine__13909__auto____1.call(this,state_18864);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
eginez$calvin$core$show_deps_$_state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$0 = eginez$calvin$core$show_deps_$_state_machine__13909__auto____0;
eginez$calvin$core$show_deps_$_state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$1 = eginez$calvin$core$show_deps_$_state_machine__13909__auto____1;
return eginez$calvin$core$show_deps_$_state_machine__13909__auto__;
})()
;})(switch__13908__auto__,c__13923__auto__))
})();
var state__13925__auto__ = (function (){var statearr_18874 = f__13924__auto__.call(null);
(statearr_18874[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13923__auto__);

return statearr_18874;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13925__auto__);
});})(c__13923__auto__))
);

return c__13923__auto__;
});
eginez.calvin.core.build_cmd_for_platform = (function eginez$calvin$core$build_cmd_for_platform(platform,classpath){
var G__18878 = platform;
switch (G__18878) {
case "lumo":
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, ["lumo",new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, ["-c",classpath], null)], null);

break;
case "planck":
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, ["planck",new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, ["-c",classpath], null)], null);

break;
default:
throw (new Error([cljs.core.str("No matching clause: "),cljs.core.str(platform)].join('')));

}
});
eginez.calvin.core.run_repl = (function eginez$calvin$core$run_repl(platform){
var c__13923__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13923__auto__){
return (function (){
var f__13924__auto__ = (function (){var switch__13908__auto__ = ((function (c__13923__auto__){
return (function (state_18929){
var state_val_18930 = (state_18929[(1)]);
if((state_val_18930 === (1))){
var inst_18912 = eginez.calvin.core.nproc.cwd();
var inst_18913 = eginez.calvin.core.resolve_classpath.call(null,inst_18912);
var state_18929__$1 = state_18929;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_18929__$1,(2),inst_18913);
} else {
if((state_val_18930 === (2))){
var inst_18915 = (state_18929[(2)]);
var inst_18916 = eginez.calvin.core.build_cmd_for_platform.call(null,platform,inst_18915);
var inst_18917 = cljs.core.nth.call(null,inst_18916,(0),null);
var inst_18918 = cljs.core.nth.call(null,inst_18916,(1),null);
var inst_18919 = cljs.core.clj__GT_js.call(null,inst_18918);
var inst_18920 = [new cljs.core.Keyword(null,"stdio","stdio",-1570777132)];
var inst_18921 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_18922 = [(0),(1),(2)];
var inst_18923 = (new cljs.core.PersistentVector(null,3,(5),inst_18921,inst_18922,null));
var inst_18924 = [inst_18923];
var inst_18925 = cljs.core.PersistentHashMap.fromArrays(inst_18920,inst_18924);
var inst_18926 = cljs.core.clj__GT_js.call(null,inst_18925);
var inst_18927 = eginez.calvin.core.nchild.spawn(inst_18917,inst_18919,inst_18926);
var state_18929__$1 = state_18929;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_18929__$1,inst_18927);
} else {
return null;
}
}
});})(c__13923__auto__))
;
return ((function (switch__13908__auto__,c__13923__auto__){
return (function() {
var eginez$calvin$core$run_repl_$_state_machine__13909__auto__ = null;
var eginez$calvin$core$run_repl_$_state_machine__13909__auto____0 = (function (){
var statearr_18934 = [null,null,null,null,null,null,null];
(statearr_18934[(0)] = eginez$calvin$core$run_repl_$_state_machine__13909__auto__);

(statearr_18934[(1)] = (1));

return statearr_18934;
});
var eginez$calvin$core$run_repl_$_state_machine__13909__auto____1 = (function (state_18929){
while(true){
var ret_value__13910__auto__ = (function (){try{while(true){
var result__13911__auto__ = switch__13908__auto__.call(null,state_18929);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13911__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13911__auto__;
}
break;
}
}catch (e18935){if((e18935 instanceof Object)){
var ex__13912__auto__ = e18935;
var statearr_18936_18938 = state_18929;
(statearr_18936_18938[(5)] = ex__13912__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_18929);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e18935;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13910__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__18939 = state_18929;
state_18929 = G__18939;
continue;
} else {
return ret_value__13910__auto__;
}
break;
}
});
eginez$calvin$core$run_repl_$_state_machine__13909__auto__ = function(state_18929){
switch(arguments.length){
case 0:
return eginez$calvin$core$run_repl_$_state_machine__13909__auto____0.call(this);
case 1:
return eginez$calvin$core$run_repl_$_state_machine__13909__auto____1.call(this,state_18929);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
eginez$calvin$core$run_repl_$_state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$0 = eginez$calvin$core$run_repl_$_state_machine__13909__auto____0;
eginez$calvin$core$run_repl_$_state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$1 = eginez$calvin$core$run_repl_$_state_machine__13909__auto____1;
return eginez$calvin$core$run_repl_$_state_machine__13909__auto__;
})()
;})(switch__13908__auto__,c__13923__auto__))
})();
var state__13925__auto__ = (function (){var statearr_18937 = f__13924__auto__.call(null);
(statearr_18937[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13923__auto__);

return statearr_18937;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13925__auto__);
});})(c__13923__auto__))
);

return c__13923__auto__;
});
eginez.calvin.core.cli_options = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, ["-h","--help"], null),new cljs.core.PersistentVector(null, 5, 5, cljs.core.PersistentVector.EMPTY_NODE, ["-p","--platform PLATFORM","Either planck or lumo",new cljs.core.Keyword(null,"default","default",-1987822328),"lumo"], null)], null);
eginez.calvin.core.help = clojure.string.join.call(null,"\n",cljs.core.flatten.call(null,new cljs.core.PersistentVector(null, 7, 5, cljs.core.PersistentVector.EMPTY_NODE, ["Calvin a minimalistic build tool for clojurescript","Usage: calvin [options] args","Options:",cljs.core.map.call(null,(function (p1__18940_SHARP_){
return [cljs.core.str("\t"),cljs.core.str(clojure.string.join.call(null," ",cljs.core.take.call(null,(2),p1__18940_SHARP_)))].join('');
}),eginez.calvin.core.cli_options),"Arguments:","\tdeps Shows dependencies","\trepl Starts a repl using either lumo or planck"], null)));
eginez.calvin.core._main = (function eginez$calvin$core$_main(var_args){
var args__7658__auto__ = [];
var len__7651__auto___18945 = arguments.length;
var i__7652__auto___18946 = (0);
while(true){
if((i__7652__auto___18946 < len__7651__auto___18945)){
args__7658__auto__.push((arguments[i__7652__auto___18946]));

var G__18947 = (i__7652__auto___18946 + (1));
i__7652__auto___18946 = G__18947;
continue;
} else {
}
break;
}

var argseq__7659__auto__ = ((((0) < args__7658__auto__.length))?(new cljs.core.IndexedSeq(args__7658__auto__.slice((0)),(0),null)):null);
return eginez.calvin.core._main.cljs$core$IFn$_invoke$arity$variadic(argseq__7659__auto__);
});

eginez.calvin.core._main.cljs$core$IFn$_invoke$arity$variadic = (function (args){
var map__18942 = cljs.tools.cli.parse_opts.call(null,args,eginez.calvin.core.cli_options,new cljs.core.Keyword(null,"in-order","in-order",-1605651796),true);
var map__18942__$1 = ((((!((map__18942 == null)))?((((map__18942.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__18942.cljs$core$ISeq$)))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__18942):map__18942);
var options = cljs.core.get.call(null,map__18942__$1,new cljs.core.Keyword(null,"options","options",99638489));
var arguments$ = cljs.core.get.call(null,map__18942__$1,new cljs.core.Keyword(null,"arguments","arguments",-1182834456));
var errors = cljs.core.get.call(null,map__18942__$1,new cljs.core.Keyword(null,"errors","errors",-908790718));
var summ = cljs.core.get.call(null,map__18942__$1,new cljs.core.Keyword(null,"summ","summ",-1220398077));
var platform = new cljs.core.Keyword(null,"platform","platform",-1086422114).cljs$core$IFn$_invoke$arity$1(options);
var G__18944 = cljs.core.first.call(null,arguments$);
if(cljs.core._EQ_.call(null,"deps",G__18944)){
return eginez.calvin.core.show_deps.call(null);
} else {
if(cljs.core._EQ_.call(null,"repl",G__18944)){
return eginez.calvin.core.run_repl.call(null,platform);
} else {
if(cljs.core._EQ_.call(null,null,G__18944)){
return cljs.core.println.call(null,eginez.calvin.core.help);
} else {
throw (new Error([cljs.core.str("No matching clause: "),cljs.core.str(cljs.core.first.call(null,arguments$))].join('')));

}
}
}
});

eginez.calvin.core._main.cljs$lang$maxFixedArity = (0);

eginez.calvin.core._main.cljs$lang$applyTo = (function (seq18941){
return eginez.calvin.core._main.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq.call(null,seq18941));
});

cljs.nodejs.enable_util_print_BANG_.call(null);
cljs.core._STAR_main_cli_fn_STAR_ = eginez.calvin.core._main;
