// Compiled by ClojureScript 1.9.293 {:target :nodejs}
goog.provide('cljs.core.async');
goog.require('cljs.core');
goog.require('cljs.core.async.impl.channels');
goog.require('cljs.core.async.impl.dispatch');
goog.require('cljs.core.async.impl.ioc_helpers');
goog.require('cljs.core.async.impl.protocols');
goog.require('cljs.core.async.impl.buffers');
goog.require('cljs.core.async.impl.timers');
cljs.core.async.fn_handler = (function cljs$core$async$fn_handler(var_args){
var args13970 = [];
var len__7651__auto___13984 = arguments.length;
var i__7652__auto___13985 = (0);
while(true){
if((i__7652__auto___13985 < len__7651__auto___13984)){
args13970.push((arguments[i__7652__auto___13985]));

var G__13986 = (i__7652__auto___13985 + (1));
i__7652__auto___13985 = G__13986;
continue;
} else {
}
break;
}

var G__13976 = args13970.length;
switch (G__13976) {
case 1:
return cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args13970.length)].join('')));

}
});

cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1 = (function (f){
return cljs.core.async.fn_handler.call(null,f,true);
});

cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2 = (function (f,blockable){
if(typeof cljs.core.async.t_cljs$core$async13977 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async13977 = (function (f,blockable,meta13978){
this.f = f;
this.blockable = blockable;
this.meta13978 = meta13978;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async13977.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_13979,meta13978__$1){
var self__ = this;
var _13979__$1 = this;
return (new cljs.core.async.t_cljs$core$async13977(self__.f,self__.blockable,meta13978__$1));
});

cljs.core.async.t_cljs$core$async13977.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_13979){
var self__ = this;
var _13979__$1 = this;
return self__.meta13978;
});

cljs.core.async.t_cljs$core$async13977.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async13977.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return true;
});

cljs.core.async.t_cljs$core$async13977.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.blockable;
});

cljs.core.async.t_cljs$core$async13977.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.f;
});

cljs.core.async.t_cljs$core$async13977.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"blockable","blockable",-28395259,null),new cljs.core.Symbol(null,"meta13978","meta13978",427980054,null)], null);
});

cljs.core.async.t_cljs$core$async13977.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async13977.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async13977";

cljs.core.async.t_cljs$core$async13977.cljs$lang$ctorPrWriter = (function (this__7149__auto__,writer__7150__auto__,opt__7151__auto__){
return cljs.core._write.call(null,writer__7150__auto__,"cljs.core.async/t_cljs$core$async13977");
});

cljs.core.async.__GT_t_cljs$core$async13977 = (function cljs$core$async$__GT_t_cljs$core$async13977(f__$1,blockable__$1,meta13978){
return (new cljs.core.async.t_cljs$core$async13977(f__$1,blockable__$1,meta13978));
});

}

return (new cljs.core.async.t_cljs$core$async13977(f,blockable,cljs.core.PersistentArrayMap.EMPTY));
});

cljs.core.async.fn_handler.cljs$lang$maxFixedArity = 2;

/**
 * Returns a fixed buffer of size n. When full, puts will block/park.
 */
cljs.core.async.buffer = (function cljs$core$async$buffer(n){
return cljs.core.async.impl.buffers.fixed_buffer.call(null,n);
});
/**
 * Returns a buffer of size n. When full, puts will complete but
 *   val will be dropped (no transfer).
 */
cljs.core.async.dropping_buffer = (function cljs$core$async$dropping_buffer(n){
return cljs.core.async.impl.buffers.dropping_buffer.call(null,n);
});
/**
 * Returns a buffer of size n. When full, puts will complete, and be
 *   buffered, but oldest elements in buffer will be dropped (not
 *   transferred).
 */
cljs.core.async.sliding_buffer = (function cljs$core$async$sliding_buffer(n){
return cljs.core.async.impl.buffers.sliding_buffer.call(null,n);
});
/**
 * Returns true if a channel created with buff will never block. That is to say,
 * puts into this buffer will never cause the buffer to be full. 
 */
cljs.core.async.unblocking_buffer_QMARK_ = (function cljs$core$async$unblocking_buffer_QMARK_(buff){
if(!((buff == null))){
if((false) || ((cljs.core.PROTOCOL_SENTINEL === buff.cljs$core$async$impl$protocols$UnblockingBuffer$))){
return true;
} else {
if((!buff.cljs$lang$protocol_mask$partition$)){
return cljs.core.native_satisfies_QMARK_.call(null,cljs.core.async.impl.protocols.UnblockingBuffer,buff);
} else {
return false;
}
}
} else {
return cljs.core.native_satisfies_QMARK_.call(null,cljs.core.async.impl.protocols.UnblockingBuffer,buff);
}
});
/**
 * Creates a channel with an optional buffer, an optional transducer (like (map f),
 *   (filter p) etc or a composition thereof), and an optional exception handler.
 *   If buf-or-n is a number, will create and use a fixed buffer of that size. If a
 *   transducer is supplied a buffer must be specified. ex-handler must be a
 *   fn of one argument - if an exception occurs during transformation it will be called
 *   with the thrown value as an argument, and any non-nil return value will be placed
 *   in the channel.
 */
cljs.core.async.chan = (function cljs$core$async$chan(var_args){
var args14004 = [];
var len__7651__auto___14013 = arguments.length;
var i__7652__auto___14014 = (0);
while(true){
if((i__7652__auto___14014 < len__7651__auto___14013)){
args14004.push((arguments[i__7652__auto___14014]));

var G__14018 = (i__7652__auto___14014 + (1));
i__7652__auto___14014 = G__14018;
continue;
} else {
}
break;
}

var G__14006 = args14004.length;
switch (G__14006) {
case 0:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0();

break;
case 1:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args14004.length)].join('')));

}
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0 = (function (){
return cljs.core.async.chan.call(null,null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1 = (function (buf_or_n){
return cljs.core.async.chan.call(null,buf_or_n,null,null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$2 = (function (buf_or_n,xform){
return cljs.core.async.chan.call(null,buf_or_n,xform,null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3 = (function (buf_or_n,xform,ex_handler){
var buf_or_n__$1 = ((cljs.core._EQ_.call(null,buf_or_n,(0)))?null:buf_or_n);
if(cljs.core.truth_(xform)){
if(cljs.core.truth_(buf_or_n__$1)){
} else {
throw (new Error([cljs.core.str("Assert failed: "),cljs.core.str("buffer must be supplied when transducer is"),cljs.core.str("\n"),cljs.core.str("buf-or-n")].join('')));
}
} else {
}

return cljs.core.async.impl.channels.chan.call(null,((typeof buf_or_n__$1 === 'number')?cljs.core.async.buffer.call(null,buf_or_n__$1):buf_or_n__$1),xform,ex_handler);
});

cljs.core.async.chan.cljs$lang$maxFixedArity = 3;

/**
 * Creates a promise channel with an optional transducer, and an optional
 *   exception-handler. A promise channel can take exactly one value that consumers
 *   will receive. Once full, puts complete but val is dropped (no transfer).
 *   Consumers will block until either a value is placed in the channel or the
 *   channel is closed. See chan for the semantics of xform and ex-handler.
 */
cljs.core.async.promise_chan = (function cljs$core$async$promise_chan(var_args){
var args14034 = [];
var len__7651__auto___14055 = arguments.length;
var i__7652__auto___14062 = (0);
while(true){
if((i__7652__auto___14062 < len__7651__auto___14055)){
args14034.push((arguments[i__7652__auto___14062]));

var G__14063 = (i__7652__auto___14062 + (1));
i__7652__auto___14062 = G__14063;
continue;
} else {
}
break;
}

var G__14038 = args14034.length;
switch (G__14038) {
case 0:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0();

break;
case 1:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args14034.length)].join('')));

}
});

cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0 = (function (){
return cljs.core.async.promise_chan.call(null,null);
});

cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$1 = (function (xform){
return cljs.core.async.promise_chan.call(null,xform,null);
});

cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$2 = (function (xform,ex_handler){
return cljs.core.async.chan.call(null,cljs.core.async.impl.buffers.promise_buffer.call(null),xform,ex_handler);
});

cljs.core.async.promise_chan.cljs$lang$maxFixedArity = 2;

/**
 * Returns a channel that will close after msecs
 */
cljs.core.async.timeout = (function cljs$core$async$timeout(msecs){
return cljs.core.async.impl.timers.timeout.call(null,msecs);
});
/**
 * takes a val from port. Must be called inside a (go ...) block. Will
 *   return nil if closed. Will park if nothing is available.
 *   Returns true unless port is already closed
 */
cljs.core.async._LT__BANG_ = (function cljs$core$async$_LT__BANG_(port){
throw (new Error("<! used not in (go ...) block"));
});
/**
 * Asynchronously takes a val from port, passing to fn1. Will pass nil
 * if closed. If on-caller? (default true) is true, and value is
 * immediately available, will call fn1 on calling thread.
 * Returns nil.
 */
cljs.core.async.take_BANG_ = (function cljs$core$async$take_BANG_(var_args){
var args14115 = [];
var len__7651__auto___14146 = arguments.length;
var i__7652__auto___14147 = (0);
while(true){
if((i__7652__auto___14147 < len__7651__auto___14146)){
args14115.push((arguments[i__7652__auto___14147]));

var G__14154 = (i__7652__auto___14147 + (1));
i__7652__auto___14147 = G__14154;
continue;
} else {
}
break;
}

var G__14133 = args14115.length;
switch (G__14133) {
case 2:
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args14115.length)].join('')));

}
});

cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (port,fn1){
return cljs.core.async.take_BANG_.call(null,port,fn1,true);
});

cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3 = (function (port,fn1,on_caller_QMARK_){
var ret = cljs.core.async.impl.protocols.take_BANG_.call(null,port,cljs.core.async.fn_handler.call(null,fn1));
if(cljs.core.truth_(ret)){
var val_14162 = cljs.core.deref.call(null,ret);
if(cljs.core.truth_(on_caller_QMARK_)){
fn1.call(null,val_14162);
} else {
cljs.core.async.impl.dispatch.run.call(null,((function (val_14162,ret){
return (function (){
return fn1.call(null,val_14162);
});})(val_14162,ret))
);
}
} else {
}

return null;
});

cljs.core.async.take_BANG_.cljs$lang$maxFixedArity = 3;

cljs.core.async.nop = (function cljs$core$async$nop(_){
return null;
});
cljs.core.async.fhnop = cljs.core.async.fn_handler.call(null,cljs.core.async.nop);
/**
 * puts a val into port. nil values are not allowed. Must be called
 *   inside a (go ...) block. Will park if no buffer space is available.
 *   Returns true unless port is already closed.
 */
cljs.core.async._GT__BANG_ = (function cljs$core$async$_GT__BANG_(port,val){
throw (new Error(">! used not in (go ...) block"));
});
/**
 * Asynchronously puts a val into port, calling fn0 (if supplied) when
 * complete. nil values are not allowed. Will throw if closed. If
 * on-caller? (default true) is true, and the put is immediately
 * accepted, will call fn0 on calling thread.  Returns nil.
 */
cljs.core.async.put_BANG_ = (function cljs$core$async$put_BANG_(var_args){
var args14164 = [];
var len__7651__auto___14167 = arguments.length;
var i__7652__auto___14168 = (0);
while(true){
if((i__7652__auto___14168 < len__7651__auto___14167)){
args14164.push((arguments[i__7652__auto___14168]));

var G__14170 = (i__7652__auto___14168 + (1));
i__7652__auto___14168 = G__14170;
continue;
} else {
}
break;
}

var G__14166 = args14164.length;
switch (G__14166) {
case 2:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args14164.length)].join('')));

}
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (port,val){
var temp__4655__auto__ = cljs.core.async.impl.protocols.put_BANG_.call(null,port,val,cljs.core.async.fhnop);
if(cljs.core.truth_(temp__4655__auto__)){
var ret = temp__4655__auto__;
return cljs.core.deref.call(null,ret);
} else {
return true;
}
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3 = (function (port,val,fn1){
return cljs.core.async.put_BANG_.call(null,port,val,fn1,true);
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4 = (function (port,val,fn1,on_caller_QMARK_){
var temp__4655__auto__ = cljs.core.async.impl.protocols.put_BANG_.call(null,port,val,cljs.core.async.fn_handler.call(null,fn1));
if(cljs.core.truth_(temp__4655__auto__)){
var retb = temp__4655__auto__;
var ret = cljs.core.deref.call(null,retb);
if(cljs.core.truth_(on_caller_QMARK_)){
fn1.call(null,ret);
} else {
cljs.core.async.impl.dispatch.run.call(null,((function (ret,retb,temp__4655__auto__){
return (function (){
return fn1.call(null,ret);
});})(ret,retb,temp__4655__auto__))
);
}

return ret;
} else {
return true;
}
});

cljs.core.async.put_BANG_.cljs$lang$maxFixedArity = 4;

cljs.core.async.close_BANG_ = (function cljs$core$async$close_BANG_(port){
return cljs.core.async.impl.protocols.close_BANG_.call(null,port);
});
cljs.core.async.random_array = (function cljs$core$async$random_array(n){
var a = (new Array(n));
var n__7461__auto___14198 = n;
var x_14199 = (0);
while(true){
if((x_14199 < n__7461__auto___14198)){
(a[x_14199] = (0));

var G__14200 = (x_14199 + (1));
x_14199 = G__14200;
continue;
} else {
}
break;
}

var i = (1);
while(true){
if(cljs.core._EQ_.call(null,i,n)){
return a;
} else {
var j = cljs.core.rand_int.call(null,i);
(a[i] = (a[j]));

(a[j] = i);

var G__14207 = (i + (1));
i = G__14207;
continue;
}
break;
}
});
cljs.core.async.alt_flag = (function cljs$core$async$alt_flag(){
var flag = cljs.core.atom.call(null,true);
if(typeof cljs.core.async.t_cljs$core$async14212 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async14212 = (function (flag,meta14213){
this.flag = flag;
this.meta14213 = meta14213;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async14212.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (flag){
return (function (_14214,meta14213__$1){
var self__ = this;
var _14214__$1 = this;
return (new cljs.core.async.t_cljs$core$async14212(self__.flag,meta14213__$1));
});})(flag))
;

cljs.core.async.t_cljs$core$async14212.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (flag){
return (function (_14214){
var self__ = this;
var _14214__$1 = this;
return self__.meta14213;
});})(flag))
;

cljs.core.async.t_cljs$core$async14212.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async14212.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = ((function (flag){
return (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.deref.call(null,self__.flag);
});})(flag))
;

cljs.core.async.t_cljs$core$async14212.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = ((function (flag){
return (function (_){
var self__ = this;
var ___$1 = this;
return true;
});})(flag))
;

cljs.core.async.t_cljs$core$async14212.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = ((function (flag){
return (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.reset_BANG_.call(null,self__.flag,null);

return true;
});})(flag))
;

cljs.core.async.t_cljs$core$async14212.getBasis = ((function (flag){
return (function (){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"flag","flag",-1565787888,null),new cljs.core.Symbol(null,"meta14213","meta14213",1958263575,null)], null);
});})(flag))
;

cljs.core.async.t_cljs$core$async14212.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async14212.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async14212";

cljs.core.async.t_cljs$core$async14212.cljs$lang$ctorPrWriter = ((function (flag){
return (function (this__7149__auto__,writer__7150__auto__,opt__7151__auto__){
return cljs.core._write.call(null,writer__7150__auto__,"cljs.core.async/t_cljs$core$async14212");
});})(flag))
;

cljs.core.async.__GT_t_cljs$core$async14212 = ((function (flag){
return (function cljs$core$async$alt_flag_$___GT_t_cljs$core$async14212(flag__$1,meta14213){
return (new cljs.core.async.t_cljs$core$async14212(flag__$1,meta14213));
});})(flag))
;

}

return (new cljs.core.async.t_cljs$core$async14212(flag,cljs.core.PersistentArrayMap.EMPTY));
});
cljs.core.async.alt_handler = (function cljs$core$async$alt_handler(flag,cb){
if(typeof cljs.core.async.t_cljs$core$async14221 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async14221 = (function (flag,cb,meta14222){
this.flag = flag;
this.cb = cb;
this.meta14222 = meta14222;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async14221.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_14223,meta14222__$1){
var self__ = this;
var _14223__$1 = this;
return (new cljs.core.async.t_cljs$core$async14221(self__.flag,self__.cb,meta14222__$1));
});

cljs.core.async.t_cljs$core$async14221.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_14223){
var self__ = this;
var _14223__$1 = this;
return self__.meta14222;
});

cljs.core.async.t_cljs$core$async14221.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async14221.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.active_QMARK_.call(null,self__.flag);
});

cljs.core.async.t_cljs$core$async14221.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return true;
});

cljs.core.async.t_cljs$core$async14221.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.async.impl.protocols.commit.call(null,self__.flag);

return self__.cb;
});

cljs.core.async.t_cljs$core$async14221.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"flag","flag",-1565787888,null),new cljs.core.Symbol(null,"cb","cb",-2064487928,null),new cljs.core.Symbol(null,"meta14222","meta14222",-1307994278,null)], null);
});

cljs.core.async.t_cljs$core$async14221.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async14221.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async14221";

cljs.core.async.t_cljs$core$async14221.cljs$lang$ctorPrWriter = (function (this__7149__auto__,writer__7150__auto__,opt__7151__auto__){
return cljs.core._write.call(null,writer__7150__auto__,"cljs.core.async/t_cljs$core$async14221");
});

cljs.core.async.__GT_t_cljs$core$async14221 = (function cljs$core$async$alt_handler_$___GT_t_cljs$core$async14221(flag__$1,cb__$1,meta14222){
return (new cljs.core.async.t_cljs$core$async14221(flag__$1,cb__$1,meta14222));
});

}

return (new cljs.core.async.t_cljs$core$async14221(flag,cb,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * returns derefable [val port] if immediate, nil if enqueued
 */
cljs.core.async.do_alts = (function cljs$core$async$do_alts(fret,ports,opts){
var flag = cljs.core.async.alt_flag.call(null);
var n = cljs.core.count.call(null,ports);
var idxs = cljs.core.async.random_array.call(null,n);
var priority = new cljs.core.Keyword(null,"priority","priority",1431093715).cljs$core$IFn$_invoke$arity$1(opts);
var ret = (function (){var i = (0);
while(true){
if((i < n)){
var idx = (cljs.core.truth_(priority)?i:(idxs[i]));
var port = cljs.core.nth.call(null,ports,idx);
var wport = ((cljs.core.vector_QMARK_.call(null,port))?port.call(null,(0)):null);
var vbox = (cljs.core.truth_(wport)?(function (){var val = port.call(null,(1));
return cljs.core.async.impl.protocols.put_BANG_.call(null,wport,val,cljs.core.async.alt_handler.call(null,flag,((function (i,val,idx,port,wport,flag,n,idxs,priority){
return (function (p1__14224_SHARP_){
return fret.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p1__14224_SHARP_,wport], null));
});})(i,val,idx,port,wport,flag,n,idxs,priority))
));
})():cljs.core.async.impl.protocols.take_BANG_.call(null,port,cljs.core.async.alt_handler.call(null,flag,((function (i,idx,port,wport,flag,n,idxs,priority){
return (function (p1__14225_SHARP_){
return fret.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p1__14225_SHARP_,port], null));
});})(i,idx,port,wport,flag,n,idxs,priority))
)));
if(cljs.core.truth_(vbox)){
return cljs.core.async.impl.channels.box.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.deref.call(null,vbox),(function (){var or__6543__auto__ = wport;
if(cljs.core.truth_(or__6543__auto__)){
return or__6543__auto__;
} else {
return port;
}
})()], null));
} else {
var G__14236 = (i + (1));
i = G__14236;
continue;
}
} else {
return null;
}
break;
}
})();
var or__6543__auto__ = ret;
if(cljs.core.truth_(or__6543__auto__)){
return or__6543__auto__;
} else {
if(cljs.core.contains_QMARK_.call(null,opts,new cljs.core.Keyword(null,"default","default",-1987822328))){
var temp__4657__auto__ = (function (){var and__6531__auto__ = cljs.core.async.impl.protocols.active_QMARK_.call(null,flag);
if(cljs.core.truth_(and__6531__auto__)){
return cljs.core.async.impl.protocols.commit.call(null,flag);
} else {
return and__6531__auto__;
}
})();
if(cljs.core.truth_(temp__4657__auto__)){
var got = temp__4657__auto__;
return cljs.core.async.impl.channels.box.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"default","default",-1987822328).cljs$core$IFn$_invoke$arity$1(opts),new cljs.core.Keyword(null,"default","default",-1987822328)], null));
} else {
return null;
}
} else {
return null;
}
}
});
/**
 * Completes at most one of several channel operations. Must be called
 * inside a (go ...) block. ports is a vector of channel endpoints,
 * which can be either a channel to take from or a vector of
 *   [channel-to-put-to val-to-put], in any combination. Takes will be
 *   made as if by <!, and puts will be made as if by >!. Unless
 *   the :priority option is true, if more than one port operation is
 *   ready a non-deterministic choice will be made. If no operation is
 *   ready and a :default value is supplied, [default-val :default] will
 *   be returned, otherwise alts! will park until the first operation to
 *   become ready completes. Returns [val port] of the completed
 *   operation, where val is the value taken for takes, and a
 *   boolean (true unless already closed, as per put!) for puts.
 * 
 *   opts are passed as :key val ... Supported options:
 * 
 *   :default val - the value to use if none of the operations are immediately ready
 *   :priority true - (default nil) when true, the operations will be tried in order.
 * 
 *   Note: there is no guarantee that the port exps or val exprs will be
 *   used, nor in what order should they be, so they should not be
 *   depended upon for side effects.
 */
cljs.core.async.alts_BANG_ = (function cljs$core$async$alts_BANG_(var_args){
var args__7658__auto__ = [];
var len__7651__auto___14246 = arguments.length;
var i__7652__auto___14247 = (0);
while(true){
if((i__7652__auto___14247 < len__7651__auto___14246)){
args__7658__auto__.push((arguments[i__7652__auto___14247]));

var G__14248 = (i__7652__auto___14247 + (1));
i__7652__auto___14247 = G__14248;
continue;
} else {
}
break;
}

var argseq__7659__auto__ = ((((1) < args__7658__auto__.length))?(new cljs.core.IndexedSeq(args__7658__auto__.slice((1)),(0),null)):null);
return cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__7659__auto__);
});

cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (ports,p__14243){
var map__14244 = p__14243;
var map__14244__$1 = ((((!((map__14244 == null)))?((((map__14244.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__14244.cljs$core$ISeq$)))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__14244):map__14244);
var opts = map__14244__$1;
throw (new Error("alts! used not in (go ...) block"));
});

cljs.core.async.alts_BANG_.cljs$lang$maxFixedArity = (1);

cljs.core.async.alts_BANG_.cljs$lang$applyTo = (function (seq14237){
var G__14238 = cljs.core.first.call(null,seq14237);
var seq14237__$1 = cljs.core.next.call(null,seq14237);
return cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic(G__14238,seq14237__$1);
});

/**
 * Puts a val into port if it's possible to do so immediately.
 *   nil values are not allowed. Never blocks. Returns true if offer succeeds.
 */
cljs.core.async.offer_BANG_ = (function cljs$core$async$offer_BANG_(port,val){
var ret = cljs.core.async.impl.protocols.put_BANG_.call(null,port,val,cljs.core.async.fn_handler.call(null,cljs.core.async.nop,false));
if(cljs.core.truth_(ret)){
return cljs.core.deref.call(null,ret);
} else {
return null;
}
});
/**
 * Takes a val from port if it's possible to do so immediately.
 *   Never blocks. Returns value if successful, nil otherwise.
 */
cljs.core.async.poll_BANG_ = (function cljs$core$async$poll_BANG_(port){
var ret = cljs.core.async.impl.protocols.take_BANG_.call(null,port,cljs.core.async.fn_handler.call(null,cljs.core.async.nop,false));
if(cljs.core.truth_(ret)){
return cljs.core.deref.call(null,ret);
} else {
return null;
}
});
/**
 * Takes elements from the from channel and supplies them to the to
 * channel. By default, the to channel will be closed when the from
 * channel closes, but can be determined by the close?  parameter. Will
 * stop consuming the from channel if the to channel closes
 */
cljs.core.async.pipe = (function cljs$core$async$pipe(var_args){
var args14253 = [];
var len__7651__auto___14307 = arguments.length;
var i__7652__auto___14308 = (0);
while(true){
if((i__7652__auto___14308 < len__7651__auto___14307)){
args14253.push((arguments[i__7652__auto___14308]));

var G__14309 = (i__7652__auto___14308 + (1));
i__7652__auto___14308 = G__14309;
continue;
} else {
}
break;
}

var G__14255 = args14253.length;
switch (G__14255) {
case 2:
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args14253.length)].join('')));

}
});

cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$2 = (function (from,to){
return cljs.core.async.pipe.call(null,from,to,true);
});

cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3 = (function (from,to,close_QMARK_){
var c__13923__auto___14311 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13923__auto___14311){
return (function (){
var f__13924__auto__ = (function (){var switch__13908__auto__ = ((function (c__13923__auto___14311){
return (function (state_14283){
var state_val_14284 = (state_14283[(1)]);
if((state_val_14284 === (7))){
var inst_14279 = (state_14283[(2)]);
var state_14283__$1 = state_14283;
var statearr_14285_14312 = state_14283__$1;
(statearr_14285_14312[(2)] = inst_14279);

(statearr_14285_14312[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14284 === (1))){
var state_14283__$1 = state_14283;
var statearr_14286_14313 = state_14283__$1;
(statearr_14286_14313[(2)] = null);

(statearr_14286_14313[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14284 === (4))){
var inst_14262 = (state_14283[(7)]);
var inst_14262__$1 = (state_14283[(2)]);
var inst_14263 = (inst_14262__$1 == null);
var state_14283__$1 = (function (){var statearr_14287 = state_14283;
(statearr_14287[(7)] = inst_14262__$1);

return statearr_14287;
})();
if(cljs.core.truth_(inst_14263)){
var statearr_14288_14314 = state_14283__$1;
(statearr_14288_14314[(1)] = (5));

} else {
var statearr_14289_14315 = state_14283__$1;
(statearr_14289_14315[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14284 === (13))){
var state_14283__$1 = state_14283;
var statearr_14290_14316 = state_14283__$1;
(statearr_14290_14316[(2)] = null);

(statearr_14290_14316[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14284 === (6))){
var inst_14262 = (state_14283[(7)]);
var state_14283__$1 = state_14283;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_14283__$1,(11),to,inst_14262);
} else {
if((state_val_14284 === (3))){
var inst_14281 = (state_14283[(2)]);
var state_14283__$1 = state_14283;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_14283__$1,inst_14281);
} else {
if((state_val_14284 === (12))){
var state_14283__$1 = state_14283;
var statearr_14291_14317 = state_14283__$1;
(statearr_14291_14317[(2)] = null);

(statearr_14291_14317[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14284 === (2))){
var state_14283__$1 = state_14283;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_14283__$1,(4),from);
} else {
if((state_val_14284 === (11))){
var inst_14272 = (state_14283[(2)]);
var state_14283__$1 = state_14283;
if(cljs.core.truth_(inst_14272)){
var statearr_14292_14318 = state_14283__$1;
(statearr_14292_14318[(1)] = (12));

} else {
var statearr_14293_14319 = state_14283__$1;
(statearr_14293_14319[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14284 === (9))){
var state_14283__$1 = state_14283;
var statearr_14294_14320 = state_14283__$1;
(statearr_14294_14320[(2)] = null);

(statearr_14294_14320[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14284 === (5))){
var state_14283__$1 = state_14283;
if(cljs.core.truth_(close_QMARK_)){
var statearr_14295_14321 = state_14283__$1;
(statearr_14295_14321[(1)] = (8));

} else {
var statearr_14296_14322 = state_14283__$1;
(statearr_14296_14322[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14284 === (14))){
var inst_14277 = (state_14283[(2)]);
var state_14283__$1 = state_14283;
var statearr_14297_14323 = state_14283__$1;
(statearr_14297_14323[(2)] = inst_14277);

(statearr_14297_14323[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14284 === (10))){
var inst_14269 = (state_14283[(2)]);
var state_14283__$1 = state_14283;
var statearr_14298_14324 = state_14283__$1;
(statearr_14298_14324[(2)] = inst_14269);

(statearr_14298_14324[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14284 === (8))){
var inst_14266 = cljs.core.async.close_BANG_.call(null,to);
var state_14283__$1 = state_14283;
var statearr_14299_14325 = state_14283__$1;
(statearr_14299_14325[(2)] = inst_14266);

(statearr_14299_14325[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__13923__auto___14311))
;
return ((function (switch__13908__auto__,c__13923__auto___14311){
return (function() {
var cljs$core$async$state_machine__13909__auto__ = null;
var cljs$core$async$state_machine__13909__auto____0 = (function (){
var statearr_14303 = [null,null,null,null,null,null,null,null];
(statearr_14303[(0)] = cljs$core$async$state_machine__13909__auto__);

(statearr_14303[(1)] = (1));

return statearr_14303;
});
var cljs$core$async$state_machine__13909__auto____1 = (function (state_14283){
while(true){
var ret_value__13910__auto__ = (function (){try{while(true){
var result__13911__auto__ = switch__13908__auto__.call(null,state_14283);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13911__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13911__auto__;
}
break;
}
}catch (e14304){if((e14304 instanceof Object)){
var ex__13912__auto__ = e14304;
var statearr_14305_14326 = state_14283;
(statearr_14305_14326[(5)] = ex__13912__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_14283);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e14304;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13910__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__14327 = state_14283;
state_14283 = G__14327;
continue;
} else {
return ret_value__13910__auto__;
}
break;
}
});
cljs$core$async$state_machine__13909__auto__ = function(state_14283){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__13909__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__13909__auto____1.call(this,state_14283);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__13909__auto____0;
cljs$core$async$state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__13909__auto____1;
return cljs$core$async$state_machine__13909__auto__;
})()
;})(switch__13908__auto__,c__13923__auto___14311))
})();
var state__13925__auto__ = (function (){var statearr_14306 = f__13924__auto__.call(null);
(statearr_14306[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13923__auto___14311);

return statearr_14306;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13925__auto__);
});})(c__13923__auto___14311))
);


return to;
});

cljs.core.async.pipe.cljs$lang$maxFixedArity = 3;

cljs.core.async.pipeline_STAR_ = (function cljs$core$async$pipeline_STAR_(n,to,xf,from,close_QMARK_,ex_handler,type){
if((n > (0))){
} else {
throw (new Error("Assert failed: (pos? n)"));
}

var jobs = cljs.core.async.chan.call(null,n);
var results = cljs.core.async.chan.call(null,n);
var process = ((function (jobs,results){
return (function (p__14531){
var vec__14532 = p__14531;
var v = cljs.core.nth.call(null,vec__14532,(0),null);
var p = cljs.core.nth.call(null,vec__14532,(1),null);
var job = vec__14532;
if((job == null)){
cljs.core.async.close_BANG_.call(null,results);

return null;
} else {
var res = cljs.core.async.chan.call(null,(1),xf,ex_handler);
var c__13923__auto___14723 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13923__auto___14723,res,vec__14532,v,p,job,jobs,results){
return (function (){
var f__13924__auto__ = (function (){var switch__13908__auto__ = ((function (c__13923__auto___14723,res,vec__14532,v,p,job,jobs,results){
return (function (state_14539){
var state_val_14540 = (state_14539[(1)]);
if((state_val_14540 === (1))){
var state_14539__$1 = state_14539;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_14539__$1,(2),res,v);
} else {
if((state_val_14540 === (2))){
var inst_14536 = (state_14539[(2)]);
var inst_14537 = cljs.core.async.close_BANG_.call(null,res);
var state_14539__$1 = (function (){var statearr_14541 = state_14539;
(statearr_14541[(7)] = inst_14536);

return statearr_14541;
})();
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_14539__$1,inst_14537);
} else {
return null;
}
}
});})(c__13923__auto___14723,res,vec__14532,v,p,job,jobs,results))
;
return ((function (switch__13908__auto__,c__13923__auto___14723,res,vec__14532,v,p,job,jobs,results){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__13909__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__13909__auto____0 = (function (){
var statearr_14545 = [null,null,null,null,null,null,null,null];
(statearr_14545[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__13909__auto__);

(statearr_14545[(1)] = (1));

return statearr_14545;
});
var cljs$core$async$pipeline_STAR__$_state_machine__13909__auto____1 = (function (state_14539){
while(true){
var ret_value__13910__auto__ = (function (){try{while(true){
var result__13911__auto__ = switch__13908__auto__.call(null,state_14539);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13911__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13911__auto__;
}
break;
}
}catch (e14546){if((e14546 instanceof Object)){
var ex__13912__auto__ = e14546;
var statearr_14547_14724 = state_14539;
(statearr_14547_14724[(5)] = ex__13912__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_14539);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e14546;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13910__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__14725 = state_14539;
state_14539 = G__14725;
continue;
} else {
return ret_value__13910__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__13909__auto__ = function(state_14539){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__13909__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__13909__auto____1.call(this,state_14539);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__13909__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__13909__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__13909__auto__;
})()
;})(switch__13908__auto__,c__13923__auto___14723,res,vec__14532,v,p,job,jobs,results))
})();
var state__13925__auto__ = (function (){var statearr_14548 = f__13924__auto__.call(null);
(statearr_14548[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13923__auto___14723);

return statearr_14548;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13925__auto__);
});})(c__13923__auto___14723,res,vec__14532,v,p,job,jobs,results))
);


cljs.core.async.put_BANG_.call(null,p,res);

return true;
}
});})(jobs,results))
;
var async = ((function (jobs,results,process){
return (function (p__14550){
var vec__14551 = p__14550;
var v = cljs.core.nth.call(null,vec__14551,(0),null);
var p = cljs.core.nth.call(null,vec__14551,(1),null);
var job = vec__14551;
if((job == null)){
cljs.core.async.close_BANG_.call(null,results);

return null;
} else {
var res = cljs.core.async.chan.call(null,(1));
xf.call(null,v,res);

cljs.core.async.put_BANG_.call(null,p,res);

return true;
}
});})(jobs,results,process))
;
var n__7461__auto___14729 = n;
var __14730 = (0);
while(true){
if((__14730 < n__7461__auto___14729)){
var G__14554_14731 = (((type instanceof cljs.core.Keyword))?type.fqn:null);
switch (G__14554_14731) {
case "compute":
var c__13923__auto___14733 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (__14730,c__13923__auto___14733,G__14554_14731,n__7461__auto___14729,jobs,results,process,async){
return (function (){
var f__13924__auto__ = (function (){var switch__13908__auto__ = ((function (__14730,c__13923__auto___14733,G__14554_14731,n__7461__auto___14729,jobs,results,process,async){
return (function (state_14567){
var state_val_14568 = (state_14567[(1)]);
if((state_val_14568 === (1))){
var state_14567__$1 = state_14567;
var statearr_14569_14734 = state_14567__$1;
(statearr_14569_14734[(2)] = null);

(statearr_14569_14734[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14568 === (2))){
var state_14567__$1 = state_14567;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_14567__$1,(4),jobs);
} else {
if((state_val_14568 === (3))){
var inst_14565 = (state_14567[(2)]);
var state_14567__$1 = state_14567;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_14567__$1,inst_14565);
} else {
if((state_val_14568 === (4))){
var inst_14557 = (state_14567[(2)]);
var inst_14558 = process.call(null,inst_14557);
var state_14567__$1 = state_14567;
if(cljs.core.truth_(inst_14558)){
var statearr_14570_14735 = state_14567__$1;
(statearr_14570_14735[(1)] = (5));

} else {
var statearr_14571_14736 = state_14567__$1;
(statearr_14571_14736[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14568 === (5))){
var state_14567__$1 = state_14567;
var statearr_14572_14737 = state_14567__$1;
(statearr_14572_14737[(2)] = null);

(statearr_14572_14737[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14568 === (6))){
var state_14567__$1 = state_14567;
var statearr_14573_14738 = state_14567__$1;
(statearr_14573_14738[(2)] = null);

(statearr_14573_14738[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14568 === (7))){
var inst_14563 = (state_14567[(2)]);
var state_14567__$1 = state_14567;
var statearr_14574_14739 = state_14567__$1;
(statearr_14574_14739[(2)] = inst_14563);

(statearr_14574_14739[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
});})(__14730,c__13923__auto___14733,G__14554_14731,n__7461__auto___14729,jobs,results,process,async))
;
return ((function (__14730,switch__13908__auto__,c__13923__auto___14733,G__14554_14731,n__7461__auto___14729,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__13909__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__13909__auto____0 = (function (){
var statearr_14578 = [null,null,null,null,null,null,null];
(statearr_14578[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__13909__auto__);

(statearr_14578[(1)] = (1));

return statearr_14578;
});
var cljs$core$async$pipeline_STAR__$_state_machine__13909__auto____1 = (function (state_14567){
while(true){
var ret_value__13910__auto__ = (function (){try{while(true){
var result__13911__auto__ = switch__13908__auto__.call(null,state_14567);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13911__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13911__auto__;
}
break;
}
}catch (e14579){if((e14579 instanceof Object)){
var ex__13912__auto__ = e14579;
var statearr_14580_14740 = state_14567;
(statearr_14580_14740[(5)] = ex__13912__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_14567);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e14579;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13910__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__14741 = state_14567;
state_14567 = G__14741;
continue;
} else {
return ret_value__13910__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__13909__auto__ = function(state_14567){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__13909__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__13909__auto____1.call(this,state_14567);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__13909__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__13909__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__13909__auto__;
})()
;})(__14730,switch__13908__auto__,c__13923__auto___14733,G__14554_14731,n__7461__auto___14729,jobs,results,process,async))
})();
var state__13925__auto__ = (function (){var statearr_14581 = f__13924__auto__.call(null);
(statearr_14581[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13923__auto___14733);

return statearr_14581;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13925__auto__);
});})(__14730,c__13923__auto___14733,G__14554_14731,n__7461__auto___14729,jobs,results,process,async))
);


break;
case "async":
var c__13923__auto___14742 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (__14730,c__13923__auto___14742,G__14554_14731,n__7461__auto___14729,jobs,results,process,async){
return (function (){
var f__13924__auto__ = (function (){var switch__13908__auto__ = ((function (__14730,c__13923__auto___14742,G__14554_14731,n__7461__auto___14729,jobs,results,process,async){
return (function (state_14594){
var state_val_14595 = (state_14594[(1)]);
if((state_val_14595 === (1))){
var state_14594__$1 = state_14594;
var statearr_14596_14743 = state_14594__$1;
(statearr_14596_14743[(2)] = null);

(statearr_14596_14743[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14595 === (2))){
var state_14594__$1 = state_14594;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_14594__$1,(4),jobs);
} else {
if((state_val_14595 === (3))){
var inst_14592 = (state_14594[(2)]);
var state_14594__$1 = state_14594;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_14594__$1,inst_14592);
} else {
if((state_val_14595 === (4))){
var inst_14584 = (state_14594[(2)]);
var inst_14585 = async.call(null,inst_14584);
var state_14594__$1 = state_14594;
if(cljs.core.truth_(inst_14585)){
var statearr_14597_14744 = state_14594__$1;
(statearr_14597_14744[(1)] = (5));

} else {
var statearr_14598_14745 = state_14594__$1;
(statearr_14598_14745[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14595 === (5))){
var state_14594__$1 = state_14594;
var statearr_14599_14746 = state_14594__$1;
(statearr_14599_14746[(2)] = null);

(statearr_14599_14746[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14595 === (6))){
var state_14594__$1 = state_14594;
var statearr_14600_14748 = state_14594__$1;
(statearr_14600_14748[(2)] = null);

(statearr_14600_14748[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14595 === (7))){
var inst_14590 = (state_14594[(2)]);
var state_14594__$1 = state_14594;
var statearr_14601_14749 = state_14594__$1;
(statearr_14601_14749[(2)] = inst_14590);

(statearr_14601_14749[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
});})(__14730,c__13923__auto___14742,G__14554_14731,n__7461__auto___14729,jobs,results,process,async))
;
return ((function (__14730,switch__13908__auto__,c__13923__auto___14742,G__14554_14731,n__7461__auto___14729,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__13909__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__13909__auto____0 = (function (){
var statearr_14605 = [null,null,null,null,null,null,null];
(statearr_14605[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__13909__auto__);

(statearr_14605[(1)] = (1));

return statearr_14605;
});
var cljs$core$async$pipeline_STAR__$_state_machine__13909__auto____1 = (function (state_14594){
while(true){
var ret_value__13910__auto__ = (function (){try{while(true){
var result__13911__auto__ = switch__13908__auto__.call(null,state_14594);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13911__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13911__auto__;
}
break;
}
}catch (e14606){if((e14606 instanceof Object)){
var ex__13912__auto__ = e14606;
var statearr_14607_14750 = state_14594;
(statearr_14607_14750[(5)] = ex__13912__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_14594);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e14606;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13910__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__14751 = state_14594;
state_14594 = G__14751;
continue;
} else {
return ret_value__13910__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__13909__auto__ = function(state_14594){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__13909__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__13909__auto____1.call(this,state_14594);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__13909__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__13909__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__13909__auto__;
})()
;})(__14730,switch__13908__auto__,c__13923__auto___14742,G__14554_14731,n__7461__auto___14729,jobs,results,process,async))
})();
var state__13925__auto__ = (function (){var statearr_14608 = f__13924__auto__.call(null);
(statearr_14608[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13923__auto___14742);

return statearr_14608;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13925__auto__);
});})(__14730,c__13923__auto___14742,G__14554_14731,n__7461__auto___14729,jobs,results,process,async))
);


break;
default:
throw (new Error([cljs.core.str("No matching clause: "),cljs.core.str(type)].join('')));

}

var G__14752 = (__14730 + (1));
__14730 = G__14752;
continue;
} else {
}
break;
}

var c__13923__auto___14753 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13923__auto___14753,jobs,results,process,async){
return (function (){
var f__13924__auto__ = (function (){var switch__13908__auto__ = ((function (c__13923__auto___14753,jobs,results,process,async){
return (function (state_14630){
var state_val_14631 = (state_14630[(1)]);
if((state_val_14631 === (1))){
var state_14630__$1 = state_14630;
var statearr_14632_14754 = state_14630__$1;
(statearr_14632_14754[(2)] = null);

(statearr_14632_14754[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14631 === (2))){
var state_14630__$1 = state_14630;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_14630__$1,(4),from);
} else {
if((state_val_14631 === (3))){
var inst_14628 = (state_14630[(2)]);
var state_14630__$1 = state_14630;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_14630__$1,inst_14628);
} else {
if((state_val_14631 === (4))){
var inst_14611 = (state_14630[(7)]);
var inst_14611__$1 = (state_14630[(2)]);
var inst_14612 = (inst_14611__$1 == null);
var state_14630__$1 = (function (){var statearr_14633 = state_14630;
(statearr_14633[(7)] = inst_14611__$1);

return statearr_14633;
})();
if(cljs.core.truth_(inst_14612)){
var statearr_14634_14755 = state_14630__$1;
(statearr_14634_14755[(1)] = (5));

} else {
var statearr_14635_14756 = state_14630__$1;
(statearr_14635_14756[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14631 === (5))){
var inst_14614 = cljs.core.async.close_BANG_.call(null,jobs);
var state_14630__$1 = state_14630;
var statearr_14636_14757 = state_14630__$1;
(statearr_14636_14757[(2)] = inst_14614);

(statearr_14636_14757[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14631 === (6))){
var inst_14611 = (state_14630[(7)]);
var inst_14616 = (state_14630[(8)]);
var inst_14616__$1 = cljs.core.async.chan.call(null,(1));
var inst_14617 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_14618 = [inst_14611,inst_14616__$1];
var inst_14619 = (new cljs.core.PersistentVector(null,2,(5),inst_14617,inst_14618,null));
var state_14630__$1 = (function (){var statearr_14637 = state_14630;
(statearr_14637[(8)] = inst_14616__$1);

return statearr_14637;
})();
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_14630__$1,(8),jobs,inst_14619);
} else {
if((state_val_14631 === (7))){
var inst_14626 = (state_14630[(2)]);
var state_14630__$1 = state_14630;
var statearr_14638_14758 = state_14630__$1;
(statearr_14638_14758[(2)] = inst_14626);

(statearr_14638_14758[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14631 === (8))){
var inst_14616 = (state_14630[(8)]);
var inst_14621 = (state_14630[(2)]);
var state_14630__$1 = (function (){var statearr_14639 = state_14630;
(statearr_14639[(9)] = inst_14621);

return statearr_14639;
})();
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_14630__$1,(9),results,inst_14616);
} else {
if((state_val_14631 === (9))){
var inst_14623 = (state_14630[(2)]);
var state_14630__$1 = (function (){var statearr_14640 = state_14630;
(statearr_14640[(10)] = inst_14623);

return statearr_14640;
})();
var statearr_14641_14759 = state_14630__$1;
(statearr_14641_14759[(2)] = null);

(statearr_14641_14759[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
});})(c__13923__auto___14753,jobs,results,process,async))
;
return ((function (switch__13908__auto__,c__13923__auto___14753,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__13909__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__13909__auto____0 = (function (){
var statearr_14645 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_14645[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__13909__auto__);

(statearr_14645[(1)] = (1));

return statearr_14645;
});
var cljs$core$async$pipeline_STAR__$_state_machine__13909__auto____1 = (function (state_14630){
while(true){
var ret_value__13910__auto__ = (function (){try{while(true){
var result__13911__auto__ = switch__13908__auto__.call(null,state_14630);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13911__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13911__auto__;
}
break;
}
}catch (e14646){if((e14646 instanceof Object)){
var ex__13912__auto__ = e14646;
var statearr_14647_14760 = state_14630;
(statearr_14647_14760[(5)] = ex__13912__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_14630);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e14646;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13910__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__14761 = state_14630;
state_14630 = G__14761;
continue;
} else {
return ret_value__13910__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__13909__auto__ = function(state_14630){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__13909__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__13909__auto____1.call(this,state_14630);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__13909__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__13909__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__13909__auto__;
})()
;})(switch__13908__auto__,c__13923__auto___14753,jobs,results,process,async))
})();
var state__13925__auto__ = (function (){var statearr_14648 = f__13924__auto__.call(null);
(statearr_14648[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13923__auto___14753);

return statearr_14648;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13925__auto__);
});})(c__13923__auto___14753,jobs,results,process,async))
);


var c__13923__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13923__auto__,jobs,results,process,async){
return (function (){
var f__13924__auto__ = (function (){var switch__13908__auto__ = ((function (c__13923__auto__,jobs,results,process,async){
return (function (state_14686){
var state_val_14687 = (state_14686[(1)]);
if((state_val_14687 === (7))){
var inst_14682 = (state_14686[(2)]);
var state_14686__$1 = state_14686;
var statearr_14688_14762 = state_14686__$1;
(statearr_14688_14762[(2)] = inst_14682);

(statearr_14688_14762[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14687 === (20))){
var state_14686__$1 = state_14686;
var statearr_14689_14763 = state_14686__$1;
(statearr_14689_14763[(2)] = null);

(statearr_14689_14763[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14687 === (1))){
var state_14686__$1 = state_14686;
var statearr_14690_14764 = state_14686__$1;
(statearr_14690_14764[(2)] = null);

(statearr_14690_14764[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14687 === (4))){
var inst_14651 = (state_14686[(7)]);
var inst_14651__$1 = (state_14686[(2)]);
var inst_14652 = (inst_14651__$1 == null);
var state_14686__$1 = (function (){var statearr_14691 = state_14686;
(statearr_14691[(7)] = inst_14651__$1);

return statearr_14691;
})();
if(cljs.core.truth_(inst_14652)){
var statearr_14692_14765 = state_14686__$1;
(statearr_14692_14765[(1)] = (5));

} else {
var statearr_14693_14766 = state_14686__$1;
(statearr_14693_14766[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14687 === (15))){
var inst_14664 = (state_14686[(8)]);
var state_14686__$1 = state_14686;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_14686__$1,(18),to,inst_14664);
} else {
if((state_val_14687 === (21))){
var inst_14677 = (state_14686[(2)]);
var state_14686__$1 = state_14686;
var statearr_14694_14767 = state_14686__$1;
(statearr_14694_14767[(2)] = inst_14677);

(statearr_14694_14767[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14687 === (13))){
var inst_14679 = (state_14686[(2)]);
var state_14686__$1 = (function (){var statearr_14695 = state_14686;
(statearr_14695[(9)] = inst_14679);

return statearr_14695;
})();
var statearr_14696_14768 = state_14686__$1;
(statearr_14696_14768[(2)] = null);

(statearr_14696_14768[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14687 === (6))){
var inst_14651 = (state_14686[(7)]);
var state_14686__$1 = state_14686;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_14686__$1,(11),inst_14651);
} else {
if((state_val_14687 === (17))){
var inst_14672 = (state_14686[(2)]);
var state_14686__$1 = state_14686;
if(cljs.core.truth_(inst_14672)){
var statearr_14697_14769 = state_14686__$1;
(statearr_14697_14769[(1)] = (19));

} else {
var statearr_14698_14770 = state_14686__$1;
(statearr_14698_14770[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14687 === (3))){
var inst_14684 = (state_14686[(2)]);
var state_14686__$1 = state_14686;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_14686__$1,inst_14684);
} else {
if((state_val_14687 === (12))){
var inst_14661 = (state_14686[(10)]);
var state_14686__$1 = state_14686;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_14686__$1,(14),inst_14661);
} else {
if((state_val_14687 === (2))){
var state_14686__$1 = state_14686;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_14686__$1,(4),results);
} else {
if((state_val_14687 === (19))){
var state_14686__$1 = state_14686;
var statearr_14702_14771 = state_14686__$1;
(statearr_14702_14771[(2)] = null);

(statearr_14702_14771[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14687 === (11))){
var inst_14661 = (state_14686[(2)]);
var state_14686__$1 = (function (){var statearr_14703 = state_14686;
(statearr_14703[(10)] = inst_14661);

return statearr_14703;
})();
var statearr_14704_14772 = state_14686__$1;
(statearr_14704_14772[(2)] = null);

(statearr_14704_14772[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14687 === (9))){
var state_14686__$1 = state_14686;
var statearr_14705_14773 = state_14686__$1;
(statearr_14705_14773[(2)] = null);

(statearr_14705_14773[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14687 === (5))){
var state_14686__$1 = state_14686;
if(cljs.core.truth_(close_QMARK_)){
var statearr_14706_14774 = state_14686__$1;
(statearr_14706_14774[(1)] = (8));

} else {
var statearr_14707_14775 = state_14686__$1;
(statearr_14707_14775[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14687 === (14))){
var inst_14666 = (state_14686[(11)]);
var inst_14664 = (state_14686[(8)]);
var inst_14664__$1 = (state_14686[(2)]);
var inst_14665 = (inst_14664__$1 == null);
var inst_14666__$1 = cljs.core.not.call(null,inst_14665);
var state_14686__$1 = (function (){var statearr_14709 = state_14686;
(statearr_14709[(11)] = inst_14666__$1);

(statearr_14709[(8)] = inst_14664__$1);

return statearr_14709;
})();
if(inst_14666__$1){
var statearr_14710_14776 = state_14686__$1;
(statearr_14710_14776[(1)] = (15));

} else {
var statearr_14711_14777 = state_14686__$1;
(statearr_14711_14777[(1)] = (16));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14687 === (16))){
var inst_14666 = (state_14686[(11)]);
var state_14686__$1 = state_14686;
var statearr_14712_14778 = state_14686__$1;
(statearr_14712_14778[(2)] = inst_14666);

(statearr_14712_14778[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14687 === (10))){
var inst_14658 = (state_14686[(2)]);
var state_14686__$1 = state_14686;
var statearr_14713_14779 = state_14686__$1;
(statearr_14713_14779[(2)] = inst_14658);

(statearr_14713_14779[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14687 === (18))){
var inst_14669 = (state_14686[(2)]);
var state_14686__$1 = state_14686;
var statearr_14714_14780 = state_14686__$1;
(statearr_14714_14780[(2)] = inst_14669);

(statearr_14714_14780[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14687 === (8))){
var inst_14655 = cljs.core.async.close_BANG_.call(null,to);
var state_14686__$1 = state_14686;
var statearr_14715_14781 = state_14686__$1;
(statearr_14715_14781[(2)] = inst_14655);

(statearr_14715_14781[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__13923__auto__,jobs,results,process,async))
;
return ((function (switch__13908__auto__,c__13923__auto__,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__13909__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__13909__auto____0 = (function (){
var statearr_14719 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_14719[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__13909__auto__);

(statearr_14719[(1)] = (1));

return statearr_14719;
});
var cljs$core$async$pipeline_STAR__$_state_machine__13909__auto____1 = (function (state_14686){
while(true){
var ret_value__13910__auto__ = (function (){try{while(true){
var result__13911__auto__ = switch__13908__auto__.call(null,state_14686);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13911__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13911__auto__;
}
break;
}
}catch (e14720){if((e14720 instanceof Object)){
var ex__13912__auto__ = e14720;
var statearr_14721_14785 = state_14686;
(statearr_14721_14785[(5)] = ex__13912__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_14686);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e14720;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13910__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__14787 = state_14686;
state_14686 = G__14787;
continue;
} else {
return ret_value__13910__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__13909__auto__ = function(state_14686){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__13909__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__13909__auto____1.call(this,state_14686);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__13909__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__13909__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__13909__auto__;
})()
;})(switch__13908__auto__,c__13923__auto__,jobs,results,process,async))
})();
var state__13925__auto__ = (function (){var statearr_14722 = f__13924__auto__.call(null);
(statearr_14722[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13923__auto__);

return statearr_14722;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13925__auto__);
});})(c__13923__auto__,jobs,results,process,async))
);

return c__13923__auto__;
});
/**
 * Takes elements from the from channel and supplies them to the to
 *   channel, subject to the async function af, with parallelism n. af
 *   must be a function of two arguments, the first an input value and
 *   the second a channel on which to place the result(s). af must close!
 *   the channel before returning.  The presumption is that af will
 *   return immediately, having launched some asynchronous operation
 *   whose completion/callback will manipulate the result channel. Outputs
 *   will be returned in order relative to  the inputs. By default, the to
 *   channel will be closed when the from channel closes, but can be
 *   determined by the close?  parameter. Will stop consuming the from
 *   channel if the to channel closes.
 */
cljs.core.async.pipeline_async = (function cljs$core$async$pipeline_async(var_args){
var args14788 = [];
var len__7651__auto___14791 = arguments.length;
var i__7652__auto___14792 = (0);
while(true){
if((i__7652__auto___14792 < len__7651__auto___14791)){
args14788.push((arguments[i__7652__auto___14792]));

var G__14793 = (i__7652__auto___14792 + (1));
i__7652__auto___14792 = G__14793;
continue;
} else {
}
break;
}

var G__14790 = args14788.length;
switch (G__14790) {
case 4:
return cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args14788.length)].join('')));

}
});

cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$4 = (function (n,to,af,from){
return cljs.core.async.pipeline_async.call(null,n,to,af,from,true);
});

cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$5 = (function (n,to,af,from,close_QMARK_){
return cljs.core.async.pipeline_STAR_.call(null,n,to,af,from,close_QMARK_,null,new cljs.core.Keyword(null,"async","async",1050769601));
});

cljs.core.async.pipeline_async.cljs$lang$maxFixedArity = 5;

/**
 * Takes elements from the from channel and supplies them to the to
 *   channel, subject to the transducer xf, with parallelism n. Because
 *   it is parallel, the transducer will be applied independently to each
 *   element, not across elements, and may produce zero or more outputs
 *   per input.  Outputs will be returned in order relative to the
 *   inputs. By default, the to channel will be closed when the from
 *   channel closes, but can be determined by the close?  parameter. Will
 *   stop consuming the from channel if the to channel closes.
 * 
 *   Note this is supplied for API compatibility with the Clojure version.
 *   Values of N > 1 will not result in actual concurrency in a
 *   single-threaded runtime.
 */
cljs.core.async.pipeline = (function cljs$core$async$pipeline(var_args){
var args14798 = [];
var len__7651__auto___14801 = arguments.length;
var i__7652__auto___14802 = (0);
while(true){
if((i__7652__auto___14802 < len__7651__auto___14801)){
args14798.push((arguments[i__7652__auto___14802]));

var G__14804 = (i__7652__auto___14802 + (1));
i__7652__auto___14802 = G__14804;
continue;
} else {
}
break;
}

var G__14800 = args14798.length;
switch (G__14800) {
case 4:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
case 6:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$6((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]),(arguments[(5)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args14798.length)].join('')));

}
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$4 = (function (n,to,xf,from){
return cljs.core.async.pipeline.call(null,n,to,xf,from,true);
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$5 = (function (n,to,xf,from,close_QMARK_){
return cljs.core.async.pipeline.call(null,n,to,xf,from,close_QMARK_,null);
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$6 = (function (n,to,xf,from,close_QMARK_,ex_handler){
return cljs.core.async.pipeline_STAR_.call(null,n,to,xf,from,close_QMARK_,ex_handler,new cljs.core.Keyword(null,"compute","compute",1555393130));
});

cljs.core.async.pipeline.cljs$lang$maxFixedArity = 6;

/**
 * Takes a predicate and a source channel and returns a vector of two
 *   channels, the first of which will contain the values for which the
 *   predicate returned true, the second those for which it returned
 *   false.
 * 
 *   The out channels will be unbuffered by default, or two buf-or-ns can
 *   be supplied. The channels will close after the source channel has
 *   closed.
 */
cljs.core.async.split = (function cljs$core$async$split(var_args){
var args14806 = [];
var len__7651__auto___14859 = arguments.length;
var i__7652__auto___14860 = (0);
while(true){
if((i__7652__auto___14860 < len__7651__auto___14859)){
args14806.push((arguments[i__7652__auto___14860]));

var G__14861 = (i__7652__auto___14860 + (1));
i__7652__auto___14860 = G__14861;
continue;
} else {
}
break;
}

var G__14808 = args14806.length;
switch (G__14808) {
case 2:
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 4:
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args14806.length)].join('')));

}
});

cljs.core.async.split.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.split.call(null,p,ch,null,null);
});

cljs.core.async.split.cljs$core$IFn$_invoke$arity$4 = (function (p,ch,t_buf_or_n,f_buf_or_n){
var tc = cljs.core.async.chan.call(null,t_buf_or_n);
var fc = cljs.core.async.chan.call(null,f_buf_or_n);
var c__13923__auto___14863 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13923__auto___14863,tc,fc){
return (function (){
var f__13924__auto__ = (function (){var switch__13908__auto__ = ((function (c__13923__auto___14863,tc,fc){
return (function (state_14834){
var state_val_14835 = (state_14834[(1)]);
if((state_val_14835 === (7))){
var inst_14830 = (state_14834[(2)]);
var state_14834__$1 = state_14834;
var statearr_14836_14864 = state_14834__$1;
(statearr_14836_14864[(2)] = inst_14830);

(statearr_14836_14864[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14835 === (1))){
var state_14834__$1 = state_14834;
var statearr_14837_14865 = state_14834__$1;
(statearr_14837_14865[(2)] = null);

(statearr_14837_14865[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14835 === (4))){
var inst_14811 = (state_14834[(7)]);
var inst_14811__$1 = (state_14834[(2)]);
var inst_14812 = (inst_14811__$1 == null);
var state_14834__$1 = (function (){var statearr_14838 = state_14834;
(statearr_14838[(7)] = inst_14811__$1);

return statearr_14838;
})();
if(cljs.core.truth_(inst_14812)){
var statearr_14839_14866 = state_14834__$1;
(statearr_14839_14866[(1)] = (5));

} else {
var statearr_14840_14867 = state_14834__$1;
(statearr_14840_14867[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14835 === (13))){
var state_14834__$1 = state_14834;
var statearr_14841_14868 = state_14834__$1;
(statearr_14841_14868[(2)] = null);

(statearr_14841_14868[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14835 === (6))){
var inst_14811 = (state_14834[(7)]);
var inst_14817 = p.call(null,inst_14811);
var state_14834__$1 = state_14834;
if(cljs.core.truth_(inst_14817)){
var statearr_14842_14869 = state_14834__$1;
(statearr_14842_14869[(1)] = (9));

} else {
var statearr_14843_14872 = state_14834__$1;
(statearr_14843_14872[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14835 === (3))){
var inst_14832 = (state_14834[(2)]);
var state_14834__$1 = state_14834;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_14834__$1,inst_14832);
} else {
if((state_val_14835 === (12))){
var state_14834__$1 = state_14834;
var statearr_14844_14875 = state_14834__$1;
(statearr_14844_14875[(2)] = null);

(statearr_14844_14875[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14835 === (2))){
var state_14834__$1 = state_14834;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_14834__$1,(4),ch);
} else {
if((state_val_14835 === (11))){
var inst_14811 = (state_14834[(7)]);
var inst_14821 = (state_14834[(2)]);
var state_14834__$1 = state_14834;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_14834__$1,(8),inst_14821,inst_14811);
} else {
if((state_val_14835 === (9))){
var state_14834__$1 = state_14834;
var statearr_14845_14879 = state_14834__$1;
(statearr_14845_14879[(2)] = tc);

(statearr_14845_14879[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14835 === (5))){
var inst_14814 = cljs.core.async.close_BANG_.call(null,tc);
var inst_14815 = cljs.core.async.close_BANG_.call(null,fc);
var state_14834__$1 = (function (){var statearr_14846 = state_14834;
(statearr_14846[(8)] = inst_14814);

return statearr_14846;
})();
var statearr_14847_14881 = state_14834__$1;
(statearr_14847_14881[(2)] = inst_14815);

(statearr_14847_14881[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14835 === (14))){
var inst_14828 = (state_14834[(2)]);
var state_14834__$1 = state_14834;
var statearr_14848_14882 = state_14834__$1;
(statearr_14848_14882[(2)] = inst_14828);

(statearr_14848_14882[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14835 === (10))){
var state_14834__$1 = state_14834;
var statearr_14849_14883 = state_14834__$1;
(statearr_14849_14883[(2)] = fc);

(statearr_14849_14883[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14835 === (8))){
var inst_14823 = (state_14834[(2)]);
var state_14834__$1 = state_14834;
if(cljs.core.truth_(inst_14823)){
var statearr_14850_14884 = state_14834__$1;
(statearr_14850_14884[(1)] = (12));

} else {
var statearr_14851_14885 = state_14834__$1;
(statearr_14851_14885[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__13923__auto___14863,tc,fc))
;
return ((function (switch__13908__auto__,c__13923__auto___14863,tc,fc){
return (function() {
var cljs$core$async$state_machine__13909__auto__ = null;
var cljs$core$async$state_machine__13909__auto____0 = (function (){
var statearr_14855 = [null,null,null,null,null,null,null,null,null];
(statearr_14855[(0)] = cljs$core$async$state_machine__13909__auto__);

(statearr_14855[(1)] = (1));

return statearr_14855;
});
var cljs$core$async$state_machine__13909__auto____1 = (function (state_14834){
while(true){
var ret_value__13910__auto__ = (function (){try{while(true){
var result__13911__auto__ = switch__13908__auto__.call(null,state_14834);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13911__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13911__auto__;
}
break;
}
}catch (e14856){if((e14856 instanceof Object)){
var ex__13912__auto__ = e14856;
var statearr_14857_14886 = state_14834;
(statearr_14857_14886[(5)] = ex__13912__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_14834);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e14856;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13910__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__14887 = state_14834;
state_14834 = G__14887;
continue;
} else {
return ret_value__13910__auto__;
}
break;
}
});
cljs$core$async$state_machine__13909__auto__ = function(state_14834){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__13909__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__13909__auto____1.call(this,state_14834);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__13909__auto____0;
cljs$core$async$state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__13909__auto____1;
return cljs$core$async$state_machine__13909__auto__;
})()
;})(switch__13908__auto__,c__13923__auto___14863,tc,fc))
})();
var state__13925__auto__ = (function (){var statearr_14858 = f__13924__auto__.call(null);
(statearr_14858[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13923__auto___14863);

return statearr_14858;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13925__auto__);
});})(c__13923__auto___14863,tc,fc))
);


return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [tc,fc], null);
});

cljs.core.async.split.cljs$lang$maxFixedArity = 4;

/**
 * f should be a function of 2 arguments. Returns a channel containing
 *   the single result of applying f to init and the first item from the
 *   channel, then applying f to that result and the 2nd item, etc. If
 *   the channel closes without yielding items, returns init and f is not
 *   called. ch must close before reduce produces a result.
 */
cljs.core.async.reduce = (function cljs$core$async$reduce(f,init,ch){
var c__13923__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13923__auto__){
return (function (){
var f__13924__auto__ = (function (){var switch__13908__auto__ = ((function (c__13923__auto__){
return (function (state_14951){
var state_val_14952 = (state_14951[(1)]);
if((state_val_14952 === (7))){
var inst_14947 = (state_14951[(2)]);
var state_14951__$1 = state_14951;
var statearr_14953_14976 = state_14951__$1;
(statearr_14953_14976[(2)] = inst_14947);

(statearr_14953_14976[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14952 === (1))){
var inst_14931 = init;
var state_14951__$1 = (function (){var statearr_14954 = state_14951;
(statearr_14954[(7)] = inst_14931);

return statearr_14954;
})();
var statearr_14955_14977 = state_14951__$1;
(statearr_14955_14977[(2)] = null);

(statearr_14955_14977[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14952 === (4))){
var inst_14934 = (state_14951[(8)]);
var inst_14934__$1 = (state_14951[(2)]);
var inst_14935 = (inst_14934__$1 == null);
var state_14951__$1 = (function (){var statearr_14956 = state_14951;
(statearr_14956[(8)] = inst_14934__$1);

return statearr_14956;
})();
if(cljs.core.truth_(inst_14935)){
var statearr_14957_14979 = state_14951__$1;
(statearr_14957_14979[(1)] = (5));

} else {
var statearr_14958_14980 = state_14951__$1;
(statearr_14958_14980[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14952 === (6))){
var inst_14938 = (state_14951[(9)]);
var inst_14931 = (state_14951[(7)]);
var inst_14934 = (state_14951[(8)]);
var inst_14938__$1 = f.call(null,inst_14931,inst_14934);
var inst_14939 = cljs.core.reduced_QMARK_.call(null,inst_14938__$1);
var state_14951__$1 = (function (){var statearr_14959 = state_14951;
(statearr_14959[(9)] = inst_14938__$1);

return statearr_14959;
})();
if(inst_14939){
var statearr_14960_14984 = state_14951__$1;
(statearr_14960_14984[(1)] = (8));

} else {
var statearr_14961_14985 = state_14951__$1;
(statearr_14961_14985[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14952 === (3))){
var inst_14949 = (state_14951[(2)]);
var state_14951__$1 = state_14951;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_14951__$1,inst_14949);
} else {
if((state_val_14952 === (2))){
var state_14951__$1 = state_14951;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_14951__$1,(4),ch);
} else {
if((state_val_14952 === (9))){
var inst_14938 = (state_14951[(9)]);
var inst_14931 = inst_14938;
var state_14951__$1 = (function (){var statearr_14962 = state_14951;
(statearr_14962[(7)] = inst_14931);

return statearr_14962;
})();
var statearr_14963_14986 = state_14951__$1;
(statearr_14963_14986[(2)] = null);

(statearr_14963_14986[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14952 === (5))){
var inst_14931 = (state_14951[(7)]);
var state_14951__$1 = state_14951;
var statearr_14964_14988 = state_14951__$1;
(statearr_14964_14988[(2)] = inst_14931);

(statearr_14964_14988[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14952 === (10))){
var inst_14945 = (state_14951[(2)]);
var state_14951__$1 = state_14951;
var statearr_14965_14990 = state_14951__$1;
(statearr_14965_14990[(2)] = inst_14945);

(statearr_14965_14990[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14952 === (8))){
var inst_14938 = (state_14951[(9)]);
var inst_14941 = cljs.core.deref.call(null,inst_14938);
var state_14951__$1 = state_14951;
var statearr_14968_14991 = state_14951__$1;
(statearr_14968_14991[(2)] = inst_14941);

(statearr_14968_14991[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
});})(c__13923__auto__))
;
return ((function (switch__13908__auto__,c__13923__auto__){
return (function() {
var cljs$core$async$reduce_$_state_machine__13909__auto__ = null;
var cljs$core$async$reduce_$_state_machine__13909__auto____0 = (function (){
var statearr_14972 = [null,null,null,null,null,null,null,null,null,null];
(statearr_14972[(0)] = cljs$core$async$reduce_$_state_machine__13909__auto__);

(statearr_14972[(1)] = (1));

return statearr_14972;
});
var cljs$core$async$reduce_$_state_machine__13909__auto____1 = (function (state_14951){
while(true){
var ret_value__13910__auto__ = (function (){try{while(true){
var result__13911__auto__ = switch__13908__auto__.call(null,state_14951);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13911__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13911__auto__;
}
break;
}
}catch (e14973){if((e14973 instanceof Object)){
var ex__13912__auto__ = e14973;
var statearr_14974_14995 = state_14951;
(statearr_14974_14995[(5)] = ex__13912__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_14951);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e14973;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13910__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__14996 = state_14951;
state_14951 = G__14996;
continue;
} else {
return ret_value__13910__auto__;
}
break;
}
});
cljs$core$async$reduce_$_state_machine__13909__auto__ = function(state_14951){
switch(arguments.length){
case 0:
return cljs$core$async$reduce_$_state_machine__13909__auto____0.call(this);
case 1:
return cljs$core$async$reduce_$_state_machine__13909__auto____1.call(this,state_14951);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$reduce_$_state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$reduce_$_state_machine__13909__auto____0;
cljs$core$async$reduce_$_state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$reduce_$_state_machine__13909__auto____1;
return cljs$core$async$reduce_$_state_machine__13909__auto__;
})()
;})(switch__13908__auto__,c__13923__auto__))
})();
var state__13925__auto__ = (function (){var statearr_14975 = f__13924__auto__.call(null);
(statearr_14975[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13923__auto__);

return statearr_14975;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13925__auto__);
});})(c__13923__auto__))
);

return c__13923__auto__;
});
/**
 * async/reduces a channel with a transformation (xform f).
 *   Returns a channel containing the result.  ch must close before
 *   transduce produces a result.
 */
cljs.core.async.transduce = (function cljs$core$async$transduce(xform,f,init,ch){
var f__$1 = xform.call(null,f);
var c__13923__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13923__auto__,f__$1){
return (function (){
var f__13924__auto__ = (function (){var switch__13908__auto__ = ((function (c__13923__auto__,f__$1){
return (function (state_15016){
var state_val_15017 = (state_15016[(1)]);
if((state_val_15017 === (1))){
var inst_15011 = cljs.core.async.reduce.call(null,f__$1,init,ch);
var state_15016__$1 = state_15016;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_15016__$1,(2),inst_15011);
} else {
if((state_val_15017 === (2))){
var inst_15013 = (state_15016[(2)]);
var inst_15014 = f__$1.call(null,inst_15013);
var state_15016__$1 = state_15016;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_15016__$1,inst_15014);
} else {
return null;
}
}
});})(c__13923__auto__,f__$1))
;
return ((function (switch__13908__auto__,c__13923__auto__,f__$1){
return (function() {
var cljs$core$async$transduce_$_state_machine__13909__auto__ = null;
var cljs$core$async$transduce_$_state_machine__13909__auto____0 = (function (){
var statearr_15023 = [null,null,null,null,null,null,null];
(statearr_15023[(0)] = cljs$core$async$transduce_$_state_machine__13909__auto__);

(statearr_15023[(1)] = (1));

return statearr_15023;
});
var cljs$core$async$transduce_$_state_machine__13909__auto____1 = (function (state_15016){
while(true){
var ret_value__13910__auto__ = (function (){try{while(true){
var result__13911__auto__ = switch__13908__auto__.call(null,state_15016);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13911__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13911__auto__;
}
break;
}
}catch (e15024){if((e15024 instanceof Object)){
var ex__13912__auto__ = e15024;
var statearr_15029_15035 = state_15016;
(statearr_15029_15035[(5)] = ex__13912__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_15016);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e15024;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13910__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__15036 = state_15016;
state_15016 = G__15036;
continue;
} else {
return ret_value__13910__auto__;
}
break;
}
});
cljs$core$async$transduce_$_state_machine__13909__auto__ = function(state_15016){
switch(arguments.length){
case 0:
return cljs$core$async$transduce_$_state_machine__13909__auto____0.call(this);
case 1:
return cljs$core$async$transduce_$_state_machine__13909__auto____1.call(this,state_15016);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$transduce_$_state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$transduce_$_state_machine__13909__auto____0;
cljs$core$async$transduce_$_state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$transduce_$_state_machine__13909__auto____1;
return cljs$core$async$transduce_$_state_machine__13909__auto__;
})()
;})(switch__13908__auto__,c__13923__auto__,f__$1))
})();
var state__13925__auto__ = (function (){var statearr_15030 = f__13924__auto__.call(null);
(statearr_15030[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13923__auto__);

return statearr_15030;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13925__auto__);
});})(c__13923__auto__,f__$1))
);

return c__13923__auto__;
});
/**
 * Puts the contents of coll into the supplied channel.
 * 
 *   By default the channel will be closed after the items are copied,
 *   but can be determined by the close? parameter.
 * 
 *   Returns a channel which will close after the items are copied.
 */
cljs.core.async.onto_chan = (function cljs$core$async$onto_chan(var_args){
var args15037 = [];
var len__7651__auto___15107 = arguments.length;
var i__7652__auto___15108 = (0);
while(true){
if((i__7652__auto___15108 < len__7651__auto___15107)){
args15037.push((arguments[i__7652__auto___15108]));

var G__15109 = (i__7652__auto___15108 + (1));
i__7652__auto___15108 = G__15109;
continue;
} else {
}
break;
}

var G__15041 = args15037.length;
switch (G__15041) {
case 2:
return cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args15037.length)].join('')));

}
});

cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$2 = (function (ch,coll){
return cljs.core.async.onto_chan.call(null,ch,coll,true);
});

cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$3 = (function (ch,coll,close_QMARK_){
var c__13923__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13923__auto__){
return (function (){
var f__13924__auto__ = (function (){var switch__13908__auto__ = ((function (c__13923__auto__){
return (function (state_15075){
var state_val_15076 = (state_15075[(1)]);
if((state_val_15076 === (7))){
var inst_15049 = (state_15075[(2)]);
var state_15075__$1 = state_15075;
var statearr_15078_15111 = state_15075__$1;
(statearr_15078_15111[(2)] = inst_15049);

(statearr_15078_15111[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15076 === (1))){
var inst_15043 = cljs.core.seq.call(null,coll);
var inst_15044 = inst_15043;
var state_15075__$1 = (function (){var statearr_15080 = state_15075;
(statearr_15080[(7)] = inst_15044);

return statearr_15080;
})();
var statearr_15081_15112 = state_15075__$1;
(statearr_15081_15112[(2)] = null);

(statearr_15081_15112[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15076 === (4))){
var inst_15044 = (state_15075[(7)]);
var inst_15047 = cljs.core.first.call(null,inst_15044);
var state_15075__$1 = state_15075;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_15075__$1,(7),ch,inst_15047);
} else {
if((state_val_15076 === (13))){
var inst_15069 = (state_15075[(2)]);
var state_15075__$1 = state_15075;
var statearr_15082_15113 = state_15075__$1;
(statearr_15082_15113[(2)] = inst_15069);

(statearr_15082_15113[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15076 === (6))){
var inst_15052 = (state_15075[(2)]);
var state_15075__$1 = state_15075;
if(cljs.core.truth_(inst_15052)){
var statearr_15083_15114 = state_15075__$1;
(statearr_15083_15114[(1)] = (8));

} else {
var statearr_15084_15115 = state_15075__$1;
(statearr_15084_15115[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15076 === (3))){
var inst_15073 = (state_15075[(2)]);
var state_15075__$1 = state_15075;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_15075__$1,inst_15073);
} else {
if((state_val_15076 === (12))){
var state_15075__$1 = state_15075;
var statearr_15085_15116 = state_15075__$1;
(statearr_15085_15116[(2)] = null);

(statearr_15085_15116[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15076 === (2))){
var inst_15044 = (state_15075[(7)]);
var state_15075__$1 = state_15075;
if(cljs.core.truth_(inst_15044)){
var statearr_15086_15117 = state_15075__$1;
(statearr_15086_15117[(1)] = (4));

} else {
var statearr_15087_15118 = state_15075__$1;
(statearr_15087_15118[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15076 === (11))){
var inst_15066 = cljs.core.async.close_BANG_.call(null,ch);
var state_15075__$1 = state_15075;
var statearr_15088_15119 = state_15075__$1;
(statearr_15088_15119[(2)] = inst_15066);

(statearr_15088_15119[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15076 === (9))){
var state_15075__$1 = state_15075;
if(cljs.core.truth_(close_QMARK_)){
var statearr_15089_15120 = state_15075__$1;
(statearr_15089_15120[(1)] = (11));

} else {
var statearr_15091_15121 = state_15075__$1;
(statearr_15091_15121[(1)] = (12));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15076 === (5))){
var inst_15044 = (state_15075[(7)]);
var state_15075__$1 = state_15075;
var statearr_15092_15122 = state_15075__$1;
(statearr_15092_15122[(2)] = inst_15044);

(statearr_15092_15122[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15076 === (10))){
var inst_15071 = (state_15075[(2)]);
var state_15075__$1 = state_15075;
var statearr_15093_15123 = state_15075__$1;
(statearr_15093_15123[(2)] = inst_15071);

(statearr_15093_15123[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15076 === (8))){
var inst_15044 = (state_15075[(7)]);
var inst_15062 = cljs.core.next.call(null,inst_15044);
var inst_15044__$1 = inst_15062;
var state_15075__$1 = (function (){var statearr_15094 = state_15075;
(statearr_15094[(7)] = inst_15044__$1);

return statearr_15094;
})();
var statearr_15095_15124 = state_15075__$1;
(statearr_15095_15124[(2)] = null);

(statearr_15095_15124[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__13923__auto__))
;
return ((function (switch__13908__auto__,c__13923__auto__){
return (function() {
var cljs$core$async$state_machine__13909__auto__ = null;
var cljs$core$async$state_machine__13909__auto____0 = (function (){
var statearr_15103 = [null,null,null,null,null,null,null,null];
(statearr_15103[(0)] = cljs$core$async$state_machine__13909__auto__);

(statearr_15103[(1)] = (1));

return statearr_15103;
});
var cljs$core$async$state_machine__13909__auto____1 = (function (state_15075){
while(true){
var ret_value__13910__auto__ = (function (){try{while(true){
var result__13911__auto__ = switch__13908__auto__.call(null,state_15075);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13911__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13911__auto__;
}
break;
}
}catch (e15104){if((e15104 instanceof Object)){
var ex__13912__auto__ = e15104;
var statearr_15105_15125 = state_15075;
(statearr_15105_15125[(5)] = ex__13912__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_15075);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e15104;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13910__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__15126 = state_15075;
state_15075 = G__15126;
continue;
} else {
return ret_value__13910__auto__;
}
break;
}
});
cljs$core$async$state_machine__13909__auto__ = function(state_15075){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__13909__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__13909__auto____1.call(this,state_15075);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__13909__auto____0;
cljs$core$async$state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__13909__auto____1;
return cljs$core$async$state_machine__13909__auto__;
})()
;})(switch__13908__auto__,c__13923__auto__))
})();
var state__13925__auto__ = (function (){var statearr_15106 = f__13924__auto__.call(null);
(statearr_15106[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13923__auto__);

return statearr_15106;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13925__auto__);
});})(c__13923__auto__))
);

return c__13923__auto__;
});

cljs.core.async.onto_chan.cljs$lang$maxFixedArity = 3;

/**
 * Creates and returns a channel which contains the contents of coll,
 *   closing when exhausted.
 */
cljs.core.async.to_chan = (function cljs$core$async$to_chan(coll){
var ch = cljs.core.async.chan.call(null,cljs.core.bounded_count.call(null,(100),coll));
cljs.core.async.onto_chan.call(null,ch,coll);

return ch;
});

/**
 * @interface
 */
cljs.core.async.Mux = function(){};

cljs.core.async.muxch_STAR_ = (function cljs$core$async$muxch_STAR_(_){
if((!((_ == null))) && (!((_.cljs$core$async$Mux$muxch_STAR_$arity$1 == null)))){
return _.cljs$core$async$Mux$muxch_STAR_$arity$1(_);
} else {
var x__7206__auto__ = (((_ == null))?null:_);
var m__7207__auto__ = (cljs.core.async.muxch_STAR_[goog.typeOf(x__7206__auto__)]);
if(!((m__7207__auto__ == null))){
return m__7207__auto__.call(null,_);
} else {
var m__7207__auto____$1 = (cljs.core.async.muxch_STAR_["_"]);
if(!((m__7207__auto____$1 == null))){
return m__7207__auto____$1.call(null,_);
} else {
throw cljs.core.missing_protocol.call(null,"Mux.muxch*",_);
}
}
}
});


/**
 * @interface
 */
cljs.core.async.Mult = function(){};

cljs.core.async.tap_STAR_ = (function cljs$core$async$tap_STAR_(m,ch,close_QMARK_){
if((!((m == null))) && (!((m.cljs$core$async$Mult$tap_STAR_$arity$3 == null)))){
return m.cljs$core$async$Mult$tap_STAR_$arity$3(m,ch,close_QMARK_);
} else {
var x__7206__auto__ = (((m == null))?null:m);
var m__7207__auto__ = (cljs.core.async.tap_STAR_[goog.typeOf(x__7206__auto__)]);
if(!((m__7207__auto__ == null))){
return m__7207__auto__.call(null,m,ch,close_QMARK_);
} else {
var m__7207__auto____$1 = (cljs.core.async.tap_STAR_["_"]);
if(!((m__7207__auto____$1 == null))){
return m__7207__auto____$1.call(null,m,ch,close_QMARK_);
} else {
throw cljs.core.missing_protocol.call(null,"Mult.tap*",m);
}
}
}
});

cljs.core.async.untap_STAR_ = (function cljs$core$async$untap_STAR_(m,ch){
if((!((m == null))) && (!((m.cljs$core$async$Mult$untap_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mult$untap_STAR_$arity$2(m,ch);
} else {
var x__7206__auto__ = (((m == null))?null:m);
var m__7207__auto__ = (cljs.core.async.untap_STAR_[goog.typeOf(x__7206__auto__)]);
if(!((m__7207__auto__ == null))){
return m__7207__auto__.call(null,m,ch);
} else {
var m__7207__auto____$1 = (cljs.core.async.untap_STAR_["_"]);
if(!((m__7207__auto____$1 == null))){
return m__7207__auto____$1.call(null,m,ch);
} else {
throw cljs.core.missing_protocol.call(null,"Mult.untap*",m);
}
}
}
});

cljs.core.async.untap_all_STAR_ = (function cljs$core$async$untap_all_STAR_(m){
if((!((m == null))) && (!((m.cljs$core$async$Mult$untap_all_STAR_$arity$1 == null)))){
return m.cljs$core$async$Mult$untap_all_STAR_$arity$1(m);
} else {
var x__7206__auto__ = (((m == null))?null:m);
var m__7207__auto__ = (cljs.core.async.untap_all_STAR_[goog.typeOf(x__7206__auto__)]);
if(!((m__7207__auto__ == null))){
return m__7207__auto__.call(null,m);
} else {
var m__7207__auto____$1 = (cljs.core.async.untap_all_STAR_["_"]);
if(!((m__7207__auto____$1 == null))){
return m__7207__auto____$1.call(null,m);
} else {
throw cljs.core.missing_protocol.call(null,"Mult.untap-all*",m);
}
}
}
});

/**
 * Creates and returns a mult(iple) of the supplied channel. Channels
 *   containing copies of the channel can be created with 'tap', and
 *   detached with 'untap'.
 * 
 *   Each item is distributed to all taps in parallel and synchronously,
 *   i.e. each tap must accept before the next item is distributed. Use
 *   buffering/windowing to prevent slow taps from holding up the mult.
 * 
 *   Items received when there are no taps get dropped.
 * 
 *   If a tap puts to a closed channel, it will be removed from the mult.
 */
cljs.core.async.mult = (function cljs$core$async$mult(ch){
var cs = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var m = (function (){
if(typeof cljs.core.async.t_cljs$core$async15401 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.Mult}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async15401 = (function (ch,cs,meta15402){
this.ch = ch;
this.cs = cs;
this.meta15402 = meta15402;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async15401.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (cs){
return (function (_15403,meta15402__$1){
var self__ = this;
var _15403__$1 = this;
return (new cljs.core.async.t_cljs$core$async15401(self__.ch,self__.cs,meta15402__$1));
});})(cs))
;

cljs.core.async.t_cljs$core$async15401.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (cs){
return (function (_15403){
var self__ = this;
var _15403__$1 = this;
return self__.meta15402;
});})(cs))
;

cljs.core.async.t_cljs$core$async15401.prototype.cljs$core$async$Mux$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async15401.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (cs){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.ch;
});})(cs))
;

cljs.core.async.t_cljs$core$async15401.prototype.cljs$core$async$Mult$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async15401.prototype.cljs$core$async$Mult$tap_STAR_$arity$3 = ((function (cs){
return (function (_,ch__$1,close_QMARK_){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.assoc,ch__$1,close_QMARK_);

return null;
});})(cs))
;

cljs.core.async.t_cljs$core$async15401.prototype.cljs$core$async$Mult$untap_STAR_$arity$2 = ((function (cs){
return (function (_,ch__$1){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.dissoc,ch__$1);

return null;
});})(cs))
;

cljs.core.async.t_cljs$core$async15401.prototype.cljs$core$async$Mult$untap_all_STAR_$arity$1 = ((function (cs){
return (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.reset_BANG_.call(null,self__.cs,cljs.core.PersistentArrayMap.EMPTY);

return null;
});})(cs))
;

cljs.core.async.t_cljs$core$async15401.getBasis = ((function (cs){
return (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"cs","cs",-117024463,null),new cljs.core.Symbol(null,"meta15402","meta15402",635172750,null)], null);
});})(cs))
;

cljs.core.async.t_cljs$core$async15401.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async15401.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async15401";

cljs.core.async.t_cljs$core$async15401.cljs$lang$ctorPrWriter = ((function (cs){
return (function (this__7149__auto__,writer__7150__auto__,opt__7151__auto__){
return cljs.core._write.call(null,writer__7150__auto__,"cljs.core.async/t_cljs$core$async15401");
});})(cs))
;

cljs.core.async.__GT_t_cljs$core$async15401 = ((function (cs){
return (function cljs$core$async$mult_$___GT_t_cljs$core$async15401(ch__$1,cs__$1,meta15402){
return (new cljs.core.async.t_cljs$core$async15401(ch__$1,cs__$1,meta15402));
});})(cs))
;

}

return (new cljs.core.async.t_cljs$core$async15401(ch,cs,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var dchan = cljs.core.async.chan.call(null,(1));
var dctr = cljs.core.atom.call(null,null);
var done = ((function (cs,m,dchan,dctr){
return (function (_){
if((cljs.core.swap_BANG_.call(null,dctr,cljs.core.dec) === (0))){
return cljs.core.async.put_BANG_.call(null,dchan,true);
} else {
return null;
}
});})(cs,m,dchan,dctr))
;
var c__13923__auto___15640 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13923__auto___15640,cs,m,dchan,dctr,done){
return (function (){
var f__13924__auto__ = (function (){var switch__13908__auto__ = ((function (c__13923__auto___15640,cs,m,dchan,dctr,done){
return (function (state_15544){
var state_val_15545 = (state_15544[(1)]);
if((state_val_15545 === (7))){
var inst_15540 = (state_15544[(2)]);
var state_15544__$1 = state_15544;
var statearr_15546_15645 = state_15544__$1;
(statearr_15546_15645[(2)] = inst_15540);

(statearr_15546_15645[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15545 === (20))){
var inst_15437 = (state_15544[(7)]);
var inst_15452 = cljs.core.first.call(null,inst_15437);
var inst_15453 = cljs.core.nth.call(null,inst_15452,(0),null);
var inst_15454 = cljs.core.nth.call(null,inst_15452,(1),null);
var state_15544__$1 = (function (){var statearr_15550 = state_15544;
(statearr_15550[(8)] = inst_15453);

return statearr_15550;
})();
if(cljs.core.truth_(inst_15454)){
var statearr_15551_15646 = state_15544__$1;
(statearr_15551_15646[(1)] = (22));

} else {
var statearr_15552_15647 = state_15544__$1;
(statearr_15552_15647[(1)] = (23));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15545 === (27))){
var inst_15406 = (state_15544[(9)]);
var inst_15484 = (state_15544[(10)]);
var inst_15489 = (state_15544[(11)]);
var inst_15482 = (state_15544[(12)]);
var inst_15489__$1 = cljs.core._nth.call(null,inst_15482,inst_15484);
var inst_15490 = cljs.core.async.put_BANG_.call(null,inst_15489__$1,inst_15406,done);
var state_15544__$1 = (function (){var statearr_15553 = state_15544;
(statearr_15553[(11)] = inst_15489__$1);

return statearr_15553;
})();
if(cljs.core.truth_(inst_15490)){
var statearr_15554_15648 = state_15544__$1;
(statearr_15554_15648[(1)] = (30));

} else {
var statearr_15555_15649 = state_15544__$1;
(statearr_15555_15649[(1)] = (31));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15545 === (1))){
var state_15544__$1 = state_15544;
var statearr_15559_15650 = state_15544__$1;
(statearr_15559_15650[(2)] = null);

(statearr_15559_15650[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15545 === (24))){
var inst_15437 = (state_15544[(7)]);
var inst_15459 = (state_15544[(2)]);
var inst_15460 = cljs.core.next.call(null,inst_15437);
var inst_15415 = inst_15460;
var inst_15416 = null;
var inst_15417 = (0);
var inst_15418 = (0);
var state_15544__$1 = (function (){var statearr_15560 = state_15544;
(statearr_15560[(13)] = inst_15417);

(statearr_15560[(14)] = inst_15416);

(statearr_15560[(15)] = inst_15418);

(statearr_15560[(16)] = inst_15415);

(statearr_15560[(17)] = inst_15459);

return statearr_15560;
})();
var statearr_15561_15657 = state_15544__$1;
(statearr_15561_15657[(2)] = null);

(statearr_15561_15657[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15545 === (39))){
var state_15544__$1 = state_15544;
var statearr_15565_15658 = state_15544__$1;
(statearr_15565_15658[(2)] = null);

(statearr_15565_15658[(1)] = (41));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15545 === (4))){
var inst_15406 = (state_15544[(9)]);
var inst_15406__$1 = (state_15544[(2)]);
var inst_15407 = (inst_15406__$1 == null);
var state_15544__$1 = (function (){var statearr_15566 = state_15544;
(statearr_15566[(9)] = inst_15406__$1);

return statearr_15566;
})();
if(cljs.core.truth_(inst_15407)){
var statearr_15567_15659 = state_15544__$1;
(statearr_15567_15659[(1)] = (5));

} else {
var statearr_15568_15660 = state_15544__$1;
(statearr_15568_15660[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15545 === (15))){
var inst_15417 = (state_15544[(13)]);
var inst_15416 = (state_15544[(14)]);
var inst_15418 = (state_15544[(15)]);
var inst_15415 = (state_15544[(16)]);
var inst_15433 = (state_15544[(2)]);
var inst_15434 = (inst_15418 + (1));
var tmp15562 = inst_15417;
var tmp15563 = inst_15416;
var tmp15564 = inst_15415;
var inst_15415__$1 = tmp15564;
var inst_15416__$1 = tmp15563;
var inst_15417__$1 = tmp15562;
var inst_15418__$1 = inst_15434;
var state_15544__$1 = (function (){var statearr_15569 = state_15544;
(statearr_15569[(13)] = inst_15417__$1);

(statearr_15569[(14)] = inst_15416__$1);

(statearr_15569[(15)] = inst_15418__$1);

(statearr_15569[(16)] = inst_15415__$1);

(statearr_15569[(18)] = inst_15433);

return statearr_15569;
})();
var statearr_15570_15661 = state_15544__$1;
(statearr_15570_15661[(2)] = null);

(statearr_15570_15661[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15545 === (21))){
var inst_15463 = (state_15544[(2)]);
var state_15544__$1 = state_15544;
var statearr_15574_15662 = state_15544__$1;
(statearr_15574_15662[(2)] = inst_15463);

(statearr_15574_15662[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15545 === (31))){
var inst_15489 = (state_15544[(11)]);
var inst_15493 = done.call(null,null);
var inst_15494 = cljs.core.async.untap_STAR_.call(null,m,inst_15489);
var state_15544__$1 = (function (){var statearr_15575 = state_15544;
(statearr_15575[(19)] = inst_15493);

return statearr_15575;
})();
var statearr_15576_15663 = state_15544__$1;
(statearr_15576_15663[(2)] = inst_15494);

(statearr_15576_15663[(1)] = (32));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15545 === (32))){
var inst_15484 = (state_15544[(10)]);
var inst_15481 = (state_15544[(20)]);
var inst_15483 = (state_15544[(21)]);
var inst_15482 = (state_15544[(12)]);
var inst_15496 = (state_15544[(2)]);
var inst_15497 = (inst_15484 + (1));
var tmp15571 = inst_15481;
var tmp15572 = inst_15483;
var tmp15573 = inst_15482;
var inst_15481__$1 = tmp15571;
var inst_15482__$1 = tmp15573;
var inst_15483__$1 = tmp15572;
var inst_15484__$1 = inst_15497;
var state_15544__$1 = (function (){var statearr_15577 = state_15544;
(statearr_15577[(10)] = inst_15484__$1);

(statearr_15577[(22)] = inst_15496);

(statearr_15577[(20)] = inst_15481__$1);

(statearr_15577[(21)] = inst_15483__$1);

(statearr_15577[(12)] = inst_15482__$1);

return statearr_15577;
})();
var statearr_15578_15664 = state_15544__$1;
(statearr_15578_15664[(2)] = null);

(statearr_15578_15664[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15545 === (40))){
var inst_15512 = (state_15544[(23)]);
var inst_15516 = done.call(null,null);
var inst_15517 = cljs.core.async.untap_STAR_.call(null,m,inst_15512);
var state_15544__$1 = (function (){var statearr_15579 = state_15544;
(statearr_15579[(24)] = inst_15516);

return statearr_15579;
})();
var statearr_15580_15665 = state_15544__$1;
(statearr_15580_15665[(2)] = inst_15517);

(statearr_15580_15665[(1)] = (41));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15545 === (33))){
var inst_15500 = (state_15544[(25)]);
var inst_15502 = cljs.core.chunked_seq_QMARK_.call(null,inst_15500);
var state_15544__$1 = state_15544;
if(inst_15502){
var statearr_15581_15666 = state_15544__$1;
(statearr_15581_15666[(1)] = (36));

} else {
var statearr_15582_15667 = state_15544__$1;
(statearr_15582_15667[(1)] = (37));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15545 === (13))){
var inst_15427 = (state_15544[(26)]);
var inst_15430 = cljs.core.async.close_BANG_.call(null,inst_15427);
var state_15544__$1 = state_15544;
var statearr_15583_15668 = state_15544__$1;
(statearr_15583_15668[(2)] = inst_15430);

(statearr_15583_15668[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15545 === (22))){
var inst_15453 = (state_15544[(8)]);
var inst_15456 = cljs.core.async.close_BANG_.call(null,inst_15453);
var state_15544__$1 = state_15544;
var statearr_15584_15669 = state_15544__$1;
(statearr_15584_15669[(2)] = inst_15456);

(statearr_15584_15669[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15545 === (36))){
var inst_15500 = (state_15544[(25)]);
var inst_15507 = cljs.core.chunk_first.call(null,inst_15500);
var inst_15508 = cljs.core.chunk_rest.call(null,inst_15500);
var inst_15509 = cljs.core.count.call(null,inst_15507);
var inst_15481 = inst_15508;
var inst_15482 = inst_15507;
var inst_15483 = inst_15509;
var inst_15484 = (0);
var state_15544__$1 = (function (){var statearr_15585 = state_15544;
(statearr_15585[(10)] = inst_15484);

(statearr_15585[(20)] = inst_15481);

(statearr_15585[(21)] = inst_15483);

(statearr_15585[(12)] = inst_15482);

return statearr_15585;
})();
var statearr_15586_15670 = state_15544__$1;
(statearr_15586_15670[(2)] = null);

(statearr_15586_15670[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15545 === (41))){
var inst_15500 = (state_15544[(25)]);
var inst_15519 = (state_15544[(2)]);
var inst_15520 = cljs.core.next.call(null,inst_15500);
var inst_15481 = inst_15520;
var inst_15482 = null;
var inst_15483 = (0);
var inst_15484 = (0);
var state_15544__$1 = (function (){var statearr_15587 = state_15544;
(statearr_15587[(27)] = inst_15519);

(statearr_15587[(10)] = inst_15484);

(statearr_15587[(20)] = inst_15481);

(statearr_15587[(21)] = inst_15483);

(statearr_15587[(12)] = inst_15482);

return statearr_15587;
})();
var statearr_15588_15671 = state_15544__$1;
(statearr_15588_15671[(2)] = null);

(statearr_15588_15671[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15545 === (43))){
var state_15544__$1 = state_15544;
var statearr_15589_15672 = state_15544__$1;
(statearr_15589_15672[(2)] = null);

(statearr_15589_15672[(1)] = (44));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15545 === (29))){
var inst_15528 = (state_15544[(2)]);
var state_15544__$1 = state_15544;
var statearr_15590_15673 = state_15544__$1;
(statearr_15590_15673[(2)] = inst_15528);

(statearr_15590_15673[(1)] = (26));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15545 === (44))){
var inst_15537 = (state_15544[(2)]);
var state_15544__$1 = (function (){var statearr_15591 = state_15544;
(statearr_15591[(28)] = inst_15537);

return statearr_15591;
})();
var statearr_15592_15674 = state_15544__$1;
(statearr_15592_15674[(2)] = null);

(statearr_15592_15674[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15545 === (6))){
var inst_15473 = (state_15544[(29)]);
var inst_15472 = cljs.core.deref.call(null,cs);
var inst_15473__$1 = cljs.core.keys.call(null,inst_15472);
var inst_15474 = cljs.core.count.call(null,inst_15473__$1);
var inst_15475 = cljs.core.reset_BANG_.call(null,dctr,inst_15474);
var inst_15480 = cljs.core.seq.call(null,inst_15473__$1);
var inst_15481 = inst_15480;
var inst_15482 = null;
var inst_15483 = (0);
var inst_15484 = (0);
var state_15544__$1 = (function (){var statearr_15593 = state_15544;
(statearr_15593[(29)] = inst_15473__$1);

(statearr_15593[(30)] = inst_15475);

(statearr_15593[(10)] = inst_15484);

(statearr_15593[(20)] = inst_15481);

(statearr_15593[(21)] = inst_15483);

(statearr_15593[(12)] = inst_15482);

return statearr_15593;
})();
var statearr_15594_15675 = state_15544__$1;
(statearr_15594_15675[(2)] = null);

(statearr_15594_15675[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15545 === (28))){
var inst_15500 = (state_15544[(25)]);
var inst_15481 = (state_15544[(20)]);
var inst_15500__$1 = cljs.core.seq.call(null,inst_15481);
var state_15544__$1 = (function (){var statearr_15595 = state_15544;
(statearr_15595[(25)] = inst_15500__$1);

return statearr_15595;
})();
if(inst_15500__$1){
var statearr_15596_15676 = state_15544__$1;
(statearr_15596_15676[(1)] = (33));

} else {
var statearr_15597_15677 = state_15544__$1;
(statearr_15597_15677[(1)] = (34));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15545 === (25))){
var inst_15484 = (state_15544[(10)]);
var inst_15483 = (state_15544[(21)]);
var inst_15486 = (inst_15484 < inst_15483);
var inst_15487 = inst_15486;
var state_15544__$1 = state_15544;
if(cljs.core.truth_(inst_15487)){
var statearr_15598_15678 = state_15544__$1;
(statearr_15598_15678[(1)] = (27));

} else {
var statearr_15599_15679 = state_15544__$1;
(statearr_15599_15679[(1)] = (28));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15545 === (34))){
var state_15544__$1 = state_15544;
var statearr_15600_15680 = state_15544__$1;
(statearr_15600_15680[(2)] = null);

(statearr_15600_15680[(1)] = (35));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15545 === (17))){
var state_15544__$1 = state_15544;
var statearr_15601_15681 = state_15544__$1;
(statearr_15601_15681[(2)] = null);

(statearr_15601_15681[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15545 === (3))){
var inst_15542 = (state_15544[(2)]);
var state_15544__$1 = state_15544;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_15544__$1,inst_15542);
} else {
if((state_val_15545 === (12))){
var inst_15468 = (state_15544[(2)]);
var state_15544__$1 = state_15544;
var statearr_15602_15682 = state_15544__$1;
(statearr_15602_15682[(2)] = inst_15468);

(statearr_15602_15682[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15545 === (2))){
var state_15544__$1 = state_15544;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_15544__$1,(4),ch);
} else {
if((state_val_15545 === (23))){
var state_15544__$1 = state_15544;
var statearr_15603_15683 = state_15544__$1;
(statearr_15603_15683[(2)] = null);

(statearr_15603_15683[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15545 === (35))){
var inst_15526 = (state_15544[(2)]);
var state_15544__$1 = state_15544;
var statearr_15604_15684 = state_15544__$1;
(statearr_15604_15684[(2)] = inst_15526);

(statearr_15604_15684[(1)] = (29));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15545 === (19))){
var inst_15437 = (state_15544[(7)]);
var inst_15441 = cljs.core.chunk_first.call(null,inst_15437);
var inst_15445 = cljs.core.chunk_rest.call(null,inst_15437);
var inst_15446 = cljs.core.count.call(null,inst_15441);
var inst_15415 = inst_15445;
var inst_15416 = inst_15441;
var inst_15417 = inst_15446;
var inst_15418 = (0);
var state_15544__$1 = (function (){var statearr_15605 = state_15544;
(statearr_15605[(13)] = inst_15417);

(statearr_15605[(14)] = inst_15416);

(statearr_15605[(15)] = inst_15418);

(statearr_15605[(16)] = inst_15415);

return statearr_15605;
})();
var statearr_15606_15686 = state_15544__$1;
(statearr_15606_15686[(2)] = null);

(statearr_15606_15686[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15545 === (11))){
var inst_15415 = (state_15544[(16)]);
var inst_15437 = (state_15544[(7)]);
var inst_15437__$1 = cljs.core.seq.call(null,inst_15415);
var state_15544__$1 = (function (){var statearr_15607 = state_15544;
(statearr_15607[(7)] = inst_15437__$1);

return statearr_15607;
})();
if(inst_15437__$1){
var statearr_15608_15687 = state_15544__$1;
(statearr_15608_15687[(1)] = (16));

} else {
var statearr_15609_15688 = state_15544__$1;
(statearr_15609_15688[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15545 === (9))){
var inst_15470 = (state_15544[(2)]);
var state_15544__$1 = state_15544;
var statearr_15610_15689 = state_15544__$1;
(statearr_15610_15689[(2)] = inst_15470);

(statearr_15610_15689[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15545 === (5))){
var inst_15413 = cljs.core.deref.call(null,cs);
var inst_15414 = cljs.core.seq.call(null,inst_15413);
var inst_15415 = inst_15414;
var inst_15416 = null;
var inst_15417 = (0);
var inst_15418 = (0);
var state_15544__$1 = (function (){var statearr_15611 = state_15544;
(statearr_15611[(13)] = inst_15417);

(statearr_15611[(14)] = inst_15416);

(statearr_15611[(15)] = inst_15418);

(statearr_15611[(16)] = inst_15415);

return statearr_15611;
})();
var statearr_15612_15692 = state_15544__$1;
(statearr_15612_15692[(2)] = null);

(statearr_15612_15692[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15545 === (14))){
var state_15544__$1 = state_15544;
var statearr_15613_15694 = state_15544__$1;
(statearr_15613_15694[(2)] = null);

(statearr_15613_15694[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15545 === (45))){
var inst_15534 = (state_15544[(2)]);
var state_15544__$1 = state_15544;
var statearr_15614_15696 = state_15544__$1;
(statearr_15614_15696[(2)] = inst_15534);

(statearr_15614_15696[(1)] = (44));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15545 === (26))){
var inst_15473 = (state_15544[(29)]);
var inst_15530 = (state_15544[(2)]);
var inst_15531 = cljs.core.seq.call(null,inst_15473);
var state_15544__$1 = (function (){var statearr_15615 = state_15544;
(statearr_15615[(31)] = inst_15530);

return statearr_15615;
})();
if(inst_15531){
var statearr_15616_15697 = state_15544__$1;
(statearr_15616_15697[(1)] = (42));

} else {
var statearr_15617_15698 = state_15544__$1;
(statearr_15617_15698[(1)] = (43));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15545 === (16))){
var inst_15437 = (state_15544[(7)]);
var inst_15439 = cljs.core.chunked_seq_QMARK_.call(null,inst_15437);
var state_15544__$1 = state_15544;
if(inst_15439){
var statearr_15618_15699 = state_15544__$1;
(statearr_15618_15699[(1)] = (19));

} else {
var statearr_15619_15700 = state_15544__$1;
(statearr_15619_15700[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15545 === (38))){
var inst_15523 = (state_15544[(2)]);
var state_15544__$1 = state_15544;
var statearr_15620_15701 = state_15544__$1;
(statearr_15620_15701[(2)] = inst_15523);

(statearr_15620_15701[(1)] = (35));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15545 === (30))){
var state_15544__$1 = state_15544;
var statearr_15621_15702 = state_15544__$1;
(statearr_15621_15702[(2)] = null);

(statearr_15621_15702[(1)] = (32));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15545 === (10))){
var inst_15416 = (state_15544[(14)]);
var inst_15418 = (state_15544[(15)]);
var inst_15426 = cljs.core._nth.call(null,inst_15416,inst_15418);
var inst_15427 = cljs.core.nth.call(null,inst_15426,(0),null);
var inst_15428 = cljs.core.nth.call(null,inst_15426,(1),null);
var state_15544__$1 = (function (){var statearr_15622 = state_15544;
(statearr_15622[(26)] = inst_15427);

return statearr_15622;
})();
if(cljs.core.truth_(inst_15428)){
var statearr_15623_15703 = state_15544__$1;
(statearr_15623_15703[(1)] = (13));

} else {
var statearr_15624_15704 = state_15544__$1;
(statearr_15624_15704[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15545 === (18))){
var inst_15466 = (state_15544[(2)]);
var state_15544__$1 = state_15544;
var statearr_15625_15705 = state_15544__$1;
(statearr_15625_15705[(2)] = inst_15466);

(statearr_15625_15705[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15545 === (42))){
var state_15544__$1 = state_15544;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_15544__$1,(45),dchan);
} else {
if((state_val_15545 === (37))){
var inst_15512 = (state_15544[(23)]);
var inst_15500 = (state_15544[(25)]);
var inst_15406 = (state_15544[(9)]);
var inst_15512__$1 = cljs.core.first.call(null,inst_15500);
var inst_15513 = cljs.core.async.put_BANG_.call(null,inst_15512__$1,inst_15406,done);
var state_15544__$1 = (function (){var statearr_15626 = state_15544;
(statearr_15626[(23)] = inst_15512__$1);

return statearr_15626;
})();
if(cljs.core.truth_(inst_15513)){
var statearr_15627_15708 = state_15544__$1;
(statearr_15627_15708[(1)] = (39));

} else {
var statearr_15628_15709 = state_15544__$1;
(statearr_15628_15709[(1)] = (40));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15545 === (8))){
var inst_15417 = (state_15544[(13)]);
var inst_15418 = (state_15544[(15)]);
var inst_15420 = (inst_15418 < inst_15417);
var inst_15421 = inst_15420;
var state_15544__$1 = state_15544;
if(cljs.core.truth_(inst_15421)){
var statearr_15629_15710 = state_15544__$1;
(statearr_15629_15710[(1)] = (10));

} else {
var statearr_15630_15711 = state_15544__$1;
(statearr_15630_15711[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__13923__auto___15640,cs,m,dchan,dctr,done))
;
return ((function (switch__13908__auto__,c__13923__auto___15640,cs,m,dchan,dctr,done){
return (function() {
var cljs$core$async$mult_$_state_machine__13909__auto__ = null;
var cljs$core$async$mult_$_state_machine__13909__auto____0 = (function (){
var statearr_15634 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_15634[(0)] = cljs$core$async$mult_$_state_machine__13909__auto__);

(statearr_15634[(1)] = (1));

return statearr_15634;
});
var cljs$core$async$mult_$_state_machine__13909__auto____1 = (function (state_15544){
while(true){
var ret_value__13910__auto__ = (function (){try{while(true){
var result__13911__auto__ = switch__13908__auto__.call(null,state_15544);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13911__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13911__auto__;
}
break;
}
}catch (e15635){if((e15635 instanceof Object)){
var ex__13912__auto__ = e15635;
var statearr_15636_15712 = state_15544;
(statearr_15636_15712[(5)] = ex__13912__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_15544);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e15635;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13910__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__15713 = state_15544;
state_15544 = G__15713;
continue;
} else {
return ret_value__13910__auto__;
}
break;
}
});
cljs$core$async$mult_$_state_machine__13909__auto__ = function(state_15544){
switch(arguments.length){
case 0:
return cljs$core$async$mult_$_state_machine__13909__auto____0.call(this);
case 1:
return cljs$core$async$mult_$_state_machine__13909__auto____1.call(this,state_15544);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mult_$_state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mult_$_state_machine__13909__auto____0;
cljs$core$async$mult_$_state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mult_$_state_machine__13909__auto____1;
return cljs$core$async$mult_$_state_machine__13909__auto__;
})()
;})(switch__13908__auto__,c__13923__auto___15640,cs,m,dchan,dctr,done))
})();
var state__13925__auto__ = (function (){var statearr_15637 = f__13924__auto__.call(null);
(statearr_15637[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13923__auto___15640);

return statearr_15637;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13925__auto__);
});})(c__13923__auto___15640,cs,m,dchan,dctr,done))
);


return m;
});
/**
 * Copies the mult source onto the supplied channel.
 * 
 *   By default the channel will be closed when the source closes,
 *   but can be determined by the close? parameter.
 */
cljs.core.async.tap = (function cljs$core$async$tap(var_args){
var args15726 = [];
var len__7651__auto___15734 = arguments.length;
var i__7652__auto___15735 = (0);
while(true){
if((i__7652__auto___15735 < len__7651__auto___15734)){
args15726.push((arguments[i__7652__auto___15735]));

var G__15736 = (i__7652__auto___15735 + (1));
i__7652__auto___15735 = G__15736;
continue;
} else {
}
break;
}

var G__15732 = args15726.length;
switch (G__15732) {
case 2:
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args15726.length)].join('')));

}
});

cljs.core.async.tap.cljs$core$IFn$_invoke$arity$2 = (function (mult,ch){
return cljs.core.async.tap.call(null,mult,ch,true);
});

cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3 = (function (mult,ch,close_QMARK_){
cljs.core.async.tap_STAR_.call(null,mult,ch,close_QMARK_);

return ch;
});

cljs.core.async.tap.cljs$lang$maxFixedArity = 3;

/**
 * Disconnects a target channel from a mult
 */
cljs.core.async.untap = (function cljs$core$async$untap(mult,ch){
return cljs.core.async.untap_STAR_.call(null,mult,ch);
});
/**
 * Disconnects all target channels from a mult
 */
cljs.core.async.untap_all = (function cljs$core$async$untap_all(mult){
return cljs.core.async.untap_all_STAR_.call(null,mult);
});

/**
 * @interface
 */
cljs.core.async.Mix = function(){};

cljs.core.async.admix_STAR_ = (function cljs$core$async$admix_STAR_(m,ch){
if((!((m == null))) && (!((m.cljs$core$async$Mix$admix_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mix$admix_STAR_$arity$2(m,ch);
} else {
var x__7206__auto__ = (((m == null))?null:m);
var m__7207__auto__ = (cljs.core.async.admix_STAR_[goog.typeOf(x__7206__auto__)]);
if(!((m__7207__auto__ == null))){
return m__7207__auto__.call(null,m,ch);
} else {
var m__7207__auto____$1 = (cljs.core.async.admix_STAR_["_"]);
if(!((m__7207__auto____$1 == null))){
return m__7207__auto____$1.call(null,m,ch);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.admix*",m);
}
}
}
});

cljs.core.async.unmix_STAR_ = (function cljs$core$async$unmix_STAR_(m,ch){
if((!((m == null))) && (!((m.cljs$core$async$Mix$unmix_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mix$unmix_STAR_$arity$2(m,ch);
} else {
var x__7206__auto__ = (((m == null))?null:m);
var m__7207__auto__ = (cljs.core.async.unmix_STAR_[goog.typeOf(x__7206__auto__)]);
if(!((m__7207__auto__ == null))){
return m__7207__auto__.call(null,m,ch);
} else {
var m__7207__auto____$1 = (cljs.core.async.unmix_STAR_["_"]);
if(!((m__7207__auto____$1 == null))){
return m__7207__auto____$1.call(null,m,ch);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.unmix*",m);
}
}
}
});

cljs.core.async.unmix_all_STAR_ = (function cljs$core$async$unmix_all_STAR_(m){
if((!((m == null))) && (!((m.cljs$core$async$Mix$unmix_all_STAR_$arity$1 == null)))){
return m.cljs$core$async$Mix$unmix_all_STAR_$arity$1(m);
} else {
var x__7206__auto__ = (((m == null))?null:m);
var m__7207__auto__ = (cljs.core.async.unmix_all_STAR_[goog.typeOf(x__7206__auto__)]);
if(!((m__7207__auto__ == null))){
return m__7207__auto__.call(null,m);
} else {
var m__7207__auto____$1 = (cljs.core.async.unmix_all_STAR_["_"]);
if(!((m__7207__auto____$1 == null))){
return m__7207__auto____$1.call(null,m);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.unmix-all*",m);
}
}
}
});

cljs.core.async.toggle_STAR_ = (function cljs$core$async$toggle_STAR_(m,state_map){
if((!((m == null))) && (!((m.cljs$core$async$Mix$toggle_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mix$toggle_STAR_$arity$2(m,state_map);
} else {
var x__7206__auto__ = (((m == null))?null:m);
var m__7207__auto__ = (cljs.core.async.toggle_STAR_[goog.typeOf(x__7206__auto__)]);
if(!((m__7207__auto__ == null))){
return m__7207__auto__.call(null,m,state_map);
} else {
var m__7207__auto____$1 = (cljs.core.async.toggle_STAR_["_"]);
if(!((m__7207__auto____$1 == null))){
return m__7207__auto____$1.call(null,m,state_map);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.toggle*",m);
}
}
}
});

cljs.core.async.solo_mode_STAR_ = (function cljs$core$async$solo_mode_STAR_(m,mode){
if((!((m == null))) && (!((m.cljs$core$async$Mix$solo_mode_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mix$solo_mode_STAR_$arity$2(m,mode);
} else {
var x__7206__auto__ = (((m == null))?null:m);
var m__7207__auto__ = (cljs.core.async.solo_mode_STAR_[goog.typeOf(x__7206__auto__)]);
if(!((m__7207__auto__ == null))){
return m__7207__auto__.call(null,m,mode);
} else {
var m__7207__auto____$1 = (cljs.core.async.solo_mode_STAR_["_"]);
if(!((m__7207__auto____$1 == null))){
return m__7207__auto____$1.call(null,m,mode);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.solo-mode*",m);
}
}
}
});

cljs.core.async.ioc_alts_BANG_ = (function cljs$core$async$ioc_alts_BANG_(var_args){
var args__7658__auto__ = [];
var len__7651__auto___15769 = arguments.length;
var i__7652__auto___15770 = (0);
while(true){
if((i__7652__auto___15770 < len__7651__auto___15769)){
args__7658__auto__.push((arguments[i__7652__auto___15770]));

var G__15771 = (i__7652__auto___15770 + (1));
i__7652__auto___15770 = G__15771;
continue;
} else {
}
break;
}

var argseq__7659__auto__ = ((((3) < args__7658__auto__.length))?(new cljs.core.IndexedSeq(args__7658__auto__.slice((3)),(0),null)):null);
return cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),argseq__7659__auto__);
});

cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (state,cont_block,ports,p__15760){
var map__15761 = p__15760;
var map__15761__$1 = ((((!((map__15761 == null)))?((((map__15761.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__15761.cljs$core$ISeq$)))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__15761):map__15761);
var opts = map__15761__$1;
var statearr_15763_15772 = state;
(statearr_15763_15772[cljs.core.async.impl.ioc_helpers.STATE_IDX] = cont_block);


var temp__4657__auto__ = cljs.core.async.do_alts.call(null,((function (map__15761,map__15761__$1,opts){
return (function (val){
var statearr_15766_15773 = state;
(statearr_15766_15773[cljs.core.async.impl.ioc_helpers.VALUE_IDX] = val);


return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state);
});})(map__15761,map__15761__$1,opts))
,ports,opts);
if(cljs.core.truth_(temp__4657__auto__)){
var cb = temp__4657__auto__;
var statearr_15767_15774 = state;
(statearr_15767_15774[cljs.core.async.impl.ioc_helpers.VALUE_IDX] = cljs.core.deref.call(null,cb));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
});

cljs.core.async.ioc_alts_BANG_.cljs$lang$maxFixedArity = (3);

cljs.core.async.ioc_alts_BANG_.cljs$lang$applyTo = (function (seq15756){
var G__15757 = cljs.core.first.call(null,seq15756);
var seq15756__$1 = cljs.core.next.call(null,seq15756);
var G__15758 = cljs.core.first.call(null,seq15756__$1);
var seq15756__$2 = cljs.core.next.call(null,seq15756__$1);
var G__15759 = cljs.core.first.call(null,seq15756__$2);
var seq15756__$3 = cljs.core.next.call(null,seq15756__$2);
return cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic(G__15757,G__15758,G__15759,seq15756__$3);
});

/**
 * Creates and returns a mix of one or more input channels which will
 *   be put on the supplied out channel. Input sources can be added to
 *   the mix with 'admix', and removed with 'unmix'. A mix supports
 *   soloing, muting and pausing multiple inputs atomically using
 *   'toggle', and can solo using either muting or pausing as determined
 *   by 'solo-mode'.
 * 
 *   Each channel can have zero or more boolean modes set via 'toggle':
 * 
 *   :solo - when true, only this (ond other soloed) channel(s) will appear
 *        in the mix output channel. :mute and :pause states of soloed
 *        channels are ignored. If solo-mode is :mute, non-soloed
 *        channels are muted, if :pause, non-soloed channels are
 *        paused.
 * 
 *   :mute - muted channels will have their contents consumed but not included in the mix
 *   :pause - paused channels will not have their contents consumed (and thus also not included in the mix)
 */
cljs.core.async.mix = (function cljs$core$async$mix(out){
var cs = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var solo_modes = new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"pause","pause",-2095325672),null,new cljs.core.Keyword(null,"mute","mute",1151223646),null], null), null);
var attrs = cljs.core.conj.call(null,solo_modes,new cljs.core.Keyword(null,"solo","solo",-316350075));
var solo_mode = cljs.core.atom.call(null,new cljs.core.Keyword(null,"mute","mute",1151223646));
var change = cljs.core.async.chan.call(null);
var changed = ((function (cs,solo_modes,attrs,solo_mode,change){
return (function (){
return cljs.core.async.put_BANG_.call(null,change,true);
});})(cs,solo_modes,attrs,solo_mode,change))
;
var pick = ((function (cs,solo_modes,attrs,solo_mode,change,changed){
return (function (attr,chs){
return cljs.core.reduce_kv.call(null,((function (cs,solo_modes,attrs,solo_mode,change,changed){
return (function (ret,c,v){
if(cljs.core.truth_(attr.call(null,v))){
return cljs.core.conj.call(null,ret,c);
} else {
return ret;
}
});})(cs,solo_modes,attrs,solo_mode,change,changed))
,cljs.core.PersistentHashSet.EMPTY,chs);
});})(cs,solo_modes,attrs,solo_mode,change,changed))
;
var calc_state = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick){
return (function (){
var chs = cljs.core.deref.call(null,cs);
var mode = cljs.core.deref.call(null,solo_mode);
var solos = pick.call(null,new cljs.core.Keyword(null,"solo","solo",-316350075),chs);
var pauses = pick.call(null,new cljs.core.Keyword(null,"pause","pause",-2095325672),chs);
return new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"solos","solos",1441458643),solos,new cljs.core.Keyword(null,"mutes","mutes",1068806309),pick.call(null,new cljs.core.Keyword(null,"mute","mute",1151223646),chs),new cljs.core.Keyword(null,"reads","reads",-1215067361),cljs.core.conj.call(null,(((cljs.core._EQ_.call(null,mode,new cljs.core.Keyword(null,"pause","pause",-2095325672))) && (!(cljs.core.empty_QMARK_.call(null,solos))))?cljs.core.vec.call(null,solos):cljs.core.vec.call(null,cljs.core.remove.call(null,pauses,cljs.core.keys.call(null,chs)))),change)], null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick))
;
var m = (function (){
if(typeof cljs.core.async.t_cljs$core$async15950 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mix}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async15950 = (function (out,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,meta15951){
this.out = out;
this.cs = cs;
this.solo_modes = solo_modes;
this.attrs = attrs;
this.solo_mode = solo_mode;
this.change = change;
this.changed = changed;
this.pick = pick;
this.calc_state = calc_state;
this.meta15951 = meta15951;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async15950.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_15952,meta15951__$1){
var self__ = this;
var _15952__$1 = this;
return (new cljs.core.async.t_cljs$core$async15950(self__.out,self__.cs,self__.solo_modes,self__.attrs,self__.solo_mode,self__.change,self__.changed,self__.pick,self__.calc_state,meta15951__$1));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async15950.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_15952){
var self__ = this;
var _15952__$1 = this;
return self__.meta15951;
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async15950.prototype.cljs$core$async$Mux$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async15950.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.out;
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async15950.prototype.cljs$core$async$Mix$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async15950.prototype.cljs$core$async$Mix$admix_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,ch){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.assoc,ch,cljs.core.PersistentArrayMap.EMPTY);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async15950.prototype.cljs$core$async$Mix$unmix_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,ch){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.dissoc,ch);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async15950.prototype.cljs$core$async$Mix$unmix_all_STAR_$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.reset_BANG_.call(null,self__.cs,cljs.core.PersistentArrayMap.EMPTY);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async15950.prototype.cljs$core$async$Mix$toggle_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,state_map){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.partial.call(null,cljs.core.merge_with,cljs.core.merge),state_map);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async15950.prototype.cljs$core$async$Mix$solo_mode_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,mode){
var self__ = this;
var ___$1 = this;
if(cljs.core.truth_(self__.solo_modes.call(null,mode))){
} else {
throw (new Error([cljs.core.str("Assert failed: "),cljs.core.str([cljs.core.str("mode must be one of: "),cljs.core.str(self__.solo_modes)].join('')),cljs.core.str("\n"),cljs.core.str("(solo-modes mode)")].join('')));
}

cljs.core.reset_BANG_.call(null,self__.solo_mode,mode);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async15950.getBasis = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (){
return new cljs.core.PersistentVector(null, 10, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"out","out",729986010,null),new cljs.core.Symbol(null,"cs","cs",-117024463,null),new cljs.core.Symbol(null,"solo-modes","solo-modes",882180540,null),new cljs.core.Symbol(null,"attrs","attrs",-450137186,null),new cljs.core.Symbol(null,"solo-mode","solo-mode",2031788074,null),new cljs.core.Symbol(null,"change","change",477485025,null),new cljs.core.Symbol(null,"changed","changed",-2083710852,null),new cljs.core.Symbol(null,"pick","pick",1300068175,null),new cljs.core.Symbol(null,"calc-state","calc-state",-349968968,null),new cljs.core.Symbol(null,"meta15951","meta15951",1051238096,null)], null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async15950.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async15950.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async15950";

cljs.core.async.t_cljs$core$async15950.cljs$lang$ctorPrWriter = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (this__7149__auto__,writer__7150__auto__,opt__7151__auto__){
return cljs.core._write.call(null,writer__7150__auto__,"cljs.core.async/t_cljs$core$async15950");
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.__GT_t_cljs$core$async15950 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function cljs$core$async$mix_$___GT_t_cljs$core$async15950(out__$1,cs__$1,solo_modes__$1,attrs__$1,solo_mode__$1,change__$1,changed__$1,pick__$1,calc_state__$1,meta15951){
return (new cljs.core.async.t_cljs$core$async15950(out__$1,cs__$1,solo_modes__$1,attrs__$1,solo_mode__$1,change__$1,changed__$1,pick__$1,calc_state__$1,meta15951));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

}

return (new cljs.core.async.t_cljs$core$async15950(out,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var c__13923__auto___16131 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13923__auto___16131,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function (){
var f__13924__auto__ = (function (){var switch__13908__auto__ = ((function (c__13923__auto___16131,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function (state_16057){
var state_val_16058 = (state_16057[(1)]);
if((state_val_16058 === (7))){
var inst_15969 = (state_16057[(2)]);
var state_16057__$1 = state_16057;
var statearr_16062_16151 = state_16057__$1;
(statearr_16062_16151[(2)] = inst_15969);

(statearr_16062_16151[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16058 === (20))){
var inst_15981 = (state_16057[(7)]);
var state_16057__$1 = state_16057;
var statearr_16063_16152 = state_16057__$1;
(statearr_16063_16152[(2)] = inst_15981);

(statearr_16063_16152[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16058 === (27))){
var state_16057__$1 = state_16057;
var statearr_16064_16153 = state_16057__$1;
(statearr_16064_16153[(2)] = null);

(statearr_16064_16153[(1)] = (28));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16058 === (1))){
var inst_15956 = (state_16057[(8)]);
var inst_15956__$1 = calc_state.call(null);
var inst_15958 = (inst_15956__$1 == null);
var inst_15959 = cljs.core.not.call(null,inst_15958);
var state_16057__$1 = (function (){var statearr_16065 = state_16057;
(statearr_16065[(8)] = inst_15956__$1);

return statearr_16065;
})();
if(inst_15959){
var statearr_16066_16154 = state_16057__$1;
(statearr_16066_16154[(1)] = (2));

} else {
var statearr_16067_16155 = state_16057__$1;
(statearr_16067_16155[(1)] = (3));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16058 === (24))){
var inst_16028 = (state_16057[(9)]);
var inst_16005 = (state_16057[(10)]);
var inst_16014 = (state_16057[(11)]);
var inst_16028__$1 = inst_16005.call(null,inst_16014);
var state_16057__$1 = (function (){var statearr_16068 = state_16057;
(statearr_16068[(9)] = inst_16028__$1);

return statearr_16068;
})();
if(cljs.core.truth_(inst_16028__$1)){
var statearr_16069_16162 = state_16057__$1;
(statearr_16069_16162[(1)] = (29));

} else {
var statearr_16070_16163 = state_16057__$1;
(statearr_16070_16163[(1)] = (30));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16058 === (4))){
var inst_15972 = (state_16057[(2)]);
var state_16057__$1 = state_16057;
if(cljs.core.truth_(inst_15972)){
var statearr_16071_16164 = state_16057__$1;
(statearr_16071_16164[(1)] = (8));

} else {
var statearr_16072_16165 = state_16057__$1;
(statearr_16072_16165[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16058 === (15))){
var inst_15999 = (state_16057[(2)]);
var state_16057__$1 = state_16057;
if(cljs.core.truth_(inst_15999)){
var statearr_16073_16166 = state_16057__$1;
(statearr_16073_16166[(1)] = (19));

} else {
var statearr_16074_16167 = state_16057__$1;
(statearr_16074_16167[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16058 === (21))){
var inst_16004 = (state_16057[(12)]);
var inst_16004__$1 = (state_16057[(2)]);
var inst_16005 = cljs.core.get.call(null,inst_16004__$1,new cljs.core.Keyword(null,"solos","solos",1441458643));
var inst_16006 = cljs.core.get.call(null,inst_16004__$1,new cljs.core.Keyword(null,"mutes","mutes",1068806309));
var inst_16007 = cljs.core.get.call(null,inst_16004__$1,new cljs.core.Keyword(null,"reads","reads",-1215067361));
var state_16057__$1 = (function (){var statearr_16075 = state_16057;
(statearr_16075[(10)] = inst_16005);

(statearr_16075[(12)] = inst_16004__$1);

(statearr_16075[(13)] = inst_16006);

return statearr_16075;
})();
return cljs.core.async.ioc_alts_BANG_.call(null,state_16057__$1,(22),inst_16007);
} else {
if((state_val_16058 === (31))){
var inst_16036 = (state_16057[(2)]);
var state_16057__$1 = state_16057;
if(cljs.core.truth_(inst_16036)){
var statearr_16076_16168 = state_16057__$1;
(statearr_16076_16168[(1)] = (32));

} else {
var statearr_16077_16169 = state_16057__$1;
(statearr_16077_16169[(1)] = (33));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16058 === (32))){
var inst_16013 = (state_16057[(14)]);
var state_16057__$1 = state_16057;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_16057__$1,(35),out,inst_16013);
} else {
if((state_val_16058 === (33))){
var inst_16004 = (state_16057[(12)]);
var inst_15981 = inst_16004;
var state_16057__$1 = (function (){var statearr_16078 = state_16057;
(statearr_16078[(7)] = inst_15981);

return statearr_16078;
})();
var statearr_16079_16173 = state_16057__$1;
(statearr_16079_16173[(2)] = null);

(statearr_16079_16173[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16058 === (13))){
var inst_15981 = (state_16057[(7)]);
var inst_15988 = inst_15981.cljs$lang$protocol_mask$partition0$;
var inst_15989 = (inst_15988 & (64));
var inst_15990 = inst_15981.cljs$core$ISeq$;
var inst_15991 = (cljs.core.PROTOCOL_SENTINEL === inst_15990);
var inst_15992 = (inst_15989) || (inst_15991);
var state_16057__$1 = state_16057;
if(cljs.core.truth_(inst_15992)){
var statearr_16080_16177 = state_16057__$1;
(statearr_16080_16177[(1)] = (16));

} else {
var statearr_16081_16178 = state_16057__$1;
(statearr_16081_16178[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16058 === (22))){
var inst_16013 = (state_16057[(14)]);
var inst_16014 = (state_16057[(11)]);
var inst_16012 = (state_16057[(2)]);
var inst_16013__$1 = cljs.core.nth.call(null,inst_16012,(0),null);
var inst_16014__$1 = cljs.core.nth.call(null,inst_16012,(1),null);
var inst_16015 = (inst_16013__$1 == null);
var inst_16016 = cljs.core._EQ_.call(null,inst_16014__$1,change);
var inst_16017 = (inst_16015) || (inst_16016);
var state_16057__$1 = (function (){var statearr_16082 = state_16057;
(statearr_16082[(14)] = inst_16013__$1);

(statearr_16082[(11)] = inst_16014__$1);

return statearr_16082;
})();
if(cljs.core.truth_(inst_16017)){
var statearr_16083_16179 = state_16057__$1;
(statearr_16083_16179[(1)] = (23));

} else {
var statearr_16084_16180 = state_16057__$1;
(statearr_16084_16180[(1)] = (24));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16058 === (36))){
var inst_16004 = (state_16057[(12)]);
var inst_15981 = inst_16004;
var state_16057__$1 = (function (){var statearr_16085 = state_16057;
(statearr_16085[(7)] = inst_15981);

return statearr_16085;
})();
var statearr_16086_16181 = state_16057__$1;
(statearr_16086_16181[(2)] = null);

(statearr_16086_16181[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16058 === (29))){
var inst_16028 = (state_16057[(9)]);
var state_16057__$1 = state_16057;
var statearr_16087_16182 = state_16057__$1;
(statearr_16087_16182[(2)] = inst_16028);

(statearr_16087_16182[(1)] = (31));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16058 === (6))){
var state_16057__$1 = state_16057;
var statearr_16088_16183 = state_16057__$1;
(statearr_16088_16183[(2)] = false);

(statearr_16088_16183[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16058 === (28))){
var inst_16024 = (state_16057[(2)]);
var inst_16025 = calc_state.call(null);
var inst_15981 = inst_16025;
var state_16057__$1 = (function (){var statearr_16089 = state_16057;
(statearr_16089[(15)] = inst_16024);

(statearr_16089[(7)] = inst_15981);

return statearr_16089;
})();
var statearr_16094_16185 = state_16057__$1;
(statearr_16094_16185[(2)] = null);

(statearr_16094_16185[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16058 === (25))){
var inst_16053 = (state_16057[(2)]);
var state_16057__$1 = state_16057;
var statearr_16095_16186 = state_16057__$1;
(statearr_16095_16186[(2)] = inst_16053);

(statearr_16095_16186[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16058 === (34))){
var inst_16051 = (state_16057[(2)]);
var state_16057__$1 = state_16057;
var statearr_16096_16188 = state_16057__$1;
(statearr_16096_16188[(2)] = inst_16051);

(statearr_16096_16188[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16058 === (17))){
var state_16057__$1 = state_16057;
var statearr_16097_16189 = state_16057__$1;
(statearr_16097_16189[(2)] = false);

(statearr_16097_16189[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16058 === (3))){
var state_16057__$1 = state_16057;
var statearr_16098_16190 = state_16057__$1;
(statearr_16098_16190[(2)] = false);

(statearr_16098_16190[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16058 === (12))){
var inst_16055 = (state_16057[(2)]);
var state_16057__$1 = state_16057;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_16057__$1,inst_16055);
} else {
if((state_val_16058 === (2))){
var inst_15956 = (state_16057[(8)]);
var inst_15961 = inst_15956.cljs$lang$protocol_mask$partition0$;
var inst_15962 = (inst_15961 & (64));
var inst_15963 = inst_15956.cljs$core$ISeq$;
var inst_15964 = (cljs.core.PROTOCOL_SENTINEL === inst_15963);
var inst_15965 = (inst_15962) || (inst_15964);
var state_16057__$1 = state_16057;
if(cljs.core.truth_(inst_15965)){
var statearr_16099_16191 = state_16057__$1;
(statearr_16099_16191[(1)] = (5));

} else {
var statearr_16100_16192 = state_16057__$1;
(statearr_16100_16192[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16058 === (23))){
var inst_16013 = (state_16057[(14)]);
var inst_16019 = (inst_16013 == null);
var state_16057__$1 = state_16057;
if(cljs.core.truth_(inst_16019)){
var statearr_16101_16193 = state_16057__$1;
(statearr_16101_16193[(1)] = (26));

} else {
var statearr_16102_16194 = state_16057__$1;
(statearr_16102_16194[(1)] = (27));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16058 === (35))){
var inst_16039 = (state_16057[(2)]);
var state_16057__$1 = state_16057;
if(cljs.core.truth_(inst_16039)){
var statearr_16103_16195 = state_16057__$1;
(statearr_16103_16195[(1)] = (36));

} else {
var statearr_16104_16196 = state_16057__$1;
(statearr_16104_16196[(1)] = (37));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16058 === (19))){
var inst_15981 = (state_16057[(7)]);
var inst_16001 = cljs.core.apply.call(null,cljs.core.hash_map,inst_15981);
var state_16057__$1 = state_16057;
var statearr_16105_16197 = state_16057__$1;
(statearr_16105_16197[(2)] = inst_16001);

(statearr_16105_16197[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16058 === (11))){
var inst_15981 = (state_16057[(7)]);
var inst_15985 = (inst_15981 == null);
var inst_15986 = cljs.core.not.call(null,inst_15985);
var state_16057__$1 = state_16057;
if(inst_15986){
var statearr_16106_16198 = state_16057__$1;
(statearr_16106_16198[(1)] = (13));

} else {
var statearr_16107_16200 = state_16057__$1;
(statearr_16107_16200[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16058 === (9))){
var inst_15956 = (state_16057[(8)]);
var state_16057__$1 = state_16057;
var statearr_16108_16204 = state_16057__$1;
(statearr_16108_16204[(2)] = inst_15956);

(statearr_16108_16204[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16058 === (5))){
var state_16057__$1 = state_16057;
var statearr_16112_16205 = state_16057__$1;
(statearr_16112_16205[(2)] = true);

(statearr_16112_16205[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16058 === (14))){
var state_16057__$1 = state_16057;
var statearr_16113_16209 = state_16057__$1;
(statearr_16113_16209[(2)] = false);

(statearr_16113_16209[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16058 === (26))){
var inst_16014 = (state_16057[(11)]);
var inst_16021 = cljs.core.swap_BANG_.call(null,cs,cljs.core.dissoc,inst_16014);
var state_16057__$1 = state_16057;
var statearr_16114_16210 = state_16057__$1;
(statearr_16114_16210[(2)] = inst_16021);

(statearr_16114_16210[(1)] = (28));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16058 === (16))){
var state_16057__$1 = state_16057;
var statearr_16115_16211 = state_16057__$1;
(statearr_16115_16211[(2)] = true);

(statearr_16115_16211[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16058 === (38))){
var inst_16045 = (state_16057[(2)]);
var state_16057__$1 = state_16057;
var statearr_16116_16218 = state_16057__$1;
(statearr_16116_16218[(2)] = inst_16045);

(statearr_16116_16218[(1)] = (34));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16058 === (30))){
var inst_16005 = (state_16057[(10)]);
var inst_16006 = (state_16057[(13)]);
var inst_16014 = (state_16057[(11)]);
var inst_16031 = cljs.core.empty_QMARK_.call(null,inst_16005);
var inst_16032 = inst_16006.call(null,inst_16014);
var inst_16033 = cljs.core.not.call(null,inst_16032);
var inst_16034 = (inst_16031) && (inst_16033);
var state_16057__$1 = state_16057;
var statearr_16117_16219 = state_16057__$1;
(statearr_16117_16219[(2)] = inst_16034);

(statearr_16117_16219[(1)] = (31));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16058 === (10))){
var inst_15956 = (state_16057[(8)]);
var inst_15977 = (state_16057[(2)]);
var inst_15978 = cljs.core.get.call(null,inst_15977,new cljs.core.Keyword(null,"solos","solos",1441458643));
var inst_15979 = cljs.core.get.call(null,inst_15977,new cljs.core.Keyword(null,"mutes","mutes",1068806309));
var inst_15980 = cljs.core.get.call(null,inst_15977,new cljs.core.Keyword(null,"reads","reads",-1215067361));
var inst_15981 = inst_15956;
var state_16057__$1 = (function (){var statearr_16118 = state_16057;
(statearr_16118[(16)] = inst_15978);

(statearr_16118[(17)] = inst_15980);

(statearr_16118[(7)] = inst_15981);

(statearr_16118[(18)] = inst_15979);

return statearr_16118;
})();
var statearr_16119_16220 = state_16057__$1;
(statearr_16119_16220[(2)] = null);

(statearr_16119_16220[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16058 === (18))){
var inst_15996 = (state_16057[(2)]);
var state_16057__$1 = state_16057;
var statearr_16120_16221 = state_16057__$1;
(statearr_16120_16221[(2)] = inst_15996);

(statearr_16120_16221[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16058 === (37))){
var state_16057__$1 = state_16057;
var statearr_16121_16222 = state_16057__$1;
(statearr_16121_16222[(2)] = null);

(statearr_16121_16222[(1)] = (38));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16058 === (8))){
var inst_15956 = (state_16057[(8)]);
var inst_15974 = cljs.core.apply.call(null,cljs.core.hash_map,inst_15956);
var state_16057__$1 = state_16057;
var statearr_16122_16223 = state_16057__$1;
(statearr_16122_16223[(2)] = inst_15974);

(statearr_16122_16223[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__13923__auto___16131,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
;
return ((function (switch__13908__auto__,c__13923__auto___16131,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function() {
var cljs$core$async$mix_$_state_machine__13909__auto__ = null;
var cljs$core$async$mix_$_state_machine__13909__auto____0 = (function (){
var statearr_16126 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_16126[(0)] = cljs$core$async$mix_$_state_machine__13909__auto__);

(statearr_16126[(1)] = (1));

return statearr_16126;
});
var cljs$core$async$mix_$_state_machine__13909__auto____1 = (function (state_16057){
while(true){
var ret_value__13910__auto__ = (function (){try{while(true){
var result__13911__auto__ = switch__13908__auto__.call(null,state_16057);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13911__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13911__auto__;
}
break;
}
}catch (e16128){if((e16128 instanceof Object)){
var ex__13912__auto__ = e16128;
var statearr_16129_16224 = state_16057;
(statearr_16129_16224[(5)] = ex__13912__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_16057);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e16128;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13910__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__16225 = state_16057;
state_16057 = G__16225;
continue;
} else {
return ret_value__13910__auto__;
}
break;
}
});
cljs$core$async$mix_$_state_machine__13909__auto__ = function(state_16057){
switch(arguments.length){
case 0:
return cljs$core$async$mix_$_state_machine__13909__auto____0.call(this);
case 1:
return cljs$core$async$mix_$_state_machine__13909__auto____1.call(this,state_16057);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mix_$_state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mix_$_state_machine__13909__auto____0;
cljs$core$async$mix_$_state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mix_$_state_machine__13909__auto____1;
return cljs$core$async$mix_$_state_machine__13909__auto__;
})()
;})(switch__13908__auto__,c__13923__auto___16131,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
})();
var state__13925__auto__ = (function (){var statearr_16130 = f__13924__auto__.call(null);
(statearr_16130[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13923__auto___16131);

return statearr_16130;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13925__auto__);
});})(c__13923__auto___16131,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
);


return m;
});
/**
 * Adds ch as an input to the mix
 */
cljs.core.async.admix = (function cljs$core$async$admix(mix,ch){
return cljs.core.async.admix_STAR_.call(null,mix,ch);
});
/**
 * Removes ch as an input to the mix
 */
cljs.core.async.unmix = (function cljs$core$async$unmix(mix,ch){
return cljs.core.async.unmix_STAR_.call(null,mix,ch);
});
/**
 * removes all inputs from the mix
 */
cljs.core.async.unmix_all = (function cljs$core$async$unmix_all(mix){
return cljs.core.async.unmix_all_STAR_.call(null,mix);
});
/**
 * Atomically sets the state(s) of one or more channels in a mix. The
 *   state map is a map of channels -> channel-state-map. A
 *   channel-state-map is a map of attrs -> boolean, where attr is one or
 *   more of :mute, :pause or :solo. Any states supplied are merged with
 *   the current state.
 * 
 *   Note that channels can be added to a mix via toggle, which can be
 *   used to add channels in a particular (e.g. paused) state.
 */
cljs.core.async.toggle = (function cljs$core$async$toggle(mix,state_map){
return cljs.core.async.toggle_STAR_.call(null,mix,state_map);
});
/**
 * Sets the solo mode of the mix. mode must be one of :mute or :pause
 */
cljs.core.async.solo_mode = (function cljs$core$async$solo_mode(mix,mode){
return cljs.core.async.solo_mode_STAR_.call(null,mix,mode);
});

/**
 * @interface
 */
cljs.core.async.Pub = function(){};

cljs.core.async.sub_STAR_ = (function cljs$core$async$sub_STAR_(p,v,ch,close_QMARK_){
if((!((p == null))) && (!((p.cljs$core$async$Pub$sub_STAR_$arity$4 == null)))){
return p.cljs$core$async$Pub$sub_STAR_$arity$4(p,v,ch,close_QMARK_);
} else {
var x__7206__auto__ = (((p == null))?null:p);
var m__7207__auto__ = (cljs.core.async.sub_STAR_[goog.typeOf(x__7206__auto__)]);
if(!((m__7207__auto__ == null))){
return m__7207__auto__.call(null,p,v,ch,close_QMARK_);
} else {
var m__7207__auto____$1 = (cljs.core.async.sub_STAR_["_"]);
if(!((m__7207__auto____$1 == null))){
return m__7207__auto____$1.call(null,p,v,ch,close_QMARK_);
} else {
throw cljs.core.missing_protocol.call(null,"Pub.sub*",p);
}
}
}
});

cljs.core.async.unsub_STAR_ = (function cljs$core$async$unsub_STAR_(p,v,ch){
if((!((p == null))) && (!((p.cljs$core$async$Pub$unsub_STAR_$arity$3 == null)))){
return p.cljs$core$async$Pub$unsub_STAR_$arity$3(p,v,ch);
} else {
var x__7206__auto__ = (((p == null))?null:p);
var m__7207__auto__ = (cljs.core.async.unsub_STAR_[goog.typeOf(x__7206__auto__)]);
if(!((m__7207__auto__ == null))){
return m__7207__auto__.call(null,p,v,ch);
} else {
var m__7207__auto____$1 = (cljs.core.async.unsub_STAR_["_"]);
if(!((m__7207__auto____$1 == null))){
return m__7207__auto____$1.call(null,p,v,ch);
} else {
throw cljs.core.missing_protocol.call(null,"Pub.unsub*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_ = (function cljs$core$async$unsub_all_STAR_(var_args){
var args16226 = [];
var len__7651__auto___16243 = arguments.length;
var i__7652__auto___16244 = (0);
while(true){
if((i__7652__auto___16244 < len__7651__auto___16243)){
args16226.push((arguments[i__7652__auto___16244]));

var G__16245 = (i__7652__auto___16244 + (1));
i__7652__auto___16244 = G__16245;
continue;
} else {
}
break;
}

var G__16232 = args16226.length;
switch (G__16232) {
case 1:
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args16226.length)].join('')));

}
});

cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$1 = (function (p){
if((!((p == null))) && (!((p.cljs$core$async$Pub$unsub_all_STAR_$arity$1 == null)))){
return p.cljs$core$async$Pub$unsub_all_STAR_$arity$1(p);
} else {
var x__7206__auto__ = (((p == null))?null:p);
var m__7207__auto__ = (cljs.core.async.unsub_all_STAR_[goog.typeOf(x__7206__auto__)]);
if(!((m__7207__auto__ == null))){
return m__7207__auto__.call(null,p);
} else {
var m__7207__auto____$1 = (cljs.core.async.unsub_all_STAR_["_"]);
if(!((m__7207__auto____$1 == null))){
return m__7207__auto____$1.call(null,p);
} else {
throw cljs.core.missing_protocol.call(null,"Pub.unsub-all*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$2 = (function (p,v){
if((!((p == null))) && (!((p.cljs$core$async$Pub$unsub_all_STAR_$arity$2 == null)))){
return p.cljs$core$async$Pub$unsub_all_STAR_$arity$2(p,v);
} else {
var x__7206__auto__ = (((p == null))?null:p);
var m__7207__auto__ = (cljs.core.async.unsub_all_STAR_[goog.typeOf(x__7206__auto__)]);
if(!((m__7207__auto__ == null))){
return m__7207__auto__.call(null,p,v);
} else {
var m__7207__auto____$1 = (cljs.core.async.unsub_all_STAR_["_"]);
if(!((m__7207__auto____$1 == null))){
return m__7207__auto____$1.call(null,p,v);
} else {
throw cljs.core.missing_protocol.call(null,"Pub.unsub-all*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_.cljs$lang$maxFixedArity = 2;


/**
 * Creates and returns a pub(lication) of the supplied channel,
 *   partitioned into topics by the topic-fn. topic-fn will be applied to
 *   each value on the channel and the result will determine the 'topic'
 *   on which that value will be put. Channels can be subscribed to
 *   receive copies of topics using 'sub', and unsubscribed using
 *   'unsub'. Each topic will be handled by an internal mult on a
 *   dedicated channel. By default these internal channels are
 *   unbuffered, but a buf-fn can be supplied which, given a topic,
 *   creates a buffer with desired properties.
 * 
 *   Each item is distributed to all subs in parallel and synchronously,
 *   i.e. each sub must accept before the next item is distributed. Use
 *   buffering/windowing to prevent slow subs from holding up the pub.
 * 
 *   Items received when there are no matching subs get dropped.
 * 
 *   Note that if buf-fns are used then each topic is handled
 *   asynchronously, i.e. if a channel is subscribed to more than one
 *   topic it should not expect them to be interleaved identically with
 *   the source.
 */
cljs.core.async.pub = (function cljs$core$async$pub(var_args){
var args16248 = [];
var len__7651__auto___16407 = arguments.length;
var i__7652__auto___16408 = (0);
while(true){
if((i__7652__auto___16408 < len__7651__auto___16407)){
args16248.push((arguments[i__7652__auto___16408]));

var G__16409 = (i__7652__auto___16408 + (1));
i__7652__auto___16408 = G__16409;
continue;
} else {
}
break;
}

var G__16250 = args16248.length;
switch (G__16250) {
case 2:
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args16248.length)].join('')));

}
});

cljs.core.async.pub.cljs$core$IFn$_invoke$arity$2 = (function (ch,topic_fn){
return cljs.core.async.pub.call(null,ch,topic_fn,cljs.core.constantly.call(null,null));
});

cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3 = (function (ch,topic_fn,buf_fn){
var mults = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var ensure_mult = ((function (mults){
return (function (topic){
var or__6543__auto__ = cljs.core.get.call(null,cljs.core.deref.call(null,mults),topic);
if(cljs.core.truth_(or__6543__auto__)){
return or__6543__auto__;
} else {
return cljs.core.get.call(null,cljs.core.swap_BANG_.call(null,mults,((function (or__6543__auto__,mults){
return (function (p1__16247_SHARP_){
if(cljs.core.truth_(p1__16247_SHARP_.call(null,topic))){
return p1__16247_SHARP_;
} else {
return cljs.core.assoc.call(null,p1__16247_SHARP_,topic,cljs.core.async.mult.call(null,cljs.core.async.chan.call(null,buf_fn.call(null,topic))));
}
});})(or__6543__auto__,mults))
),topic);
}
});})(mults))
;
var p = (function (){
if(typeof cljs.core.async.t_cljs$core$async16254 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.Pub}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async16254 = (function (ch,topic_fn,buf_fn,mults,ensure_mult,meta16255){
this.ch = ch;
this.topic_fn = topic_fn;
this.buf_fn = buf_fn;
this.mults = mults;
this.ensure_mult = ensure_mult;
this.meta16255 = meta16255;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async16254.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (mults,ensure_mult){
return (function (_16256,meta16255__$1){
var self__ = this;
var _16256__$1 = this;
return (new cljs.core.async.t_cljs$core$async16254(self__.ch,self__.topic_fn,self__.buf_fn,self__.mults,self__.ensure_mult,meta16255__$1));
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async16254.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (mults,ensure_mult){
return (function (_16256){
var self__ = this;
var _16256__$1 = this;
return self__.meta16255;
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async16254.prototype.cljs$core$async$Mux$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async16254.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (mults,ensure_mult){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.ch;
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async16254.prototype.cljs$core$async$Pub$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async16254.prototype.cljs$core$async$Pub$sub_STAR_$arity$4 = ((function (mults,ensure_mult){
return (function (p,topic,ch__$1,close_QMARK_){
var self__ = this;
var p__$1 = this;
var m = self__.ensure_mult.call(null,topic);
return cljs.core.async.tap.call(null,m,ch__$1,close_QMARK_);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async16254.prototype.cljs$core$async$Pub$unsub_STAR_$arity$3 = ((function (mults,ensure_mult){
return (function (p,topic,ch__$1){
var self__ = this;
var p__$1 = this;
var temp__4657__auto__ = cljs.core.get.call(null,cljs.core.deref.call(null,self__.mults),topic);
if(cljs.core.truth_(temp__4657__auto__)){
var m = temp__4657__auto__;
return cljs.core.async.untap.call(null,m,ch__$1);
} else {
return null;
}
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async16254.prototype.cljs$core$async$Pub$unsub_all_STAR_$arity$1 = ((function (mults,ensure_mult){
return (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.reset_BANG_.call(null,self__.mults,cljs.core.PersistentArrayMap.EMPTY);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async16254.prototype.cljs$core$async$Pub$unsub_all_STAR_$arity$2 = ((function (mults,ensure_mult){
return (function (_,topic){
var self__ = this;
var ___$1 = this;
return cljs.core.swap_BANG_.call(null,self__.mults,cljs.core.dissoc,topic);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async16254.getBasis = ((function (mults,ensure_mult){
return (function (){
return new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"topic-fn","topic-fn",-862449736,null),new cljs.core.Symbol(null,"buf-fn","buf-fn",-1200281591,null),new cljs.core.Symbol(null,"mults","mults",-461114485,null),new cljs.core.Symbol(null,"ensure-mult","ensure-mult",1796584816,null),new cljs.core.Symbol(null,"meta16255","meta16255",1976342996,null)], null);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async16254.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async16254.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async16254";

cljs.core.async.t_cljs$core$async16254.cljs$lang$ctorPrWriter = ((function (mults,ensure_mult){
return (function (this__7149__auto__,writer__7150__auto__,opt__7151__auto__){
return cljs.core._write.call(null,writer__7150__auto__,"cljs.core.async/t_cljs$core$async16254");
});})(mults,ensure_mult))
;

cljs.core.async.__GT_t_cljs$core$async16254 = ((function (mults,ensure_mult){
return (function cljs$core$async$__GT_t_cljs$core$async16254(ch__$1,topic_fn__$1,buf_fn__$1,mults__$1,ensure_mult__$1,meta16255){
return (new cljs.core.async.t_cljs$core$async16254(ch__$1,topic_fn__$1,buf_fn__$1,mults__$1,ensure_mult__$1,meta16255));
});})(mults,ensure_mult))
;

}

return (new cljs.core.async.t_cljs$core$async16254(ch,topic_fn,buf_fn,mults,ensure_mult,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var c__13923__auto___16431 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13923__auto___16431,mults,ensure_mult,p){
return (function (){
var f__13924__auto__ = (function (){var switch__13908__auto__ = ((function (c__13923__auto___16431,mults,ensure_mult,p){
return (function (state_16339){
var state_val_16340 = (state_16339[(1)]);
if((state_val_16340 === (7))){
var inst_16335 = (state_16339[(2)]);
var state_16339__$1 = state_16339;
var statearr_16341_16444 = state_16339__$1;
(statearr_16341_16444[(2)] = inst_16335);

(statearr_16341_16444[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16340 === (20))){
var state_16339__$1 = state_16339;
var statearr_16342_16445 = state_16339__$1;
(statearr_16342_16445[(2)] = null);

(statearr_16342_16445[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16340 === (1))){
var state_16339__$1 = state_16339;
var statearr_16343_16446 = state_16339__$1;
(statearr_16343_16446[(2)] = null);

(statearr_16343_16446[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16340 === (24))){
var inst_16315 = (state_16339[(7)]);
var inst_16327 = cljs.core.swap_BANG_.call(null,mults,cljs.core.dissoc,inst_16315);
var state_16339__$1 = state_16339;
var statearr_16344_16447 = state_16339__$1;
(statearr_16344_16447[(2)] = inst_16327);

(statearr_16344_16447[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16340 === (4))){
var inst_16262 = (state_16339[(8)]);
var inst_16262__$1 = (state_16339[(2)]);
var inst_16265 = (inst_16262__$1 == null);
var state_16339__$1 = (function (){var statearr_16345 = state_16339;
(statearr_16345[(8)] = inst_16262__$1);

return statearr_16345;
})();
if(cljs.core.truth_(inst_16265)){
var statearr_16346_16448 = state_16339__$1;
(statearr_16346_16448[(1)] = (5));

} else {
var statearr_16347_16449 = state_16339__$1;
(statearr_16347_16449[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16340 === (15))){
var inst_16309 = (state_16339[(2)]);
var state_16339__$1 = state_16339;
var statearr_16354_16450 = state_16339__$1;
(statearr_16354_16450[(2)] = inst_16309);

(statearr_16354_16450[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16340 === (21))){
var inst_16332 = (state_16339[(2)]);
var state_16339__$1 = (function (){var statearr_16355 = state_16339;
(statearr_16355[(9)] = inst_16332);

return statearr_16355;
})();
var statearr_16356_16454 = state_16339__$1;
(statearr_16356_16454[(2)] = null);

(statearr_16356_16454[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16340 === (13))){
var inst_16291 = (state_16339[(10)]);
var inst_16293 = cljs.core.chunked_seq_QMARK_.call(null,inst_16291);
var state_16339__$1 = state_16339;
if(inst_16293){
var statearr_16357_16458 = state_16339__$1;
(statearr_16357_16458[(1)] = (16));

} else {
var statearr_16358_16459 = state_16339__$1;
(statearr_16358_16459[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16340 === (22))){
var inst_16324 = (state_16339[(2)]);
var state_16339__$1 = state_16339;
if(cljs.core.truth_(inst_16324)){
var statearr_16359_16461 = state_16339__$1;
(statearr_16359_16461[(1)] = (23));

} else {
var statearr_16360_16462 = state_16339__$1;
(statearr_16360_16462[(1)] = (24));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16340 === (6))){
var inst_16315 = (state_16339[(7)]);
var inst_16262 = (state_16339[(8)]);
var inst_16317 = (state_16339[(11)]);
var inst_16315__$1 = topic_fn.call(null,inst_16262);
var inst_16316 = cljs.core.deref.call(null,mults);
var inst_16317__$1 = cljs.core.get.call(null,inst_16316,inst_16315__$1);
var state_16339__$1 = (function (){var statearr_16361 = state_16339;
(statearr_16361[(7)] = inst_16315__$1);

(statearr_16361[(11)] = inst_16317__$1);

return statearr_16361;
})();
if(cljs.core.truth_(inst_16317__$1)){
var statearr_16362_16466 = state_16339__$1;
(statearr_16362_16466[(1)] = (19));

} else {
var statearr_16363_16467 = state_16339__$1;
(statearr_16363_16467[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16340 === (25))){
var inst_16329 = (state_16339[(2)]);
var state_16339__$1 = state_16339;
var statearr_16364_16471 = state_16339__$1;
(statearr_16364_16471[(2)] = inst_16329);

(statearr_16364_16471[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16340 === (17))){
var inst_16291 = (state_16339[(10)]);
var inst_16300 = cljs.core.first.call(null,inst_16291);
var inst_16301 = cljs.core.async.muxch_STAR_.call(null,inst_16300);
var inst_16302 = cljs.core.async.close_BANG_.call(null,inst_16301);
var inst_16303 = cljs.core.next.call(null,inst_16291);
var inst_16274 = inst_16303;
var inst_16275 = null;
var inst_16276 = (0);
var inst_16277 = (0);
var state_16339__$1 = (function (){var statearr_16369 = state_16339;
(statearr_16369[(12)] = inst_16276);

(statearr_16369[(13)] = inst_16274);

(statearr_16369[(14)] = inst_16302);

(statearr_16369[(15)] = inst_16275);

(statearr_16369[(16)] = inst_16277);

return statearr_16369;
})();
var statearr_16370_16472 = state_16339__$1;
(statearr_16370_16472[(2)] = null);

(statearr_16370_16472[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16340 === (3))){
var inst_16337 = (state_16339[(2)]);
var state_16339__$1 = state_16339;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_16339__$1,inst_16337);
} else {
if((state_val_16340 === (12))){
var inst_16311 = (state_16339[(2)]);
var state_16339__$1 = state_16339;
var statearr_16372_16473 = state_16339__$1;
(statearr_16372_16473[(2)] = inst_16311);

(statearr_16372_16473[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16340 === (2))){
var state_16339__$1 = state_16339;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_16339__$1,(4),ch);
} else {
if((state_val_16340 === (23))){
var state_16339__$1 = state_16339;
var statearr_16376_16474 = state_16339__$1;
(statearr_16376_16474[(2)] = null);

(statearr_16376_16474[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16340 === (19))){
var inst_16262 = (state_16339[(8)]);
var inst_16317 = (state_16339[(11)]);
var inst_16322 = cljs.core.async.muxch_STAR_.call(null,inst_16317);
var state_16339__$1 = state_16339;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_16339__$1,(22),inst_16322,inst_16262);
} else {
if((state_val_16340 === (11))){
var inst_16274 = (state_16339[(13)]);
var inst_16291 = (state_16339[(10)]);
var inst_16291__$1 = cljs.core.seq.call(null,inst_16274);
var state_16339__$1 = (function (){var statearr_16377 = state_16339;
(statearr_16377[(10)] = inst_16291__$1);

return statearr_16377;
})();
if(inst_16291__$1){
var statearr_16378_16475 = state_16339__$1;
(statearr_16378_16475[(1)] = (13));

} else {
var statearr_16379_16476 = state_16339__$1;
(statearr_16379_16476[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16340 === (9))){
var inst_16313 = (state_16339[(2)]);
var state_16339__$1 = state_16339;
var statearr_16380_16480 = state_16339__$1;
(statearr_16380_16480[(2)] = inst_16313);

(statearr_16380_16480[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16340 === (5))){
var inst_16271 = cljs.core.deref.call(null,mults);
var inst_16272 = cljs.core.vals.call(null,inst_16271);
var inst_16273 = cljs.core.seq.call(null,inst_16272);
var inst_16274 = inst_16273;
var inst_16275 = null;
var inst_16276 = (0);
var inst_16277 = (0);
var state_16339__$1 = (function (){var statearr_16381 = state_16339;
(statearr_16381[(12)] = inst_16276);

(statearr_16381[(13)] = inst_16274);

(statearr_16381[(15)] = inst_16275);

(statearr_16381[(16)] = inst_16277);

return statearr_16381;
})();
var statearr_16382_16484 = state_16339__$1;
(statearr_16382_16484[(2)] = null);

(statearr_16382_16484[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16340 === (14))){
var state_16339__$1 = state_16339;
var statearr_16386_16485 = state_16339__$1;
(statearr_16386_16485[(2)] = null);

(statearr_16386_16485[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16340 === (16))){
var inst_16291 = (state_16339[(10)]);
var inst_16295 = cljs.core.chunk_first.call(null,inst_16291);
var inst_16296 = cljs.core.chunk_rest.call(null,inst_16291);
var inst_16297 = cljs.core.count.call(null,inst_16295);
var inst_16274 = inst_16296;
var inst_16275 = inst_16295;
var inst_16276 = inst_16297;
var inst_16277 = (0);
var state_16339__$1 = (function (){var statearr_16387 = state_16339;
(statearr_16387[(12)] = inst_16276);

(statearr_16387[(13)] = inst_16274);

(statearr_16387[(15)] = inst_16275);

(statearr_16387[(16)] = inst_16277);

return statearr_16387;
})();
var statearr_16388_16486 = state_16339__$1;
(statearr_16388_16486[(2)] = null);

(statearr_16388_16486[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16340 === (10))){
var inst_16276 = (state_16339[(12)]);
var inst_16274 = (state_16339[(13)]);
var inst_16275 = (state_16339[(15)]);
var inst_16277 = (state_16339[(16)]);
var inst_16285 = cljs.core._nth.call(null,inst_16275,inst_16277);
var inst_16286 = cljs.core.async.muxch_STAR_.call(null,inst_16285);
var inst_16287 = cljs.core.async.close_BANG_.call(null,inst_16286);
var inst_16288 = (inst_16277 + (1));
var tmp16383 = inst_16276;
var tmp16384 = inst_16274;
var tmp16385 = inst_16275;
var inst_16274__$1 = tmp16384;
var inst_16275__$1 = tmp16385;
var inst_16276__$1 = tmp16383;
var inst_16277__$1 = inst_16288;
var state_16339__$1 = (function (){var statearr_16389 = state_16339;
(statearr_16389[(12)] = inst_16276__$1);

(statearr_16389[(13)] = inst_16274__$1);

(statearr_16389[(17)] = inst_16287);

(statearr_16389[(15)] = inst_16275__$1);

(statearr_16389[(16)] = inst_16277__$1);

return statearr_16389;
})();
var statearr_16390_16487 = state_16339__$1;
(statearr_16390_16487[(2)] = null);

(statearr_16390_16487[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16340 === (18))){
var inst_16306 = (state_16339[(2)]);
var state_16339__$1 = state_16339;
var statearr_16391_16488 = state_16339__$1;
(statearr_16391_16488[(2)] = inst_16306);

(statearr_16391_16488[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16340 === (8))){
var inst_16276 = (state_16339[(12)]);
var inst_16277 = (state_16339[(16)]);
var inst_16282 = (inst_16277 < inst_16276);
var inst_16283 = inst_16282;
var state_16339__$1 = state_16339;
if(cljs.core.truth_(inst_16283)){
var statearr_16392_16489 = state_16339__$1;
(statearr_16392_16489[(1)] = (10));

} else {
var statearr_16393_16490 = state_16339__$1;
(statearr_16393_16490[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__13923__auto___16431,mults,ensure_mult,p))
;
return ((function (switch__13908__auto__,c__13923__auto___16431,mults,ensure_mult,p){
return (function() {
var cljs$core$async$state_machine__13909__auto__ = null;
var cljs$core$async$state_machine__13909__auto____0 = (function (){
var statearr_16400 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_16400[(0)] = cljs$core$async$state_machine__13909__auto__);

(statearr_16400[(1)] = (1));

return statearr_16400;
});
var cljs$core$async$state_machine__13909__auto____1 = (function (state_16339){
while(true){
var ret_value__13910__auto__ = (function (){try{while(true){
var result__13911__auto__ = switch__13908__auto__.call(null,state_16339);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13911__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13911__auto__;
}
break;
}
}catch (e16401){if((e16401 instanceof Object)){
var ex__13912__auto__ = e16401;
var statearr_16402_16503 = state_16339;
(statearr_16402_16503[(5)] = ex__13912__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_16339);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e16401;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13910__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__16504 = state_16339;
state_16339 = G__16504;
continue;
} else {
return ret_value__13910__auto__;
}
break;
}
});
cljs$core$async$state_machine__13909__auto__ = function(state_16339){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__13909__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__13909__auto____1.call(this,state_16339);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__13909__auto____0;
cljs$core$async$state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__13909__auto____1;
return cljs$core$async$state_machine__13909__auto__;
})()
;})(switch__13908__auto__,c__13923__auto___16431,mults,ensure_mult,p))
})();
var state__13925__auto__ = (function (){var statearr_16406 = f__13924__auto__.call(null);
(statearr_16406[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13923__auto___16431);

return statearr_16406;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13925__auto__);
});})(c__13923__auto___16431,mults,ensure_mult,p))
);


return p;
});

cljs.core.async.pub.cljs$lang$maxFixedArity = 3;

/**
 * Subscribes a channel to a topic of a pub.
 * 
 *   By default the channel will be closed when the source closes,
 *   but can be determined by the close? parameter.
 */
cljs.core.async.sub = (function cljs$core$async$sub(var_args){
var args16505 = [];
var len__7651__auto___16520 = arguments.length;
var i__7652__auto___16521 = (0);
while(true){
if((i__7652__auto___16521 < len__7651__auto___16520)){
args16505.push((arguments[i__7652__auto___16521]));

var G__16522 = (i__7652__auto___16521 + (1));
i__7652__auto___16521 = G__16522;
continue;
} else {
}
break;
}

var G__16519 = args16505.length;
switch (G__16519) {
case 3:
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args16505.length)].join('')));

}
});

cljs.core.async.sub.cljs$core$IFn$_invoke$arity$3 = (function (p,topic,ch){
return cljs.core.async.sub.call(null,p,topic,ch,true);
});

cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4 = (function (p,topic,ch,close_QMARK_){
return cljs.core.async.sub_STAR_.call(null,p,topic,ch,close_QMARK_);
});

cljs.core.async.sub.cljs$lang$maxFixedArity = 4;

/**
 * Unsubscribes a channel from a topic of a pub
 */
cljs.core.async.unsub = (function cljs$core$async$unsub(p,topic,ch){
return cljs.core.async.unsub_STAR_.call(null,p,topic,ch);
});
/**
 * Unsubscribes all channels from a pub, or a topic of a pub
 */
cljs.core.async.unsub_all = (function cljs$core$async$unsub_all(var_args){
var args16524 = [];
var len__7651__auto___16527 = arguments.length;
var i__7652__auto___16528 = (0);
while(true){
if((i__7652__auto___16528 < len__7651__auto___16527)){
args16524.push((arguments[i__7652__auto___16528]));

var G__16529 = (i__7652__auto___16528 + (1));
i__7652__auto___16528 = G__16529;
continue;
} else {
}
break;
}

var G__16526 = args16524.length;
switch (G__16526) {
case 1:
return cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args16524.length)].join('')));

}
});

cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$1 = (function (p){
return cljs.core.async.unsub_all_STAR_.call(null,p);
});

cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$2 = (function (p,topic){
return cljs.core.async.unsub_all_STAR_.call(null,p,topic);
});

cljs.core.async.unsub_all.cljs$lang$maxFixedArity = 2;

/**
 * Takes a function and a collection of source channels, and returns a
 *   channel which contains the values produced by applying f to the set
 *   of first items taken from each source channel, followed by applying
 *   f to the set of second items from each channel, until any one of the
 *   channels is closed, at which point the output channel will be
 *   closed. The returned channel will be unbuffered by default, or a
 *   buf-or-n can be supplied
 */
cljs.core.async.map = (function cljs$core$async$map(var_args){
var args16536 = [];
var len__7651__auto___16667 = arguments.length;
var i__7652__auto___16668 = (0);
while(true){
if((i__7652__auto___16668 < len__7651__auto___16667)){
args16536.push((arguments[i__7652__auto___16668]));

var G__16669 = (i__7652__auto___16668 + (1));
i__7652__auto___16668 = G__16669;
continue;
} else {
}
break;
}

var G__16538 = args16536.length;
switch (G__16538) {
case 2:
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args16536.length)].join('')));

}
});

cljs.core.async.map.cljs$core$IFn$_invoke$arity$2 = (function (f,chs){
return cljs.core.async.map.call(null,f,chs,null);
});

cljs.core.async.map.cljs$core$IFn$_invoke$arity$3 = (function (f,chs,buf_or_n){
var chs__$1 = cljs.core.vec.call(null,chs);
var out = cljs.core.async.chan.call(null,buf_or_n);
var cnt = cljs.core.count.call(null,chs__$1);
var rets = cljs.core.object_array.call(null,cnt);
var dchan = cljs.core.async.chan.call(null,(1));
var dctr = cljs.core.atom.call(null,null);
var done = cljs.core.mapv.call(null,((function (chs__$1,out,cnt,rets,dchan,dctr){
return (function (i){
return ((function (chs__$1,out,cnt,rets,dchan,dctr){
return (function (ret){
(rets[i] = ret);

if((cljs.core.swap_BANG_.call(null,dctr,cljs.core.dec) === (0))){
return cljs.core.async.put_BANG_.call(null,dchan,rets.slice((0)));
} else {
return null;
}
});
;})(chs__$1,out,cnt,rets,dchan,dctr))
});})(chs__$1,out,cnt,rets,dchan,dctr))
,cljs.core.range.call(null,cnt));
var c__13923__auto___16676 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13923__auto___16676,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function (){
var f__13924__auto__ = (function (){var switch__13908__auto__ = ((function (c__13923__auto___16676,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function (state_16593){
var state_val_16594 = (state_16593[(1)]);
if((state_val_16594 === (7))){
var state_16593__$1 = state_16593;
var statearr_16595_16677 = state_16593__$1;
(statearr_16595_16677[(2)] = null);

(statearr_16595_16677[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16594 === (1))){
var state_16593__$1 = state_16593;
var statearr_16596_16678 = state_16593__$1;
(statearr_16596_16678[(2)] = null);

(statearr_16596_16678[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16594 === (4))){
var inst_16554 = (state_16593[(7)]);
var inst_16556 = (inst_16554 < cnt);
var state_16593__$1 = state_16593;
if(cljs.core.truth_(inst_16556)){
var statearr_16597_16679 = state_16593__$1;
(statearr_16597_16679[(1)] = (6));

} else {
var statearr_16598_16680 = state_16593__$1;
(statearr_16598_16680[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16594 === (15))){
var inst_16589 = (state_16593[(2)]);
var state_16593__$1 = state_16593;
var statearr_16599_16682 = state_16593__$1;
(statearr_16599_16682[(2)] = inst_16589);

(statearr_16599_16682[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16594 === (13))){
var inst_16582 = cljs.core.async.close_BANG_.call(null,out);
var state_16593__$1 = state_16593;
var statearr_16600_16683 = state_16593__$1;
(statearr_16600_16683[(2)] = inst_16582);

(statearr_16600_16683[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16594 === (6))){
var state_16593__$1 = state_16593;
var statearr_16604_16690 = state_16593__$1;
(statearr_16604_16690[(2)] = null);

(statearr_16604_16690[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16594 === (3))){
var inst_16591 = (state_16593[(2)]);
var state_16593__$1 = state_16593;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_16593__$1,inst_16591);
} else {
if((state_val_16594 === (12))){
var inst_16579 = (state_16593[(8)]);
var inst_16579__$1 = (state_16593[(2)]);
var inst_16580 = cljs.core.some.call(null,cljs.core.nil_QMARK_,inst_16579__$1);
var state_16593__$1 = (function (){var statearr_16618 = state_16593;
(statearr_16618[(8)] = inst_16579__$1);

return statearr_16618;
})();
if(cljs.core.truth_(inst_16580)){
var statearr_16619_16697 = state_16593__$1;
(statearr_16619_16697[(1)] = (13));

} else {
var statearr_16620_16698 = state_16593__$1;
(statearr_16620_16698[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16594 === (2))){
var inst_16550 = cljs.core.reset_BANG_.call(null,dctr,cnt);
var inst_16554 = (0);
var state_16593__$1 = (function (){var statearr_16621 = state_16593;
(statearr_16621[(9)] = inst_16550);

(statearr_16621[(7)] = inst_16554);

return statearr_16621;
})();
var statearr_16622_16699 = state_16593__$1;
(statearr_16622_16699[(2)] = null);

(statearr_16622_16699[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16594 === (11))){
var inst_16554 = (state_16593[(7)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_16593,(10),Object,null,(9));
var inst_16566 = chs__$1.call(null,inst_16554);
var inst_16567 = done.call(null,inst_16554);
var inst_16568 = cljs.core.async.take_BANG_.call(null,inst_16566,inst_16567);
var state_16593__$1 = state_16593;
var statearr_16623_16700 = state_16593__$1;
(statearr_16623_16700[(2)] = inst_16568);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_16593__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16594 === (9))){
var inst_16554 = (state_16593[(7)]);
var inst_16570 = (state_16593[(2)]);
var inst_16571 = (inst_16554 + (1));
var inst_16554__$1 = inst_16571;
var state_16593__$1 = (function (){var statearr_16624 = state_16593;
(statearr_16624[(10)] = inst_16570);

(statearr_16624[(7)] = inst_16554__$1);

return statearr_16624;
})();
var statearr_16625_16701 = state_16593__$1;
(statearr_16625_16701[(2)] = null);

(statearr_16625_16701[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16594 === (5))){
var inst_16577 = (state_16593[(2)]);
var state_16593__$1 = (function (){var statearr_16626 = state_16593;
(statearr_16626[(11)] = inst_16577);

return statearr_16626;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_16593__$1,(12),dchan);
} else {
if((state_val_16594 === (14))){
var inst_16579 = (state_16593[(8)]);
var inst_16584 = cljs.core.apply.call(null,f,inst_16579);
var state_16593__$1 = state_16593;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_16593__$1,(16),out,inst_16584);
} else {
if((state_val_16594 === (16))){
var inst_16586 = (state_16593[(2)]);
var state_16593__$1 = (function (){var statearr_16631 = state_16593;
(statearr_16631[(12)] = inst_16586);

return statearr_16631;
})();
var statearr_16632_16702 = state_16593__$1;
(statearr_16632_16702[(2)] = null);

(statearr_16632_16702[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16594 === (10))){
var inst_16561 = (state_16593[(2)]);
var inst_16562 = cljs.core.swap_BANG_.call(null,dctr,cljs.core.dec);
var state_16593__$1 = (function (){var statearr_16633 = state_16593;
(statearr_16633[(13)] = inst_16561);

return statearr_16633;
})();
var statearr_16634_16712 = state_16593__$1;
(statearr_16634_16712[(2)] = inst_16562);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_16593__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16594 === (8))){
var inst_16575 = (state_16593[(2)]);
var state_16593__$1 = state_16593;
var statearr_16635_16722 = state_16593__$1;
(statearr_16635_16722[(2)] = inst_16575);

(statearr_16635_16722[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__13923__auto___16676,chs__$1,out,cnt,rets,dchan,dctr,done))
;
return ((function (switch__13908__auto__,c__13923__auto___16676,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function() {
var cljs$core$async$state_machine__13909__auto__ = null;
var cljs$core$async$state_machine__13909__auto____0 = (function (){
var statearr_16663 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_16663[(0)] = cljs$core$async$state_machine__13909__auto__);

(statearr_16663[(1)] = (1));

return statearr_16663;
});
var cljs$core$async$state_machine__13909__auto____1 = (function (state_16593){
while(true){
var ret_value__13910__auto__ = (function (){try{while(true){
var result__13911__auto__ = switch__13908__auto__.call(null,state_16593);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13911__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13911__auto__;
}
break;
}
}catch (e16664){if((e16664 instanceof Object)){
var ex__13912__auto__ = e16664;
var statearr_16665_16723 = state_16593;
(statearr_16665_16723[(5)] = ex__13912__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_16593);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e16664;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13910__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__16724 = state_16593;
state_16593 = G__16724;
continue;
} else {
return ret_value__13910__auto__;
}
break;
}
});
cljs$core$async$state_machine__13909__auto__ = function(state_16593){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__13909__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__13909__auto____1.call(this,state_16593);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__13909__auto____0;
cljs$core$async$state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__13909__auto____1;
return cljs$core$async$state_machine__13909__auto__;
})()
;})(switch__13908__auto__,c__13923__auto___16676,chs__$1,out,cnt,rets,dchan,dctr,done))
})();
var state__13925__auto__ = (function (){var statearr_16666 = f__13924__auto__.call(null);
(statearr_16666[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13923__auto___16676);

return statearr_16666;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13925__auto__);
});})(c__13923__auto___16676,chs__$1,out,cnt,rets,dchan,dctr,done))
);


return out;
});

cljs.core.async.map.cljs$lang$maxFixedArity = 3;

/**
 * Takes a collection of source channels and returns a channel which
 *   contains all values taken from them. The returned channel will be
 *   unbuffered by default, or a buf-or-n can be supplied. The channel
 *   will close after all the source channels have closed.
 */
cljs.core.async.merge = (function cljs$core$async$merge(var_args){
var args16726 = [];
var len__7651__auto___16814 = arguments.length;
var i__7652__auto___16815 = (0);
while(true){
if((i__7652__auto___16815 < len__7651__auto___16814)){
args16726.push((arguments[i__7652__auto___16815]));

var G__16816 = (i__7652__auto___16815 + (1));
i__7652__auto___16815 = G__16816;
continue;
} else {
}
break;
}

var G__16728 = args16726.length;
switch (G__16728) {
case 1:
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args16726.length)].join('')));

}
});

cljs.core.async.merge.cljs$core$IFn$_invoke$arity$1 = (function (chs){
return cljs.core.async.merge.call(null,chs,null);
});

cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2 = (function (chs,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__13923__auto___16818 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13923__auto___16818,out){
return (function (){
var f__13924__auto__ = (function (){var switch__13908__auto__ = ((function (c__13923__auto___16818,out){
return (function (state_16766){
var state_val_16767 = (state_16766[(1)]);
if((state_val_16767 === (7))){
var inst_16743 = (state_16766[(7)]);
var inst_16742 = (state_16766[(8)]);
var inst_16742__$1 = (state_16766[(2)]);
var inst_16743__$1 = cljs.core.nth.call(null,inst_16742__$1,(0),null);
var inst_16744 = cljs.core.nth.call(null,inst_16742__$1,(1),null);
var inst_16745 = (inst_16743__$1 == null);
var state_16766__$1 = (function (){var statearr_16768 = state_16766;
(statearr_16768[(9)] = inst_16744);

(statearr_16768[(7)] = inst_16743__$1);

(statearr_16768[(8)] = inst_16742__$1);

return statearr_16768;
})();
if(cljs.core.truth_(inst_16745)){
var statearr_16769_16828 = state_16766__$1;
(statearr_16769_16828[(1)] = (8));

} else {
var statearr_16770_16829 = state_16766__$1;
(statearr_16770_16829[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16767 === (1))){
var inst_16732 = cljs.core.vec.call(null,chs);
var inst_16733 = inst_16732;
var state_16766__$1 = (function (){var statearr_16771 = state_16766;
(statearr_16771[(10)] = inst_16733);

return statearr_16771;
})();
var statearr_16772_16844 = state_16766__$1;
(statearr_16772_16844[(2)] = null);

(statearr_16772_16844[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16767 === (4))){
var inst_16733 = (state_16766[(10)]);
var state_16766__$1 = state_16766;
return cljs.core.async.ioc_alts_BANG_.call(null,state_16766__$1,(7),inst_16733);
} else {
if((state_val_16767 === (6))){
var inst_16762 = (state_16766[(2)]);
var state_16766__$1 = state_16766;
var statearr_16773_16845 = state_16766__$1;
(statearr_16773_16845[(2)] = inst_16762);

(statearr_16773_16845[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16767 === (3))){
var inst_16764 = (state_16766[(2)]);
var state_16766__$1 = state_16766;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_16766__$1,inst_16764);
} else {
if((state_val_16767 === (2))){
var inst_16733 = (state_16766[(10)]);
var inst_16735 = cljs.core.count.call(null,inst_16733);
var inst_16736 = (inst_16735 > (0));
var state_16766__$1 = state_16766;
if(cljs.core.truth_(inst_16736)){
var statearr_16781_16846 = state_16766__$1;
(statearr_16781_16846[(1)] = (4));

} else {
var statearr_16782_16847 = state_16766__$1;
(statearr_16782_16847[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16767 === (11))){
var inst_16733 = (state_16766[(10)]);
var inst_16755 = (state_16766[(2)]);
var tmp16777 = inst_16733;
var inst_16733__$1 = tmp16777;
var state_16766__$1 = (function (){var statearr_16783 = state_16766;
(statearr_16783[(10)] = inst_16733__$1);

(statearr_16783[(11)] = inst_16755);

return statearr_16783;
})();
var statearr_16784_16848 = state_16766__$1;
(statearr_16784_16848[(2)] = null);

(statearr_16784_16848[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16767 === (9))){
var inst_16743 = (state_16766[(7)]);
var state_16766__$1 = state_16766;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_16766__$1,(11),out,inst_16743);
} else {
if((state_val_16767 === (5))){
var inst_16760 = cljs.core.async.close_BANG_.call(null,out);
var state_16766__$1 = state_16766;
var statearr_16788_16849 = state_16766__$1;
(statearr_16788_16849[(2)] = inst_16760);

(statearr_16788_16849[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16767 === (10))){
var inst_16758 = (state_16766[(2)]);
var state_16766__$1 = state_16766;
var statearr_16789_16850 = state_16766__$1;
(statearr_16789_16850[(2)] = inst_16758);

(statearr_16789_16850[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16767 === (8))){
var inst_16733 = (state_16766[(10)]);
var inst_16744 = (state_16766[(9)]);
var inst_16743 = (state_16766[(7)]);
var inst_16742 = (state_16766[(8)]);
var inst_16750 = (function (){var cs = inst_16733;
var vec__16738 = inst_16742;
var v = inst_16743;
var c = inst_16744;
return ((function (cs,vec__16738,v,c,inst_16733,inst_16744,inst_16743,inst_16742,state_val_16767,c__13923__auto___16818,out){
return (function (p1__16725_SHARP_){
return cljs.core.not_EQ_.call(null,c,p1__16725_SHARP_);
});
;})(cs,vec__16738,v,c,inst_16733,inst_16744,inst_16743,inst_16742,state_val_16767,c__13923__auto___16818,out))
})();
var inst_16751 = cljs.core.filterv.call(null,inst_16750,inst_16733);
var inst_16733__$1 = inst_16751;
var state_16766__$1 = (function (){var statearr_16805 = state_16766;
(statearr_16805[(10)] = inst_16733__$1);

return statearr_16805;
})();
var statearr_16806_16851 = state_16766__$1;
(statearr_16806_16851[(2)] = null);

(statearr_16806_16851[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__13923__auto___16818,out))
;
return ((function (switch__13908__auto__,c__13923__auto___16818,out){
return (function() {
var cljs$core$async$state_machine__13909__auto__ = null;
var cljs$core$async$state_machine__13909__auto____0 = (function (){
var statearr_16810 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_16810[(0)] = cljs$core$async$state_machine__13909__auto__);

(statearr_16810[(1)] = (1));

return statearr_16810;
});
var cljs$core$async$state_machine__13909__auto____1 = (function (state_16766){
while(true){
var ret_value__13910__auto__ = (function (){try{while(true){
var result__13911__auto__ = switch__13908__auto__.call(null,state_16766);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13911__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13911__auto__;
}
break;
}
}catch (e16811){if((e16811 instanceof Object)){
var ex__13912__auto__ = e16811;
var statearr_16812_16855 = state_16766;
(statearr_16812_16855[(5)] = ex__13912__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_16766);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e16811;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13910__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__16856 = state_16766;
state_16766 = G__16856;
continue;
} else {
return ret_value__13910__auto__;
}
break;
}
});
cljs$core$async$state_machine__13909__auto__ = function(state_16766){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__13909__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__13909__auto____1.call(this,state_16766);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__13909__auto____0;
cljs$core$async$state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__13909__auto____1;
return cljs$core$async$state_machine__13909__auto__;
})()
;})(switch__13908__auto__,c__13923__auto___16818,out))
})();
var state__13925__auto__ = (function (){var statearr_16813 = f__13924__auto__.call(null);
(statearr_16813[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13923__auto___16818);

return statearr_16813;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13925__auto__);
});})(c__13923__auto___16818,out))
);


return out;
});

cljs.core.async.merge.cljs$lang$maxFixedArity = 2;

/**
 * Returns a channel containing the single (collection) result of the
 *   items taken from the channel conjoined to the supplied
 *   collection. ch must close before into produces a result.
 */
cljs.core.async.into = (function cljs$core$async$into(coll,ch){
return cljs.core.async.reduce.call(null,cljs.core.conj,coll,ch);
});
/**
 * Returns a channel that will return, at most, n items from ch. After n items
 * have been returned, or ch has been closed, the return chanel will close.
 * 
 *   The output channel is unbuffered by default, unless buf-or-n is given.
 */
cljs.core.async.take = (function cljs$core$async$take(var_args){
var args16860 = [];
var len__7651__auto___16915 = arguments.length;
var i__7652__auto___16916 = (0);
while(true){
if((i__7652__auto___16916 < len__7651__auto___16915)){
args16860.push((arguments[i__7652__auto___16916]));

var G__16917 = (i__7652__auto___16916 + (1));
i__7652__auto___16916 = G__16917;
continue;
} else {
}
break;
}

var G__16862 = args16860.length;
switch (G__16862) {
case 2:
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args16860.length)].join('')));

}
});

cljs.core.async.take.cljs$core$IFn$_invoke$arity$2 = (function (n,ch){
return cljs.core.async.take.call(null,n,ch,null);
});

cljs.core.async.take.cljs$core$IFn$_invoke$arity$3 = (function (n,ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__13923__auto___16922 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13923__auto___16922,out){
return (function (){
var f__13924__auto__ = (function (){var switch__13908__auto__ = ((function (c__13923__auto___16922,out){
return (function (state_16886){
var state_val_16887 = (state_16886[(1)]);
if((state_val_16887 === (7))){
var inst_16868 = (state_16886[(7)]);
var inst_16868__$1 = (state_16886[(2)]);
var inst_16869 = (inst_16868__$1 == null);
var inst_16870 = cljs.core.not.call(null,inst_16869);
var state_16886__$1 = (function (){var statearr_16888 = state_16886;
(statearr_16888[(7)] = inst_16868__$1);

return statearr_16888;
})();
if(inst_16870){
var statearr_16889_16948 = state_16886__$1;
(statearr_16889_16948[(1)] = (8));

} else {
var statearr_16890_16949 = state_16886__$1;
(statearr_16890_16949[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16887 === (1))){
var inst_16863 = (0);
var state_16886__$1 = (function (){var statearr_16891 = state_16886;
(statearr_16891[(8)] = inst_16863);

return statearr_16891;
})();
var statearr_16892_16950 = state_16886__$1;
(statearr_16892_16950[(2)] = null);

(statearr_16892_16950[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16887 === (4))){
var state_16886__$1 = state_16886;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_16886__$1,(7),ch);
} else {
if((state_val_16887 === (6))){
var inst_16881 = (state_16886[(2)]);
var state_16886__$1 = state_16886;
var statearr_16893_16963 = state_16886__$1;
(statearr_16893_16963[(2)] = inst_16881);

(statearr_16893_16963[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16887 === (3))){
var inst_16883 = (state_16886[(2)]);
var inst_16884 = cljs.core.async.close_BANG_.call(null,out);
var state_16886__$1 = (function (){var statearr_16894 = state_16886;
(statearr_16894[(9)] = inst_16883);

return statearr_16894;
})();
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_16886__$1,inst_16884);
} else {
if((state_val_16887 === (2))){
var inst_16863 = (state_16886[(8)]);
var inst_16865 = (inst_16863 < n);
var state_16886__$1 = state_16886;
if(cljs.core.truth_(inst_16865)){
var statearr_16895_16964 = state_16886__$1;
(statearr_16895_16964[(1)] = (4));

} else {
var statearr_16896_16965 = state_16886__$1;
(statearr_16896_16965[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16887 === (11))){
var inst_16863 = (state_16886[(8)]);
var inst_16873 = (state_16886[(2)]);
var inst_16874 = (inst_16863 + (1));
var inst_16863__$1 = inst_16874;
var state_16886__$1 = (function (){var statearr_16897 = state_16886;
(statearr_16897[(8)] = inst_16863__$1);

(statearr_16897[(10)] = inst_16873);

return statearr_16897;
})();
var statearr_16898_16966 = state_16886__$1;
(statearr_16898_16966[(2)] = null);

(statearr_16898_16966[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16887 === (9))){
var state_16886__$1 = state_16886;
var statearr_16899_16967 = state_16886__$1;
(statearr_16899_16967[(2)] = null);

(statearr_16899_16967[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16887 === (5))){
var state_16886__$1 = state_16886;
var statearr_16900_16968 = state_16886__$1;
(statearr_16900_16968[(2)] = null);

(statearr_16900_16968[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16887 === (10))){
var inst_16878 = (state_16886[(2)]);
var state_16886__$1 = state_16886;
var statearr_16901_16969 = state_16886__$1;
(statearr_16901_16969[(2)] = inst_16878);

(statearr_16901_16969[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16887 === (8))){
var inst_16868 = (state_16886[(7)]);
var state_16886__$1 = state_16886;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_16886__$1,(11),out,inst_16868);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__13923__auto___16922,out))
;
return ((function (switch__13908__auto__,c__13923__auto___16922,out){
return (function() {
var cljs$core$async$state_machine__13909__auto__ = null;
var cljs$core$async$state_machine__13909__auto____0 = (function (){
var statearr_16905 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_16905[(0)] = cljs$core$async$state_machine__13909__auto__);

(statearr_16905[(1)] = (1));

return statearr_16905;
});
var cljs$core$async$state_machine__13909__auto____1 = (function (state_16886){
while(true){
var ret_value__13910__auto__ = (function (){try{while(true){
var result__13911__auto__ = switch__13908__auto__.call(null,state_16886);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13911__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13911__auto__;
}
break;
}
}catch (e16906){if((e16906 instanceof Object)){
var ex__13912__auto__ = e16906;
var statearr_16907_16970 = state_16886;
(statearr_16907_16970[(5)] = ex__13912__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_16886);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e16906;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13910__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__16971 = state_16886;
state_16886 = G__16971;
continue;
} else {
return ret_value__13910__auto__;
}
break;
}
});
cljs$core$async$state_machine__13909__auto__ = function(state_16886){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__13909__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__13909__auto____1.call(this,state_16886);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__13909__auto____0;
cljs$core$async$state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__13909__auto____1;
return cljs$core$async$state_machine__13909__auto__;
})()
;})(switch__13908__auto__,c__13923__auto___16922,out))
})();
var state__13925__auto__ = (function (){var statearr_16911 = f__13924__auto__.call(null);
(statearr_16911[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13923__auto___16922);

return statearr_16911;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13925__auto__);
});})(c__13923__auto___16922,out))
);


return out;
});

cljs.core.async.take.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.map_LT_ = (function cljs$core$async$map_LT_(f,ch){
if(typeof cljs.core.async.t_cljs$core$async16993 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async16993 = (function (f,ch,meta16994){
this.f = f;
this.ch = ch;
this.meta16994 = meta16994;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async16993.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_16995,meta16994__$1){
var self__ = this;
var _16995__$1 = this;
return (new cljs.core.async.t_cljs$core$async16993(self__.f,self__.ch,meta16994__$1));
});

cljs.core.async.t_cljs$core$async16993.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_16995){
var self__ = this;
var _16995__$1 = this;
return self__.meta16994;
});

cljs.core.async.t_cljs$core$async16993.prototype.cljs$core$async$impl$protocols$Channel$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async16993.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async16993.prototype.cljs$core$async$impl$protocols$Channel$closed_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.closed_QMARK_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async16993.prototype.cljs$core$async$impl$protocols$ReadPort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async16993.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
var ret = cljs.core.async.impl.protocols.take_BANG_.call(null,self__.ch,(function (){
if(typeof cljs.core.async.t_cljs$core$async16996 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async16996 = (function (f,ch,meta16994,_,fn1,meta16997){
this.f = f;
this.ch = ch;
this.meta16994 = meta16994;
this._ = _;
this.fn1 = fn1;
this.meta16997 = meta16997;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async16996.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (___$1){
return (function (_16998,meta16997__$1){
var self__ = this;
var _16998__$1 = this;
return (new cljs.core.async.t_cljs$core$async16996(self__.f,self__.ch,self__.meta16994,self__._,self__.fn1,meta16997__$1));
});})(___$1))
;

cljs.core.async.t_cljs$core$async16996.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (___$1){
return (function (_16998){
var self__ = this;
var _16998__$1 = this;
return self__.meta16997;
});})(___$1))
;

cljs.core.async.t_cljs$core$async16996.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async16996.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
return cljs.core.async.impl.protocols.active_QMARK_.call(null,self__.fn1);
});})(___$1))
;

cljs.core.async.t_cljs$core$async16996.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
return true;
});})(___$1))
;

cljs.core.async.t_cljs$core$async16996.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
var f1 = cljs.core.async.impl.protocols.commit.call(null,self__.fn1);
return ((function (f1,___$2,___$1){
return (function (p1__16972_SHARP_){
return f1.call(null,(((p1__16972_SHARP_ == null))?null:self__.f.call(null,p1__16972_SHARP_)));
});
;})(f1,___$2,___$1))
});})(___$1))
;

cljs.core.async.t_cljs$core$async16996.getBasis = ((function (___$1){
return (function (){
return new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta16994","meta16994",-1938814879,null),cljs.core.with_meta(new cljs.core.Symbol(null,"_","_",-1201019570,null),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"tag","tag",-1290361223),new cljs.core.Symbol("cljs.core.async","t_cljs$core$async16993","cljs.core.async/t_cljs$core$async16993",-1149162792,null)], null)),new cljs.core.Symbol(null,"fn1","fn1",895834444,null),new cljs.core.Symbol(null,"meta16997","meta16997",2073920064,null)], null);
});})(___$1))
;

cljs.core.async.t_cljs$core$async16996.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async16996.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async16996";

cljs.core.async.t_cljs$core$async16996.cljs$lang$ctorPrWriter = ((function (___$1){
return (function (this__7149__auto__,writer__7150__auto__,opt__7151__auto__){
return cljs.core._write.call(null,writer__7150__auto__,"cljs.core.async/t_cljs$core$async16996");
});})(___$1))
;

cljs.core.async.__GT_t_cljs$core$async16996 = ((function (___$1){
return (function cljs$core$async$map_LT__$___GT_t_cljs$core$async16996(f__$1,ch__$1,meta16994__$1,___$2,fn1__$1,meta16997){
return (new cljs.core.async.t_cljs$core$async16996(f__$1,ch__$1,meta16994__$1,___$2,fn1__$1,meta16997));
});})(___$1))
;

}

return (new cljs.core.async.t_cljs$core$async16996(self__.f,self__.ch,self__.meta16994,___$1,fn1,cljs.core.PersistentArrayMap.EMPTY));
})()
);
if(cljs.core.truth_((function (){var and__6531__auto__ = ret;
if(cljs.core.truth_(and__6531__auto__)){
return !((cljs.core.deref.call(null,ret) == null));
} else {
return and__6531__auto__;
}
})())){
return cljs.core.async.impl.channels.box.call(null,self__.f.call(null,cljs.core.deref.call(null,ret)));
} else {
return ret;
}
});

cljs.core.async.t_cljs$core$async16993.prototype.cljs$core$async$impl$protocols$WritePort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async16993.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.put_BANG_.call(null,self__.ch,val,fn1);
});

cljs.core.async.t_cljs$core$async16993.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta16994","meta16994",-1938814879,null)], null);
});

cljs.core.async.t_cljs$core$async16993.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async16993.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async16993";

cljs.core.async.t_cljs$core$async16993.cljs$lang$ctorPrWriter = (function (this__7149__auto__,writer__7150__auto__,opt__7151__auto__){
return cljs.core._write.call(null,writer__7150__auto__,"cljs.core.async/t_cljs$core$async16993");
});

cljs.core.async.__GT_t_cljs$core$async16993 = (function cljs$core$async$map_LT__$___GT_t_cljs$core$async16993(f__$1,ch__$1,meta16994){
return (new cljs.core.async.t_cljs$core$async16993(f__$1,ch__$1,meta16994));
});

}

return (new cljs.core.async.t_cljs$core$async16993(f,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.map_GT_ = (function cljs$core$async$map_GT_(f,ch){
if(typeof cljs.core.async.t_cljs$core$async17020 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async17020 = (function (f,ch,meta17021){
this.f = f;
this.ch = ch;
this.meta17021 = meta17021;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async17020.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_17022,meta17021__$1){
var self__ = this;
var _17022__$1 = this;
return (new cljs.core.async.t_cljs$core$async17020(self__.f,self__.ch,meta17021__$1));
});

cljs.core.async.t_cljs$core$async17020.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_17022){
var self__ = this;
var _17022__$1 = this;
return self__.meta17021;
});

cljs.core.async.t_cljs$core$async17020.prototype.cljs$core$async$impl$protocols$Channel$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async17020.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async17020.prototype.cljs$core$async$impl$protocols$ReadPort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async17020.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.take_BANG_.call(null,self__.ch,fn1);
});

cljs.core.async.t_cljs$core$async17020.prototype.cljs$core$async$impl$protocols$WritePort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async17020.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.put_BANG_.call(null,self__.ch,self__.f.call(null,val),fn1);
});

cljs.core.async.t_cljs$core$async17020.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta17021","meta17021",831317466,null)], null);
});

cljs.core.async.t_cljs$core$async17020.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async17020.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async17020";

cljs.core.async.t_cljs$core$async17020.cljs$lang$ctorPrWriter = (function (this__7149__auto__,writer__7150__auto__,opt__7151__auto__){
return cljs.core._write.call(null,writer__7150__auto__,"cljs.core.async/t_cljs$core$async17020");
});

cljs.core.async.__GT_t_cljs$core$async17020 = (function cljs$core$async$map_GT__$___GT_t_cljs$core$async17020(f__$1,ch__$1,meta17021){
return (new cljs.core.async.t_cljs$core$async17020(f__$1,ch__$1,meta17021));
});

}

return (new cljs.core.async.t_cljs$core$async17020(f,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.filter_GT_ = (function cljs$core$async$filter_GT_(p,ch){
if(typeof cljs.core.async.t_cljs$core$async17026 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async17026 = (function (p,ch,meta17027){
this.p = p;
this.ch = ch;
this.meta17027 = meta17027;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async17026.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_17028,meta17027__$1){
var self__ = this;
var _17028__$1 = this;
return (new cljs.core.async.t_cljs$core$async17026(self__.p,self__.ch,meta17027__$1));
});

cljs.core.async.t_cljs$core$async17026.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_17028){
var self__ = this;
var _17028__$1 = this;
return self__.meta17027;
});

cljs.core.async.t_cljs$core$async17026.prototype.cljs$core$async$impl$protocols$Channel$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async17026.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async17026.prototype.cljs$core$async$impl$protocols$Channel$closed_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.closed_QMARK_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async17026.prototype.cljs$core$async$impl$protocols$ReadPort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async17026.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.take_BANG_.call(null,self__.ch,fn1);
});

cljs.core.async.t_cljs$core$async17026.prototype.cljs$core$async$impl$protocols$WritePort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async17026.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
if(cljs.core.truth_(self__.p.call(null,val))){
return cljs.core.async.impl.protocols.put_BANG_.call(null,self__.ch,val,fn1);
} else {
return cljs.core.async.impl.channels.box.call(null,cljs.core.not.call(null,cljs.core.async.impl.protocols.closed_QMARK_.call(null,self__.ch)));
}
});

cljs.core.async.t_cljs$core$async17026.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"p","p",1791580836,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta17027","meta17027",23342952,null)], null);
});

cljs.core.async.t_cljs$core$async17026.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async17026.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async17026";

cljs.core.async.t_cljs$core$async17026.cljs$lang$ctorPrWriter = (function (this__7149__auto__,writer__7150__auto__,opt__7151__auto__){
return cljs.core._write.call(null,writer__7150__auto__,"cljs.core.async/t_cljs$core$async17026");
});

cljs.core.async.__GT_t_cljs$core$async17026 = (function cljs$core$async$filter_GT__$___GT_t_cljs$core$async17026(p__$1,ch__$1,meta17027){
return (new cljs.core.async.t_cljs$core$async17026(p__$1,ch__$1,meta17027));
});

}

return (new cljs.core.async.t_cljs$core$async17026(p,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.remove_GT_ = (function cljs$core$async$remove_GT_(p,ch){
return cljs.core.async.filter_GT_.call(null,cljs.core.complement.call(null,p),ch);
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.filter_LT_ = (function cljs$core$async$filter_LT_(var_args){
var args17041 = [];
var len__7651__auto___17085 = arguments.length;
var i__7652__auto___17086 = (0);
while(true){
if((i__7652__auto___17086 < len__7651__auto___17085)){
args17041.push((arguments[i__7652__auto___17086]));

var G__17090 = (i__7652__auto___17086 + (1));
i__7652__auto___17086 = G__17090;
continue;
} else {
}
break;
}

var G__17043 = args17041.length;
switch (G__17043) {
case 2:
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args17041.length)].join('')));

}
});

cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.filter_LT_.call(null,p,ch,null);
});

cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3 = (function (p,ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__13923__auto___17095 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13923__auto___17095,out){
return (function (){
var f__13924__auto__ = (function (){var switch__13908__auto__ = ((function (c__13923__auto___17095,out){
return (function (state_17064){
var state_val_17065 = (state_17064[(1)]);
if((state_val_17065 === (7))){
var inst_17060 = (state_17064[(2)]);
var state_17064__$1 = state_17064;
var statearr_17066_17096 = state_17064__$1;
(statearr_17066_17096[(2)] = inst_17060);

(statearr_17066_17096[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17065 === (1))){
var state_17064__$1 = state_17064;
var statearr_17067_17100 = state_17064__$1;
(statearr_17067_17100[(2)] = null);

(statearr_17067_17100[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17065 === (4))){
var inst_17046 = (state_17064[(7)]);
var inst_17046__$1 = (state_17064[(2)]);
var inst_17047 = (inst_17046__$1 == null);
var state_17064__$1 = (function (){var statearr_17068 = state_17064;
(statearr_17068[(7)] = inst_17046__$1);

return statearr_17068;
})();
if(cljs.core.truth_(inst_17047)){
var statearr_17069_17104 = state_17064__$1;
(statearr_17069_17104[(1)] = (5));

} else {
var statearr_17070_17105 = state_17064__$1;
(statearr_17070_17105[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17065 === (6))){
var inst_17046 = (state_17064[(7)]);
var inst_17051 = p.call(null,inst_17046);
var state_17064__$1 = state_17064;
if(cljs.core.truth_(inst_17051)){
var statearr_17071_17106 = state_17064__$1;
(statearr_17071_17106[(1)] = (8));

} else {
var statearr_17072_17107 = state_17064__$1;
(statearr_17072_17107[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17065 === (3))){
var inst_17062 = (state_17064[(2)]);
var state_17064__$1 = state_17064;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_17064__$1,inst_17062);
} else {
if((state_val_17065 === (2))){
var state_17064__$1 = state_17064;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_17064__$1,(4),ch);
} else {
if((state_val_17065 === (11))){
var inst_17054 = (state_17064[(2)]);
var state_17064__$1 = state_17064;
var statearr_17073_17108 = state_17064__$1;
(statearr_17073_17108[(2)] = inst_17054);

(statearr_17073_17108[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17065 === (9))){
var state_17064__$1 = state_17064;
var statearr_17074_17109 = state_17064__$1;
(statearr_17074_17109[(2)] = null);

(statearr_17074_17109[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17065 === (5))){
var inst_17049 = cljs.core.async.close_BANG_.call(null,out);
var state_17064__$1 = state_17064;
var statearr_17075_17110 = state_17064__$1;
(statearr_17075_17110[(2)] = inst_17049);

(statearr_17075_17110[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17065 === (10))){
var inst_17057 = (state_17064[(2)]);
var state_17064__$1 = (function (){var statearr_17076 = state_17064;
(statearr_17076[(8)] = inst_17057);

return statearr_17076;
})();
var statearr_17077_17111 = state_17064__$1;
(statearr_17077_17111[(2)] = null);

(statearr_17077_17111[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17065 === (8))){
var inst_17046 = (state_17064[(7)]);
var state_17064__$1 = state_17064;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_17064__$1,(11),out,inst_17046);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__13923__auto___17095,out))
;
return ((function (switch__13908__auto__,c__13923__auto___17095,out){
return (function() {
var cljs$core$async$state_machine__13909__auto__ = null;
var cljs$core$async$state_machine__13909__auto____0 = (function (){
var statearr_17081 = [null,null,null,null,null,null,null,null,null];
(statearr_17081[(0)] = cljs$core$async$state_machine__13909__auto__);

(statearr_17081[(1)] = (1));

return statearr_17081;
});
var cljs$core$async$state_machine__13909__auto____1 = (function (state_17064){
while(true){
var ret_value__13910__auto__ = (function (){try{while(true){
var result__13911__auto__ = switch__13908__auto__.call(null,state_17064);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13911__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13911__auto__;
}
break;
}
}catch (e17082){if((e17082 instanceof Object)){
var ex__13912__auto__ = e17082;
var statearr_17083_17112 = state_17064;
(statearr_17083_17112[(5)] = ex__13912__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_17064);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e17082;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13910__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__17113 = state_17064;
state_17064 = G__17113;
continue;
} else {
return ret_value__13910__auto__;
}
break;
}
});
cljs$core$async$state_machine__13909__auto__ = function(state_17064){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__13909__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__13909__auto____1.call(this,state_17064);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__13909__auto____0;
cljs$core$async$state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__13909__auto____1;
return cljs$core$async$state_machine__13909__auto__;
})()
;})(switch__13908__auto__,c__13923__auto___17095,out))
})();
var state__13925__auto__ = (function (){var statearr_17084 = f__13924__auto__.call(null);
(statearr_17084[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13923__auto___17095);

return statearr_17084;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13925__auto__);
});})(c__13923__auto___17095,out))
);


return out;
});

cljs.core.async.filter_LT_.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.remove_LT_ = (function cljs$core$async$remove_LT_(var_args){
var args17114 = [];
var len__7651__auto___17119 = arguments.length;
var i__7652__auto___17120 = (0);
while(true){
if((i__7652__auto___17120 < len__7651__auto___17119)){
args17114.push((arguments[i__7652__auto___17120]));

var G__17121 = (i__7652__auto___17120 + (1));
i__7652__auto___17120 = G__17121;
continue;
} else {
}
break;
}

var G__17117 = args17114.length;
switch (G__17117) {
case 2:
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args17114.length)].join('')));

}
});

cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.remove_LT_.call(null,p,ch,null);
});

cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3 = (function (p,ch,buf_or_n){
return cljs.core.async.filter_LT_.call(null,cljs.core.complement.call(null,p),ch,buf_or_n);
});

cljs.core.async.remove_LT_.cljs$lang$maxFixedArity = 3;

cljs.core.async.mapcat_STAR_ = (function cljs$core$async$mapcat_STAR_(f,in$,out){
var c__13923__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13923__auto__){
return (function (){
var f__13924__auto__ = (function (){var switch__13908__auto__ = ((function (c__13923__auto__){
return (function (state_17309){
var state_val_17310 = (state_17309[(1)]);
if((state_val_17310 === (7))){
var inst_17305 = (state_17309[(2)]);
var state_17309__$1 = state_17309;
var statearr_17313_17396 = state_17309__$1;
(statearr_17313_17396[(2)] = inst_17305);

(statearr_17313_17396[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17310 === (20))){
var inst_17275 = (state_17309[(7)]);
var inst_17286 = (state_17309[(2)]);
var inst_17287 = cljs.core.next.call(null,inst_17275);
var inst_17256 = inst_17287;
var inst_17257 = null;
var inst_17258 = (0);
var inst_17259 = (0);
var state_17309__$1 = (function (){var statearr_17314 = state_17309;
(statearr_17314[(8)] = inst_17259);

(statearr_17314[(9)] = inst_17258);

(statearr_17314[(10)] = inst_17256);

(statearr_17314[(11)] = inst_17286);

(statearr_17314[(12)] = inst_17257);

return statearr_17314;
})();
var statearr_17315_17400 = state_17309__$1;
(statearr_17315_17400[(2)] = null);

(statearr_17315_17400[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17310 === (1))){
var state_17309__$1 = state_17309;
var statearr_17316_17401 = state_17309__$1;
(statearr_17316_17401[(2)] = null);

(statearr_17316_17401[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17310 === (4))){
var inst_17243 = (state_17309[(13)]);
var inst_17243__$1 = (state_17309[(2)]);
var inst_17244 = (inst_17243__$1 == null);
var state_17309__$1 = (function (){var statearr_17317 = state_17309;
(statearr_17317[(13)] = inst_17243__$1);

return statearr_17317;
})();
if(cljs.core.truth_(inst_17244)){
var statearr_17318_17402 = state_17309__$1;
(statearr_17318_17402[(1)] = (5));

} else {
var statearr_17319_17403 = state_17309__$1;
(statearr_17319_17403[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17310 === (15))){
var state_17309__$1 = state_17309;
var statearr_17323_17404 = state_17309__$1;
(statearr_17323_17404[(2)] = null);

(statearr_17323_17404[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17310 === (21))){
var state_17309__$1 = state_17309;
var statearr_17324_17405 = state_17309__$1;
(statearr_17324_17405[(2)] = null);

(statearr_17324_17405[(1)] = (23));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17310 === (13))){
var inst_17259 = (state_17309[(8)]);
var inst_17258 = (state_17309[(9)]);
var inst_17256 = (state_17309[(10)]);
var inst_17257 = (state_17309[(12)]);
var inst_17271 = (state_17309[(2)]);
var inst_17272 = (inst_17259 + (1));
var tmp17320 = inst_17258;
var tmp17321 = inst_17256;
var tmp17322 = inst_17257;
var inst_17256__$1 = tmp17321;
var inst_17257__$1 = tmp17322;
var inst_17258__$1 = tmp17320;
var inst_17259__$1 = inst_17272;
var state_17309__$1 = (function (){var statearr_17325 = state_17309;
(statearr_17325[(14)] = inst_17271);

(statearr_17325[(8)] = inst_17259__$1);

(statearr_17325[(9)] = inst_17258__$1);

(statearr_17325[(10)] = inst_17256__$1);

(statearr_17325[(12)] = inst_17257__$1);

return statearr_17325;
})();
var statearr_17326_17406 = state_17309__$1;
(statearr_17326_17406[(2)] = null);

(statearr_17326_17406[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17310 === (22))){
var state_17309__$1 = state_17309;
var statearr_17327_17407 = state_17309__$1;
(statearr_17327_17407[(2)] = null);

(statearr_17327_17407[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17310 === (6))){
var inst_17243 = (state_17309[(13)]);
var inst_17254 = f.call(null,inst_17243);
var inst_17255 = cljs.core.seq.call(null,inst_17254);
var inst_17256 = inst_17255;
var inst_17257 = null;
var inst_17258 = (0);
var inst_17259 = (0);
var state_17309__$1 = (function (){var statearr_17328 = state_17309;
(statearr_17328[(8)] = inst_17259);

(statearr_17328[(9)] = inst_17258);

(statearr_17328[(10)] = inst_17256);

(statearr_17328[(12)] = inst_17257);

return statearr_17328;
})();
var statearr_17329_17408 = state_17309__$1;
(statearr_17329_17408[(2)] = null);

(statearr_17329_17408[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17310 === (17))){
var inst_17275 = (state_17309[(7)]);
var inst_17279 = cljs.core.chunk_first.call(null,inst_17275);
var inst_17280 = cljs.core.chunk_rest.call(null,inst_17275);
var inst_17281 = cljs.core.count.call(null,inst_17279);
var inst_17256 = inst_17280;
var inst_17257 = inst_17279;
var inst_17258 = inst_17281;
var inst_17259 = (0);
var state_17309__$1 = (function (){var statearr_17330 = state_17309;
(statearr_17330[(8)] = inst_17259);

(statearr_17330[(9)] = inst_17258);

(statearr_17330[(10)] = inst_17256);

(statearr_17330[(12)] = inst_17257);

return statearr_17330;
})();
var statearr_17334_17418 = state_17309__$1;
(statearr_17334_17418[(2)] = null);

(statearr_17334_17418[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17310 === (3))){
var inst_17307 = (state_17309[(2)]);
var state_17309__$1 = state_17309;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_17309__$1,inst_17307);
} else {
if((state_val_17310 === (12))){
var inst_17295 = (state_17309[(2)]);
var state_17309__$1 = state_17309;
var statearr_17347_17419 = state_17309__$1;
(statearr_17347_17419[(2)] = inst_17295);

(statearr_17347_17419[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17310 === (2))){
var state_17309__$1 = state_17309;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_17309__$1,(4),in$);
} else {
if((state_val_17310 === (23))){
var inst_17303 = (state_17309[(2)]);
var state_17309__$1 = state_17309;
var statearr_17366_17420 = state_17309__$1;
(statearr_17366_17420[(2)] = inst_17303);

(statearr_17366_17420[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17310 === (19))){
var inst_17290 = (state_17309[(2)]);
var state_17309__$1 = state_17309;
var statearr_17367_17421 = state_17309__$1;
(statearr_17367_17421[(2)] = inst_17290);

(statearr_17367_17421[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17310 === (11))){
var inst_17256 = (state_17309[(10)]);
var inst_17275 = (state_17309[(7)]);
var inst_17275__$1 = cljs.core.seq.call(null,inst_17256);
var state_17309__$1 = (function (){var statearr_17368 = state_17309;
(statearr_17368[(7)] = inst_17275__$1);

return statearr_17368;
})();
if(inst_17275__$1){
var statearr_17369_17425 = state_17309__$1;
(statearr_17369_17425[(1)] = (14));

} else {
var statearr_17370_17426 = state_17309__$1;
(statearr_17370_17426[(1)] = (15));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17310 === (9))){
var inst_17297 = (state_17309[(2)]);
var inst_17298 = cljs.core.async.impl.protocols.closed_QMARK_.call(null,out);
var state_17309__$1 = (function (){var statearr_17377 = state_17309;
(statearr_17377[(15)] = inst_17297);

return statearr_17377;
})();
if(cljs.core.truth_(inst_17298)){
var statearr_17378_17430 = state_17309__$1;
(statearr_17378_17430[(1)] = (21));

} else {
var statearr_17379_17431 = state_17309__$1;
(statearr_17379_17431[(1)] = (22));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17310 === (5))){
var inst_17246 = cljs.core.async.close_BANG_.call(null,out);
var state_17309__$1 = state_17309;
var statearr_17383_17432 = state_17309__$1;
(statearr_17383_17432[(2)] = inst_17246);

(statearr_17383_17432[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17310 === (14))){
var inst_17275 = (state_17309[(7)]);
var inst_17277 = cljs.core.chunked_seq_QMARK_.call(null,inst_17275);
var state_17309__$1 = state_17309;
if(inst_17277){
var statearr_17384_17433 = state_17309__$1;
(statearr_17384_17433[(1)] = (17));

} else {
var statearr_17385_17434 = state_17309__$1;
(statearr_17385_17434[(1)] = (18));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17310 === (16))){
var inst_17293 = (state_17309[(2)]);
var state_17309__$1 = state_17309;
var statearr_17386_17435 = state_17309__$1;
(statearr_17386_17435[(2)] = inst_17293);

(statearr_17386_17435[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17310 === (10))){
var inst_17259 = (state_17309[(8)]);
var inst_17257 = (state_17309[(12)]);
var inst_17269 = cljs.core._nth.call(null,inst_17257,inst_17259);
var state_17309__$1 = state_17309;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_17309__$1,(13),out,inst_17269);
} else {
if((state_val_17310 === (18))){
var inst_17275 = (state_17309[(7)]);
var inst_17284 = cljs.core.first.call(null,inst_17275);
var state_17309__$1 = state_17309;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_17309__$1,(20),out,inst_17284);
} else {
if((state_val_17310 === (8))){
var inst_17259 = (state_17309[(8)]);
var inst_17258 = (state_17309[(9)]);
var inst_17266 = (inst_17259 < inst_17258);
var inst_17267 = inst_17266;
var state_17309__$1 = state_17309;
if(cljs.core.truth_(inst_17267)){
var statearr_17387_17436 = state_17309__$1;
(statearr_17387_17436[(1)] = (10));

} else {
var statearr_17388_17437 = state_17309__$1;
(statearr_17388_17437[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__13923__auto__))
;
return ((function (switch__13908__auto__,c__13923__auto__){
return (function() {
var cljs$core$async$mapcat_STAR__$_state_machine__13909__auto__ = null;
var cljs$core$async$mapcat_STAR__$_state_machine__13909__auto____0 = (function (){
var statearr_17392 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_17392[(0)] = cljs$core$async$mapcat_STAR__$_state_machine__13909__auto__);

(statearr_17392[(1)] = (1));

return statearr_17392;
});
var cljs$core$async$mapcat_STAR__$_state_machine__13909__auto____1 = (function (state_17309){
while(true){
var ret_value__13910__auto__ = (function (){try{while(true){
var result__13911__auto__ = switch__13908__auto__.call(null,state_17309);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13911__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13911__auto__;
}
break;
}
}catch (e17393){if((e17393 instanceof Object)){
var ex__13912__auto__ = e17393;
var statearr_17394_17438 = state_17309;
(statearr_17394_17438[(5)] = ex__13912__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_17309);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e17393;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13910__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__17439 = state_17309;
state_17309 = G__17439;
continue;
} else {
return ret_value__13910__auto__;
}
break;
}
});
cljs$core$async$mapcat_STAR__$_state_machine__13909__auto__ = function(state_17309){
switch(arguments.length){
case 0:
return cljs$core$async$mapcat_STAR__$_state_machine__13909__auto____0.call(this);
case 1:
return cljs$core$async$mapcat_STAR__$_state_machine__13909__auto____1.call(this,state_17309);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mapcat_STAR__$_state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mapcat_STAR__$_state_machine__13909__auto____0;
cljs$core$async$mapcat_STAR__$_state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mapcat_STAR__$_state_machine__13909__auto____1;
return cljs$core$async$mapcat_STAR__$_state_machine__13909__auto__;
})()
;})(switch__13908__auto__,c__13923__auto__))
})();
var state__13925__auto__ = (function (){var statearr_17395 = f__13924__auto__.call(null);
(statearr_17395[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13923__auto__);

return statearr_17395;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13925__auto__);
});})(c__13923__auto__))
);

return c__13923__auto__;
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.mapcat_LT_ = (function cljs$core$async$mapcat_LT_(var_args){
var args17440 = [];
var len__7651__auto___17443 = arguments.length;
var i__7652__auto___17444 = (0);
while(true){
if((i__7652__auto___17444 < len__7651__auto___17443)){
args17440.push((arguments[i__7652__auto___17444]));

var G__17445 = (i__7652__auto___17444 + (1));
i__7652__auto___17444 = G__17445;
continue;
} else {
}
break;
}

var G__17442 = args17440.length;
switch (G__17442) {
case 2:
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args17440.length)].join('')));

}
});

cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$2 = (function (f,in$){
return cljs.core.async.mapcat_LT_.call(null,f,in$,null);
});

cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3 = (function (f,in$,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
cljs.core.async.mapcat_STAR_.call(null,f,in$,out);

return out;
});

cljs.core.async.mapcat_LT_.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.mapcat_GT_ = (function cljs$core$async$mapcat_GT_(var_args){
var args17447 = [];
var len__7651__auto___17450 = arguments.length;
var i__7652__auto___17451 = (0);
while(true){
if((i__7652__auto___17451 < len__7651__auto___17450)){
args17447.push((arguments[i__7652__auto___17451]));

var G__17452 = (i__7652__auto___17451 + (1));
i__7652__auto___17451 = G__17452;
continue;
} else {
}
break;
}

var G__17449 = args17447.length;
switch (G__17449) {
case 2:
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args17447.length)].join('')));

}
});

cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$2 = (function (f,out){
return cljs.core.async.mapcat_GT_.call(null,f,out,null);
});

cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3 = (function (f,out,buf_or_n){
var in$ = cljs.core.async.chan.call(null,buf_or_n);
cljs.core.async.mapcat_STAR_.call(null,f,in$,out);

return in$;
});

cljs.core.async.mapcat_GT_.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.unique = (function cljs$core$async$unique(var_args){
var args17454 = [];
var len__7651__auto___17514 = arguments.length;
var i__7652__auto___17516 = (0);
while(true){
if((i__7652__auto___17516 < len__7651__auto___17514)){
args17454.push((arguments[i__7652__auto___17516]));

var G__17517 = (i__7652__auto___17516 + (1));
i__7652__auto___17516 = G__17517;
continue;
} else {
}
break;
}

var G__17456 = args17454.length;
switch (G__17456) {
case 1:
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args17454.length)].join('')));

}
});

cljs.core.async.unique.cljs$core$IFn$_invoke$arity$1 = (function (ch){
return cljs.core.async.unique.call(null,ch,null);
});

cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2 = (function (ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__13923__auto___17519 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13923__auto___17519,out){
return (function (){
var f__13924__auto__ = (function (){var switch__13908__auto__ = ((function (c__13923__auto___17519,out){
return (function (state_17480){
var state_val_17481 = (state_17480[(1)]);
if((state_val_17481 === (7))){
var inst_17475 = (state_17480[(2)]);
var state_17480__$1 = state_17480;
var statearr_17482_17520 = state_17480__$1;
(statearr_17482_17520[(2)] = inst_17475);

(statearr_17482_17520[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17481 === (1))){
var inst_17457 = null;
var state_17480__$1 = (function (){var statearr_17483 = state_17480;
(statearr_17483[(7)] = inst_17457);

return statearr_17483;
})();
var statearr_17484_17521 = state_17480__$1;
(statearr_17484_17521[(2)] = null);

(statearr_17484_17521[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17481 === (4))){
var inst_17460 = (state_17480[(8)]);
var inst_17460__$1 = (state_17480[(2)]);
var inst_17461 = (inst_17460__$1 == null);
var inst_17462 = cljs.core.not.call(null,inst_17461);
var state_17480__$1 = (function (){var statearr_17485 = state_17480;
(statearr_17485[(8)] = inst_17460__$1);

return statearr_17485;
})();
if(inst_17462){
var statearr_17486_17522 = state_17480__$1;
(statearr_17486_17522[(1)] = (5));

} else {
var statearr_17487_17523 = state_17480__$1;
(statearr_17487_17523[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17481 === (6))){
var state_17480__$1 = state_17480;
var statearr_17488_17524 = state_17480__$1;
(statearr_17488_17524[(2)] = null);

(statearr_17488_17524[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17481 === (3))){
var inst_17477 = (state_17480[(2)]);
var inst_17478 = cljs.core.async.close_BANG_.call(null,out);
var state_17480__$1 = (function (){var statearr_17490 = state_17480;
(statearr_17490[(9)] = inst_17477);

return statearr_17490;
})();
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_17480__$1,inst_17478);
} else {
if((state_val_17481 === (2))){
var state_17480__$1 = state_17480;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_17480__$1,(4),ch);
} else {
if((state_val_17481 === (11))){
var inst_17460 = (state_17480[(8)]);
var inst_17469 = (state_17480[(2)]);
var inst_17457 = inst_17460;
var state_17480__$1 = (function (){var statearr_17492 = state_17480;
(statearr_17492[(10)] = inst_17469);

(statearr_17492[(7)] = inst_17457);

return statearr_17492;
})();
var statearr_17494_17525 = state_17480__$1;
(statearr_17494_17525[(2)] = null);

(statearr_17494_17525[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17481 === (9))){
var inst_17460 = (state_17480[(8)]);
var state_17480__$1 = state_17480;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_17480__$1,(11),out,inst_17460);
} else {
if((state_val_17481 === (5))){
var inst_17457 = (state_17480[(7)]);
var inst_17460 = (state_17480[(8)]);
var inst_17464 = cljs.core._EQ_.call(null,inst_17460,inst_17457);
var state_17480__$1 = state_17480;
if(inst_17464){
var statearr_17496_17526 = state_17480__$1;
(statearr_17496_17526[(1)] = (8));

} else {
var statearr_17497_17527 = state_17480__$1;
(statearr_17497_17527[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17481 === (10))){
var inst_17472 = (state_17480[(2)]);
var state_17480__$1 = state_17480;
var statearr_17498_17528 = state_17480__$1;
(statearr_17498_17528[(2)] = inst_17472);

(statearr_17498_17528[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17481 === (8))){
var inst_17457 = (state_17480[(7)]);
var tmp17495 = inst_17457;
var inst_17457__$1 = tmp17495;
var state_17480__$1 = (function (){var statearr_17499 = state_17480;
(statearr_17499[(7)] = inst_17457__$1);

return statearr_17499;
})();
var statearr_17500_17529 = state_17480__$1;
(statearr_17500_17529[(2)] = null);

(statearr_17500_17529[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__13923__auto___17519,out))
;
return ((function (switch__13908__auto__,c__13923__auto___17519,out){
return (function() {
var cljs$core$async$state_machine__13909__auto__ = null;
var cljs$core$async$state_machine__13909__auto____0 = (function (){
var statearr_17508 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_17508[(0)] = cljs$core$async$state_machine__13909__auto__);

(statearr_17508[(1)] = (1));

return statearr_17508;
});
var cljs$core$async$state_machine__13909__auto____1 = (function (state_17480){
while(true){
var ret_value__13910__auto__ = (function (){try{while(true){
var result__13911__auto__ = switch__13908__auto__.call(null,state_17480);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13911__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13911__auto__;
}
break;
}
}catch (e17509){if((e17509 instanceof Object)){
var ex__13912__auto__ = e17509;
var statearr_17510_17530 = state_17480;
(statearr_17510_17530[(5)] = ex__13912__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_17480);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e17509;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13910__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__17531 = state_17480;
state_17480 = G__17531;
continue;
} else {
return ret_value__13910__auto__;
}
break;
}
});
cljs$core$async$state_machine__13909__auto__ = function(state_17480){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__13909__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__13909__auto____1.call(this,state_17480);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__13909__auto____0;
cljs$core$async$state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__13909__auto____1;
return cljs$core$async$state_machine__13909__auto__;
})()
;})(switch__13908__auto__,c__13923__auto___17519,out))
})();
var state__13925__auto__ = (function (){var statearr_17511 = f__13924__auto__.call(null);
(statearr_17511[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13923__auto___17519);

return statearr_17511;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13925__auto__);
});})(c__13923__auto___17519,out))
);


return out;
});

cljs.core.async.unique.cljs$lang$maxFixedArity = 2;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.partition = (function cljs$core$async$partition(var_args){
var args17532 = [];
var len__7651__auto___17602 = arguments.length;
var i__7652__auto___17603 = (0);
while(true){
if((i__7652__auto___17603 < len__7651__auto___17602)){
args17532.push((arguments[i__7652__auto___17603]));

var G__17604 = (i__7652__auto___17603 + (1));
i__7652__auto___17603 = G__17604;
continue;
} else {
}
break;
}

var G__17534 = args17532.length;
switch (G__17534) {
case 2:
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args17532.length)].join('')));

}
});

cljs.core.async.partition.cljs$core$IFn$_invoke$arity$2 = (function (n,ch){
return cljs.core.async.partition.call(null,n,ch,null);
});

cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3 = (function (n,ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__13923__auto___17606 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13923__auto___17606,out){
return (function (){
var f__13924__auto__ = (function (){var switch__13908__auto__ = ((function (c__13923__auto___17606,out){
return (function (state_17572){
var state_val_17573 = (state_17572[(1)]);
if((state_val_17573 === (7))){
var inst_17568 = (state_17572[(2)]);
var state_17572__$1 = state_17572;
var statearr_17574_17607 = state_17572__$1;
(statearr_17574_17607[(2)] = inst_17568);

(statearr_17574_17607[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17573 === (1))){
var inst_17535 = (new Array(n));
var inst_17536 = inst_17535;
var inst_17537 = (0);
var state_17572__$1 = (function (){var statearr_17575 = state_17572;
(statearr_17575[(7)] = inst_17536);

(statearr_17575[(8)] = inst_17537);

return statearr_17575;
})();
var statearr_17576_17608 = state_17572__$1;
(statearr_17576_17608[(2)] = null);

(statearr_17576_17608[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17573 === (4))){
var inst_17540 = (state_17572[(9)]);
var inst_17540__$1 = (state_17572[(2)]);
var inst_17541 = (inst_17540__$1 == null);
var inst_17542 = cljs.core.not.call(null,inst_17541);
var state_17572__$1 = (function (){var statearr_17577 = state_17572;
(statearr_17577[(9)] = inst_17540__$1);

return statearr_17577;
})();
if(inst_17542){
var statearr_17578_17613 = state_17572__$1;
(statearr_17578_17613[(1)] = (5));

} else {
var statearr_17579_17614 = state_17572__$1;
(statearr_17579_17614[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17573 === (15))){
var inst_17562 = (state_17572[(2)]);
var state_17572__$1 = state_17572;
var statearr_17580_17618 = state_17572__$1;
(statearr_17580_17618[(2)] = inst_17562);

(statearr_17580_17618[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17573 === (13))){
var state_17572__$1 = state_17572;
var statearr_17581_17619 = state_17572__$1;
(statearr_17581_17619[(2)] = null);

(statearr_17581_17619[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17573 === (6))){
var inst_17537 = (state_17572[(8)]);
var inst_17558 = (inst_17537 > (0));
var state_17572__$1 = state_17572;
if(cljs.core.truth_(inst_17558)){
var statearr_17582_17620 = state_17572__$1;
(statearr_17582_17620[(1)] = (12));

} else {
var statearr_17583_17621 = state_17572__$1;
(statearr_17583_17621[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17573 === (3))){
var inst_17570 = (state_17572[(2)]);
var state_17572__$1 = state_17572;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_17572__$1,inst_17570);
} else {
if((state_val_17573 === (12))){
var inst_17536 = (state_17572[(7)]);
var inst_17560 = cljs.core.vec.call(null,inst_17536);
var state_17572__$1 = state_17572;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_17572__$1,(15),out,inst_17560);
} else {
if((state_val_17573 === (2))){
var state_17572__$1 = state_17572;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_17572__$1,(4),ch);
} else {
if((state_val_17573 === (11))){
var inst_17552 = (state_17572[(2)]);
var inst_17553 = (new Array(n));
var inst_17536 = inst_17553;
var inst_17537 = (0);
var state_17572__$1 = (function (){var statearr_17584 = state_17572;
(statearr_17584[(10)] = inst_17552);

(statearr_17584[(7)] = inst_17536);

(statearr_17584[(8)] = inst_17537);

return statearr_17584;
})();
var statearr_17585_17622 = state_17572__$1;
(statearr_17585_17622[(2)] = null);

(statearr_17585_17622[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17573 === (9))){
var inst_17536 = (state_17572[(7)]);
var inst_17550 = cljs.core.vec.call(null,inst_17536);
var state_17572__$1 = state_17572;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_17572__$1,(11),out,inst_17550);
} else {
if((state_val_17573 === (5))){
var inst_17540 = (state_17572[(9)]);
var inst_17545 = (state_17572[(11)]);
var inst_17536 = (state_17572[(7)]);
var inst_17537 = (state_17572[(8)]);
var inst_17544 = (inst_17536[inst_17537] = inst_17540);
var inst_17545__$1 = (inst_17537 + (1));
var inst_17546 = (inst_17545__$1 < n);
var state_17572__$1 = (function (){var statearr_17586 = state_17572;
(statearr_17586[(11)] = inst_17545__$1);

(statearr_17586[(12)] = inst_17544);

return statearr_17586;
})();
if(cljs.core.truth_(inst_17546)){
var statearr_17587_17630 = state_17572__$1;
(statearr_17587_17630[(1)] = (8));

} else {
var statearr_17588_17631 = state_17572__$1;
(statearr_17588_17631[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17573 === (14))){
var inst_17565 = (state_17572[(2)]);
var inst_17566 = cljs.core.async.close_BANG_.call(null,out);
var state_17572__$1 = (function (){var statearr_17590 = state_17572;
(statearr_17590[(13)] = inst_17565);

return statearr_17590;
})();
var statearr_17591_17632 = state_17572__$1;
(statearr_17591_17632[(2)] = inst_17566);

(statearr_17591_17632[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17573 === (10))){
var inst_17556 = (state_17572[(2)]);
var state_17572__$1 = state_17572;
var statearr_17592_17633 = state_17572__$1;
(statearr_17592_17633[(2)] = inst_17556);

(statearr_17592_17633[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17573 === (8))){
var inst_17545 = (state_17572[(11)]);
var inst_17536 = (state_17572[(7)]);
var tmp17589 = inst_17536;
var inst_17536__$1 = tmp17589;
var inst_17537 = inst_17545;
var state_17572__$1 = (function (){var statearr_17593 = state_17572;
(statearr_17593[(7)] = inst_17536__$1);

(statearr_17593[(8)] = inst_17537);

return statearr_17593;
})();
var statearr_17594_17634 = state_17572__$1;
(statearr_17594_17634[(2)] = null);

(statearr_17594_17634[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__13923__auto___17606,out))
;
return ((function (switch__13908__auto__,c__13923__auto___17606,out){
return (function() {
var cljs$core$async$state_machine__13909__auto__ = null;
var cljs$core$async$state_machine__13909__auto____0 = (function (){
var statearr_17598 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_17598[(0)] = cljs$core$async$state_machine__13909__auto__);

(statearr_17598[(1)] = (1));

return statearr_17598;
});
var cljs$core$async$state_machine__13909__auto____1 = (function (state_17572){
while(true){
var ret_value__13910__auto__ = (function (){try{while(true){
var result__13911__auto__ = switch__13908__auto__.call(null,state_17572);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13911__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13911__auto__;
}
break;
}
}catch (e17599){if((e17599 instanceof Object)){
var ex__13912__auto__ = e17599;
var statearr_17600_17643 = state_17572;
(statearr_17600_17643[(5)] = ex__13912__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_17572);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e17599;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13910__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__17644 = state_17572;
state_17572 = G__17644;
continue;
} else {
return ret_value__13910__auto__;
}
break;
}
});
cljs$core$async$state_machine__13909__auto__ = function(state_17572){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__13909__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__13909__auto____1.call(this,state_17572);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__13909__auto____0;
cljs$core$async$state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__13909__auto____1;
return cljs$core$async$state_machine__13909__auto__;
})()
;})(switch__13908__auto__,c__13923__auto___17606,out))
})();
var state__13925__auto__ = (function (){var statearr_17601 = f__13924__auto__.call(null);
(statearr_17601[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13923__auto___17606);

return statearr_17601;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13925__auto__);
});})(c__13923__auto___17606,out))
);


return out;
});

cljs.core.async.partition.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.partition_by = (function cljs$core$async$partition_by(var_args){
var args17645 = [];
var len__7651__auto___17719 = arguments.length;
var i__7652__auto___17720 = (0);
while(true){
if((i__7652__auto___17720 < len__7651__auto___17719)){
args17645.push((arguments[i__7652__auto___17720]));

var G__17721 = (i__7652__auto___17720 + (1));
i__7652__auto___17720 = G__17721;
continue;
} else {
}
break;
}

var G__17647 = args17645.length;
switch (G__17647) {
case 2:
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args17645.length)].join('')));

}
});

cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$2 = (function (f,ch){
return cljs.core.async.partition_by.call(null,f,ch,null);
});

cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3 = (function (f,ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__13923__auto___17723 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13923__auto___17723,out){
return (function (){
var f__13924__auto__ = (function (){var switch__13908__auto__ = ((function (c__13923__auto___17723,out){
return (function (state_17689){
var state_val_17690 = (state_17689[(1)]);
if((state_val_17690 === (7))){
var inst_17685 = (state_17689[(2)]);
var state_17689__$1 = state_17689;
var statearr_17691_17724 = state_17689__$1;
(statearr_17691_17724[(2)] = inst_17685);

(statearr_17691_17724[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17690 === (1))){
var inst_17648 = [];
var inst_17649 = inst_17648;
var inst_17650 = new cljs.core.Keyword("cljs.core.async","nothing","cljs.core.async/nothing",-69252123);
var state_17689__$1 = (function (){var statearr_17692 = state_17689;
(statearr_17692[(7)] = inst_17650);

(statearr_17692[(8)] = inst_17649);

return statearr_17692;
})();
var statearr_17693_17725 = state_17689__$1;
(statearr_17693_17725[(2)] = null);

(statearr_17693_17725[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17690 === (4))){
var inst_17653 = (state_17689[(9)]);
var inst_17653__$1 = (state_17689[(2)]);
var inst_17654 = (inst_17653__$1 == null);
var inst_17655 = cljs.core.not.call(null,inst_17654);
var state_17689__$1 = (function (){var statearr_17694 = state_17689;
(statearr_17694[(9)] = inst_17653__$1);

return statearr_17694;
})();
if(inst_17655){
var statearr_17695_17728 = state_17689__$1;
(statearr_17695_17728[(1)] = (5));

} else {
var statearr_17696_17732 = state_17689__$1;
(statearr_17696_17732[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17690 === (15))){
var inst_17679 = (state_17689[(2)]);
var state_17689__$1 = state_17689;
var statearr_17697_17733 = state_17689__$1;
(statearr_17697_17733[(2)] = inst_17679);

(statearr_17697_17733[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17690 === (13))){
var state_17689__$1 = state_17689;
var statearr_17698_17734 = state_17689__$1;
(statearr_17698_17734[(2)] = null);

(statearr_17698_17734[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17690 === (6))){
var inst_17649 = (state_17689[(8)]);
var inst_17674 = inst_17649.length;
var inst_17675 = (inst_17674 > (0));
var state_17689__$1 = state_17689;
if(cljs.core.truth_(inst_17675)){
var statearr_17699_17739 = state_17689__$1;
(statearr_17699_17739[(1)] = (12));

} else {
var statearr_17700_17740 = state_17689__$1;
(statearr_17700_17740[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17690 === (3))){
var inst_17687 = (state_17689[(2)]);
var state_17689__$1 = state_17689;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_17689__$1,inst_17687);
} else {
if((state_val_17690 === (12))){
var inst_17649 = (state_17689[(8)]);
var inst_17677 = cljs.core.vec.call(null,inst_17649);
var state_17689__$1 = state_17689;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_17689__$1,(15),out,inst_17677);
} else {
if((state_val_17690 === (2))){
var state_17689__$1 = state_17689;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_17689__$1,(4),ch);
} else {
if((state_val_17690 === (11))){
var inst_17653 = (state_17689[(9)]);
var inst_17657 = (state_17689[(10)]);
var inst_17667 = (state_17689[(2)]);
var inst_17668 = [];
var inst_17669 = inst_17668.push(inst_17653);
var inst_17649 = inst_17668;
var inst_17650 = inst_17657;
var state_17689__$1 = (function (){var statearr_17701 = state_17689;
(statearr_17701[(11)] = inst_17667);

(statearr_17701[(7)] = inst_17650);

(statearr_17701[(8)] = inst_17649);

(statearr_17701[(12)] = inst_17669);

return statearr_17701;
})();
var statearr_17702_17765 = state_17689__$1;
(statearr_17702_17765[(2)] = null);

(statearr_17702_17765[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17690 === (9))){
var inst_17649 = (state_17689[(8)]);
var inst_17665 = cljs.core.vec.call(null,inst_17649);
var state_17689__$1 = state_17689;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_17689__$1,(11),out,inst_17665);
} else {
if((state_val_17690 === (5))){
var inst_17653 = (state_17689[(9)]);
var inst_17650 = (state_17689[(7)]);
var inst_17657 = (state_17689[(10)]);
var inst_17657__$1 = f.call(null,inst_17653);
var inst_17658 = cljs.core._EQ_.call(null,inst_17657__$1,inst_17650);
var inst_17659 = cljs.core.keyword_identical_QMARK_.call(null,inst_17650,new cljs.core.Keyword("cljs.core.async","nothing","cljs.core.async/nothing",-69252123));
var inst_17660 = (inst_17658) || (inst_17659);
var state_17689__$1 = (function (){var statearr_17703 = state_17689;
(statearr_17703[(10)] = inst_17657__$1);

return statearr_17703;
})();
if(cljs.core.truth_(inst_17660)){
var statearr_17704_17770 = state_17689__$1;
(statearr_17704_17770[(1)] = (8));

} else {
var statearr_17705_17771 = state_17689__$1;
(statearr_17705_17771[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17690 === (14))){
var inst_17682 = (state_17689[(2)]);
var inst_17683 = cljs.core.async.close_BANG_.call(null,out);
var state_17689__$1 = (function (){var statearr_17707 = state_17689;
(statearr_17707[(13)] = inst_17682);

return statearr_17707;
})();
var statearr_17708_17784 = state_17689__$1;
(statearr_17708_17784[(2)] = inst_17683);

(statearr_17708_17784[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17690 === (10))){
var inst_17672 = (state_17689[(2)]);
var state_17689__$1 = state_17689;
var statearr_17709_17797 = state_17689__$1;
(statearr_17709_17797[(2)] = inst_17672);

(statearr_17709_17797[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17690 === (8))){
var inst_17653 = (state_17689[(9)]);
var inst_17657 = (state_17689[(10)]);
var inst_17649 = (state_17689[(8)]);
var inst_17662 = inst_17649.push(inst_17653);
var tmp17706 = inst_17649;
var inst_17649__$1 = tmp17706;
var inst_17650 = inst_17657;
var state_17689__$1 = (function (){var statearr_17710 = state_17689;
(statearr_17710[(7)] = inst_17650);

(statearr_17710[(14)] = inst_17662);

(statearr_17710[(8)] = inst_17649__$1);

return statearr_17710;
})();
var statearr_17711_17798 = state_17689__$1;
(statearr_17711_17798[(2)] = null);

(statearr_17711_17798[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__13923__auto___17723,out))
;
return ((function (switch__13908__auto__,c__13923__auto___17723,out){
return (function() {
var cljs$core$async$state_machine__13909__auto__ = null;
var cljs$core$async$state_machine__13909__auto____0 = (function (){
var statearr_17715 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_17715[(0)] = cljs$core$async$state_machine__13909__auto__);

(statearr_17715[(1)] = (1));

return statearr_17715;
});
var cljs$core$async$state_machine__13909__auto____1 = (function (state_17689){
while(true){
var ret_value__13910__auto__ = (function (){try{while(true){
var result__13911__auto__ = switch__13908__auto__.call(null,state_17689);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13911__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13911__auto__;
}
break;
}
}catch (e17716){if((e17716 instanceof Object)){
var ex__13912__auto__ = e17716;
var statearr_17717_17799 = state_17689;
(statearr_17717_17799[(5)] = ex__13912__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_17689);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e17716;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13910__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__17800 = state_17689;
state_17689 = G__17800;
continue;
} else {
return ret_value__13910__auto__;
}
break;
}
});
cljs$core$async$state_machine__13909__auto__ = function(state_17689){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__13909__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__13909__auto____1.call(this,state_17689);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__13909__auto____0;
cljs$core$async$state_machine__13909__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__13909__auto____1;
return cljs$core$async$state_machine__13909__auto__;
})()
;})(switch__13908__auto__,c__13923__auto___17723,out))
})();
var state__13925__auto__ = (function (){var statearr_17718 = f__13924__auto__.call(null);
(statearr_17718[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13923__auto___17723);

return statearr_17718;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13925__auto__);
});})(c__13923__auto___17723,out))
);


return out;
});

cljs.core.async.partition_by.cljs$lang$maxFixedArity = 3;

